//Copyright (C) 2017 McAfee, Inc.  All rights reserved


// General

var strRange= "Please enter an integer value between %1 and %2.";
var strModified= "You have not applied changes made on this page.\n\nDiscard these changes?" ;
var strContentAlert="Scanning all formats with this option selected can be CPU intensive.\r\nIt is advisable to ensure that the content rules are configured for\r\nspecific formats to minimize this impact.";
var strFindMacroAlert="Enabling this option will treat all macros in the attachment(s) as infected.";
var strRemoveMacroAlert="Enabling this option will remove all macros from the attachment(s).";
var gsInvalidAbsolutePath= 	"Please enter an absolute path in windows format ('<driveletter>:\\...')\r\nor UNC format ('\\\\<server name>\\<shared folder>\\...').";
var gsInvalidRelativePath= 	"Please remove '\\' from the beginning of the relative path.";
var gsInvalidCharsInPath= 	"The characters '\*\"<>|/:?' are not allowed in a file path.";
var gsInvalidFilename= 		"Please enter a valid filename.";
var gsInvalidPath= 		"Invalid file path.";
var gsInvalidPathTooLong= 	"File path too long.";
var gsInvalidFileTooLong=	"File name is too long.";
var gsInvalidCharsInName= 	"The characters '\*\"<>|\\/:?' are not allowed in a filename.";
var gsInvalidEmail= 		"Please enter a valid e-mail address.";
var gsInvalidPassword=		"Please enter your password.";
var gsNone=			"None";
var gsSubPagesModified=		"You will lose unsaved changes if you continue.\n\nAre you sure?" ;
var gsConfigSaveFailed=		"Failed to save configuration. Please refer to the Product Log for more details." ;
var gsDuplicateNotAllowed=  "An entry with this name already exists, please enter a unique name.";
var gsImportDone=			"Block/Allow list import done."
var gsSpecialCharsNotAllowed = "The characters '!@#$%^&*()+=-[]\\\';,./{}|\":<>?' are not allowed in a category name.";

var gsScriptNotAllowed= "Script keyword is not allowed as part of input.";
var gsTagsNotAllowed= "The input contains invalid HTML/XML tags which are not allowed."
var gsSquareBracketsNotAllowed= "The input contains square brackets which are not allowed."
var gsXMLCommentTagsNotAllowed= "XML Comment tags are not allowed as part of input.";
var gsHTMLTagsNotAllowed= "All HTML tags are not allowed as part of input.";
var gsWildCardRequired=  "Please enter wildcard '\*' or '?' along with the word or phrase.";
var gsSaveChanges =			"Click on the 'Save' button before applying the changes.";
var gsDuplicateRule= "An entry with this rule already exists, please enter a unique rule.";
var gsCopyDuplicateRule= "Rules already present in the current policy would be not be copied.";
var gsInvalidNameTooLong =  "Too long. Please enter a name within 100 characters.";
var gsInvalidIPAddress  = "Please enter a valid IP address.";
var gsPasswordmismatch = "The Passwords you typed do not match. Please type the passwords again.";
var gsSelRepository = "Select a Repository to Edit/Delete/MoveUp/MoveDown.";
var gsDelRepository = "Cannot delete repository. Atleast one repository is needed for sitelist to function correctly.";
var gsInvalidADGroup = "Invalid AD group.";

// Page titles
var gsTDashboard ="Dashboard";
var gsTStats="Statistics & Information";
var gsTODScans="On-Demand Scans";
var gsTReports="Graphical Reports";
var gsTDetectedItems="Detected Items";
var gsTSpam="Spam";
var gsTIP="IP Reputation";
var gsTPhish="Phish";
var gsTViruses="Viruses";
var gsTClean="Clean";
var gsTSPOOF = "Spoofed Mails";
var gsTPups="Potentially Unwanted Programs";
var gsTContent="Unwanted Content";
var gsTBannedFile = "Banned File types and Messages";
var gsTURL = "Mail URL Reputation";
var gsTAll="All Items";
var gsTPolicyManager="Policy Manager";
var gsTOnAccess="On-Access";
var gsTOnDemand="On-Demand";
var gsTShared="Shared Resource";
var gsTSettings="Settings & Diagnostics";
var gsTOASettings="On-Access Settings";
var gsTODSettings="On-Demand Settings";
var gsTDISettings="Detected Items";
var gsTUIPeferences="User Interface Preferences";
var gsTDiagnostics="Diagnostics";
var gsSiteList="Site List";
var gsTProductLog="Product Log";
var gsTImportExport="Import and Export Configuration";
var gsTDATSettings="DAT Settings";
var gsTProxySettings="Proxy Settings";
var strKB="KB";
var strMB="MB";
var gsTCompnDLP = "DLP and Compliance"
var gsScoreBasedDict = "Score Based Dictionary"

// Graphical reports
var strSimple		=	"Simple";
var strAdvanced		= 	"Advanced";

// System metrics
var strNoInstances  = "<No Instances>";

// Product Log
var strProductLog	=       "Product Log";

// User Interface Preferences
var strDashboardSettingsTab =  "Dashboard Settings";
var strChartSettingsTab     = "Graph and Chart Settings";

// Diagnostics
var strDebugLoggingTab      = "Debug Logging";
var strErrReportingServTab  = "Error Reporting Service";
var strEventLoggingTab      = "Event Logging";
var strProductLogTab        = "Product Log";

// Export/Import Tab
var strConfigurationTab     = "Configuration";
var strSiteListTab          = "SiteList";

// Site List Tabs
var strRepositoriesTab		= "Repositories";
var strProxyConfigurationTab	= "Proxy Configuration";

// Detected Items
var strNoQuarantinedDataAlt = "This item does not have any quarantined data.";
var strQuarantinedDataAlt = "This item has quarantined data.";
var strAvtQuarantinedDataAlt = "This item has quarantined data and can be submitted to McAfee Labs.";

// Settings and diagnostics
var strOptimDesc        = 	"Although optimization may improve performance and reduce the size of the database, the process is time-consuming and the database is unavailable when the process runs.  We recommend running this operation infrequently, and never during normal working hours.";
var strPurgeDesc        = 	"The database should be regularly purged to delete any quarantined items that are older that the specified limits. During a purge, the database remains operational, although performance may be affected. We recommend that you schedule this operation to occur outside normal working hours.";

//Language Controls for SharedResManager.js and PolActions_CS.js  ( DLP Rules in Multiple Languages)
var LangList=new Array();
    LangList['zh-CN'] = 'Chinese - Simplified';
    LangList['en'] = 'English';
	LangList['fr'] = 'French';
	LangList['de'] = 'German';
    LangList['ja'] = 'Japanese';
	LangList['es'] = 'Spanish';
		
// Calendar controls ##AK 20050428 - modified array structure to suit the localization parse tool.
var strMOnths = new Array();
strMOnths[0] = "January";
strMOnths[1] = "February";
strMOnths[2] = "March";
strMOnths[3] = "April";
strMOnths[4] = "May";
strMOnths[5] = "June";
strMOnths[6] = "July";
strMOnths[7] = "August";
strMOnths[8] = "September";
strMOnths[9] = "October";
strMOnths[10] = "November";
strMOnths[11] = "December";

var strShortMOnths = new Array();
strShortMOnths[0] = "Jan";
strShortMOnths[1] = "Feb";
strShortMOnths[2] = "Mar";
strShortMOnths[3] = "Apr";
strShortMOnths[4] = "May";
strShortMOnths[5] = "Jun";
strShortMOnths[6] = "Jul";
strShortMOnths[7] = "Aug";
strShortMOnths[8] = "Sep";
strShortMOnths[9] = "Oct";
strShortMOnths[10] = "Nov";
strShortMOnths[11] = "Dec";

var strDays = new Array();
strDays["0"] = "Sunday";
strDays["1"] = "Monday";
strDays["2"] = "Tuesday";
strDays["3"] = "Wednesday";
strDays["4"] = "Thursday";
strDays["5"] = "Friday";
strDays["6"] = "Saturday";

var strShortDays = new Array();
strShortDays["0"] = "Sun";
strShortDays["1"] = "Mon";
strShortDays["2"] = "Tue";
strShortDays["3"] = "Wed";
strShortDays["4"] = "Thu";
strShortDays["5"] = "Fri";
strShortDays["6"] = "Sat";

var strStartDate = "Select a start date:";
var strEndDate   = "Select an end date:";

// Names of data types for identity rules
var gDataTypeNames = new Array();
gDataTypeNames["e"] = "SMTP e-mail address";

//Identities Page
gsIdentityPageError = "At least one rule needs to be present.";

// Detection reason
var gsReason = new Array();
gsReason["av"]= "Anti-Virus";
gsReason["content"]= "DLP and Compliance";
gsReason["file"]= "File Filter";
gsReason["spam"]= "Anti-Spam";
gsReason["ip"]= "IP Reputation";
gsReason["ec"]= "Encrypted Or Corrupted";
gsReason["pup"]= "Potentially Unwanted Program";
gsReason["phish"]= "Phish";
gsReason["pa"]= "Packer";
gsReason["mailsize"] = "Mail Size";
gsReason["enc"] = "Encrypted";
gsReason["sig"] = "Signed";
gsReason["cor"] = "Corrupted";
gsReason["dos"] = "Denial of Service";
gsReason["procnt"] = "Protected Content";
gsReason["pwdpro"] = "Password Protected";
gsReason["blockmime"] = "Blocked MIME";
//gsReason["url"] = "URL filtering";
gsReason["url"] = "URL Reputation"; 
gsReason["tie"] = "TIE Reputation";
gsReason["spfsf"] = "SPF Soft Fail";
gsReason["spfhf"] = "SPF Hard Fail";
var gsClean="Clean";

// Reason groups
var gsReasonGroup = new Array();
gsReasonGroup ["gav"]= "Viruses";
gsReasonGroup ["gcontent"]= "Unwanted Content";
gsReasonGroup ["gfile"] = "Banned File types and Messages";
gsReasonGroup ["gspam"]= "Spam";
gsReasonGroup ["gpup"]= "Potentially Unwanted Programs";
gsReasonGroup ["gphish"]= "Phish";
gsReasonGroup ["gcompndlp"]= "DLP and Compliance";
gsReasonGroup ["gip"]= "IP Reputation";
gsReasonGroup ["gurl"]= "Mail URL Reputation";
gsReasonGroup ["gtieatd"] = "TIE and ATD Detections";
gsReasonGroup ["gspoof"] = "Spoofed Mails";

// Record Table
var strDelete 		= "Delete";
var strNoColumns	= "Please select at least one column to display.";
var strNoRows		= "Please select at least one row.";
var strOneRow		= "Please select one row only.";
var strSelectAll 	= "Select All";
var strSelectNone	= "Select None";
var strSearching        = "Searching database. Please wait...";
var strDeleteAll	= "Delete All";
var strDeleteAllWarning = "This will delete %1 record(s). Are you sure?";
var strStartLaterThanEnd = "Please select a start date that is earlier than the end date.";

// Error messages	##AK - 20050428 - declared the Array with () to suit the localization parse tool.
var strErrorMessages = new Array();
strErrorMessages[0x80040227] = "The current query is no longer valid.";
strErrorMessages[0x8004023f] = "The query timed out.";
strErrorMessages[0x8004022b] = "Invalid filter syntax.";
strErrorMessages[0x80040238] = "There are no records to display.";
strErrorMessages[0x8004023c] = "There are no records to display.";
strErrorMessages[0x80041011] = "The file submitted is not a mail message or is incorrectly formatted.";
strErrorMessages[0x80041012] = "Failed to submit sample.";

strErrorMessages[0x80040262] = "The configuration file is not of the correct format.";
strErrorMessages[0x80040263] = "The item does not have any quarantined data.";
strErrorMessages[0x0] 	     = "The operation completed successfully.";
strErrorMessages[0x80004005] = "The operation failed to complete successfully.";
strErrorMessages[0x80042001] = "Invalid or Duplicate Entries.";
var strDefaultError	     = "The operation failed with error %1.";

// Product Log Cols - ##AK - 20050428 - declared the Array with () to suit the localization parse tool.
var gProductLogCols = new Array();
gProductLogCols["id"]		= "ID";
gProductLogCols["lvl"]		= "Level";
gProductLogCols["dsc"]		= "Description";
gProductLogCols["dts"]		= "Date/Time";

// Scheduling
var gsNoStopAfter="Please enter a time of at least one minute.";
var gsNoHour= "Please enter an hour value.";
var gsNoMin= "Please enter a minute value.";
var gsNoYear= "Please enter a year value.";
var gsNoDay= "Please enter a day value.";
var gsOneDay= "Please select at least one day of the week.";
var gsOneMonth= "Please select at least one month of the year.";
var gsRecurrance= "Please enter a recurrence interval.";
var gsInvalidDateTime= "You are trying to schedule a task for a Date/Time which has already expired.\nThis may result in the task not being triggered.";
var gsNoTasks = "No tasks are currently scheduled.";
var gsDefaultTaskName = "Task %1";
var strTrainGroup 	     = "for group:";
var strAllGroups	     = "All Groups";
var gsModify	= "Modify";
var gsDelete = "Delete";
var gsStatus = "Status";
var gsIdle = "Idle";
var gsNA = "N/A";
var gsRunNow = "Run Now";
var gsProgress = "Show Status";
var gsStop = "Stop";
var gsUnmark  = "Undo Delete";
var gsProgressTitle = "Status of %1";
var gsTaskStatuses = new Array();
gsTaskStatuses[0]="Starting";
gsTaskStatuses[1]="Stopped";
gsTaskStatuses[2]="New";
gsTaskStatuses[3]="Running";
gsTaskStatuses[4]="Failed";
gsTaskStatuses[5]="Completed";
gsTaskStatuses[6]="Deleting, please wait...";
gsTaskStatuses[7]="Idle";
gsTaskStatuses[8]="Marked for deletion";
var gsTaskStopped= "The selected task has been stopped successfully.";
var gsStopTaskTimedOut= "The selected task did not respond in a timely fashion. Please try again.";
var gsStopTaskFailed= "Failed to stop the running task.";
var gsTaskStarted= "The selected task has been started successfully.";
var gsStartTaskFailed= "Failed to start the running task. Make sure that McAfee Framework Service is running.";
var gsTaskRunning="The selected task is already running.";
var gsTaskStatusItems = new Array;
gsTaskStatusItems["avd"] = "Anti-virus DAT Version";
gsTaskStatusItems["ave"] = "Anti-virus Engine Version";
var gsNewScanMsg = "Click <span class='bold'>New Scan</span> to schedule a new on-demand scan.";
var gsNewReportMsg = "Click <span class='bold'>New Report</span> to schedule a new Report.";
var gsTaskExists ="A task with that name already exists.";
var gsNoTaskName ="Please enter a task name.";
var gsValidTaskName ="Quotes are not allowed for the Task Name.";
var gsTaskNotSaved = "Please apply or cancel outstanding modifications before running a task.";
var gsTaskGeneral = "General";
var gsTaskSettings = "Settings";
var gsTaskDetections = "Detections";

// Graph Filter Rule Descriptions
var gsRuleDescriptionAdvance = "Advance Rule Filter";
var gsRuleDescription0 = "Top 10 Viruses";
var gsRuleDescription1 = "Top 10 Infected Files";
var gsRuleDescription2 = "Results";
var gsRuleDescription3 = "Scan Source Detections";
var gsRuleDescription4 = "Top 10 Detections";
var gsRuleDescription5 = "Top 10 Spam Detections";
var gsRuleDescription6 = "Top 10 Phish Detections";
var gsRuleDescription7 = "Top 10 Unwanted Programs";
var gsRuleDescription8 = "Top 10 DLP and Compliance Detections";
var gsRuleDescription9 = "Top 10 Spam Recipients";
var gsRuleDescription10 = "Top 10 Virus Recipients";
var gsRuleDescription11 = "Top 10 Virus Senders";
var gsRuleDescription12 = "Top 10 Infected Servers";
var gsRuleDescription13 = "Top 10 Infected Databases";
var gsRuleDescription14 = "Top 10 Blocked IP Addresses";
var gsRuleDescription15 = "Top 10 Blocked URLs";
var gsRuleDescription16 = "Top 10 TIE Detections";
var gsRuleDescription17 = "Top 10 Spoof Detections";

var gsNumDetections 	= "Number of Detections";
var gsHours24			= "Hour (24 hour)";
var gsDayOfWeek			= "Day of the Week";
var gsDayOfMonth		= "Day of the Month";

var gsBadFilter = "At least one filter string must be entered.";

// Strings for the InputList control
var il_st = {};
il_st.gsEdit = "Edit";
il_st.gsDelete = "Delete";
il_st.gsDeleteAll = "Delete All";
il_st.gsImport = "Import";
il_st.gsExport = "Export";
il_st.gsAdd = "Add";
il_st.gsInputListErr = "You must specify at least one value.";
il_st.gsInputListDefName = "Input List";
il_st.gsInputListDefDirective = "[You can use '*' and '?' as wildcard characters to match multiple names]";
il_st.gsDefInputPattern = "Input %1";
il_st.gsDuplicateEntryErr = "Duplicate entries are not permitted.";
il_st.gsHDEnable = "Enable";
il_st.gsHDAddress = "Email Address";
il_st.gsHDAction = "Action";

// Dashboard Tabs
var gsStats = "Statistics";
var gsSystemPerformace = "Performance";
var gsProductInformation = "Product Information";
var gsUpdateInformation = "Update Information";
var gsRecentlyScannedItems = "Recently Scanned Items";
var gsLicenses = "Licenses";

// Dashboard Page
var gsNothingSelected = "No counters selected";
var gsAntiSpamEngine = "Anti-Spam Engine";
var gsSpamVersion = "Rules Version";
var gsDATsOutOfDate="Your Anti-Virus DATs may be out of date.";
var gsStreamingUpdate="Last Anti-Spam Streaming Update";
var gsDATsOK="You have successfully updated your Anti-Virus DATs in the past three days.";
var gsDetected="Detected";
var gsScanned="Scanned";
var gsBlocked="Blocked";
var gsDetectedItem="Item detected as an exception (%1)";
var gsCleanItem="Item is clean";
var gsDetections="Detections";
var gNoDetectionTypeSelected="No Detection Type Selected.";

// License
var gsLicenseDescription = new Array( "Unknown", "Evaluation", "Beta", "Unregistered", "Licensed", "Evaluation expired", "Beta expired" )
var gsLicenseExplanationTop= "This is to remind you that this product has a license that will expire soon. If the license expires, some or all of the product functionality will no longer operate. For further information, review the license states below and then press the accept button to dismiss this message."
var gsLicenseExplanationBottom= "Please contact McAfee, Inc. or your software dealer in order to acquire an appropriate licensed copy of this software."
var gsLicDescription = "Description";
var gsLicType = "Type";
var gsLicExpires = "Expires";
var gsLicDayTo = "Days to Expiry";
var gsLicNagTitle = "License Expiry Warning";

// Stat Pop-ups
var gsSpamInfo	= "Additional Spam Information";
var gsPhishInfo = "Additional Phish Information";
var gsSpoofInfo = "Additional Spoof Information";
var gsIPInfo    = "Additional IP Reputation Information";
var gsVirusInfo = "Additional Virus Information";
var gsTieAtdInfo = "Additional TIE and ATD Information";
var gsPUPInfo	= "Additional PUP Information";
var gsUnwanted  = "Triggered scanners/filters";
var gsURLInfo = "Additional URL Reputation Information";

var gsPopUpStatName  = new Object();
gsPopUpStatName["spamscanned"]	= "Scanned for spam:";
gsPopUpStatName["spam"]			= "Detected as spam:";
gsPopUpStatName["spamblocked"]	= "Blocked as spam:";
gsPopUpStatName["phishscanned"]	= "Scanned for phish:";
gsPopUpStatName["phish"]		= "Phish detected:";
gsPopUpStatName["phishblocked"]	= "Phish blocked:";
gsPopUpStatName["spfhf"]	= "SPF Hard Fail detected:";
gsPopUpStatName["spfsf"]	= "SPF Soft Fail detected:";
gsPopUpStatName["av"]			= "Virus detected:";
gsPopUpStatName["viruscleaned"]	= "Virus cleaned:";
gsPopUpStatName["pup"]			= "PUP detected:";
gsPopUpStatName["pupblocked"]	= "PUP blocked:";
gsPopUpStatName["file"]			= "Banned file types:";
gsPopUpStatName["mailsize"]		= "Banned messages:";
gsPopUpStatName["blockmime"]	= "Incomplete MIME messages:";
gsPopUpStatName["pa"]			= "Packers:";
gsPopUpStatName["content"]		= "DLP and Compliance:";
gsPopUpStatName["ec"]			= "Encrypted/Corrupted content:";
gsPopUpStatName["enc"]			= "Encrypted content:";
gsPopUpStatName["sig"]			= "Signed content:";
gsPopUpStatName["cor"]			= "Corrupted content:";
gsPopUpStatName["dos"]			= "Denial of service:";
gsPopUpStatName["procnt"]		= "Protected content:";
gsPopUpStatName["pwdpro"]		= "Password protected files:";
gsPopUpStatName["ip"]			= "IP encountered";
gsPopUpStatName["ipdropped"]	= "IP dropped";
gsPopUpStatName["iprejected"]	= "IP rejected";
gsPopUpStatName["url"]	= "URLs detected";
gsPopUpStatName["other"]		= "Others:";
gsPopUpStatName["tie_file"]  = "File reputations";
gsPopUpStatName["tie_cert"]  = "Certificate reputations";
gsPopUpStatName["atd"]  = "ATD submissions";
gsPopUpStatName["tie"]  = "Total TIE detections";

var gsScannedForSpam = "Scanned for spam:";
var gsDetectedAsSpam = "Detected as spam:";
var gsBlockedAsSpam = "Blocked as spam:";
var gsPhishDetected = "Phish detected:";
var gsPhishBlocked = "Phish blocked:";
var gsVirusDectected = "Virus detected:";
var gsVirusCleaned = "Virus cleaned:";
var gsPUPDectected = "PUP detected:";
var gsPUPBlocked = "PUP blocked:";
var gsIPEncountered	= "IP encountered";
var gsIPDropped	= "IP dropped";
var gsIPRejected	= "IP rejected";
var gsURLsBlocked = "Blocked URLs";


// UI Preferences Page
var gsPPRefreshInputVal   = "The refresh rate for the dashboard must be greater or equal to 30 and less than or equal to 3600.";
var gsPPScaleInputVal     = "The scale for the system metrics graph must be between 100 and 500.";
var gsPPHoursInputVal     = "The number of hours to report for must be between 1 and 24.";
var gsPPAngleInputVal     = "The angle for Pie charts must be between 1 and 360.";
var gsPPMaxScannedItemsInputVal	  = "The maximum number of scanned items must be between 10 and 100.";
var gsPPRefreshRate       = "Refresh rate";
var gsPPGraphScale        = "Graph scale";
var gsPPMaxScannedItems	  = "Maximum recently scanned items";
var gsPPHours             = "Number of hours to report for";
var gsPPAngle             = "Pie angle";


// Database Management
var gsEditPurgeSchedule = "Edit Purge Schedule";
var gsEditOptSchedule =   "Edit Optimization Schedule";

// Import / Export
var gsFileUploadOK		= "Successfully uploaded configuration to server.";
var gsFileUploadFailed	= "Failed to upload configuration to server. Result: ";
var gsConfirmRestoreDefault = "Are you sure you wish to restore the Default configuration? Note: Default configuration will reset your product to maximum performance.";
var gsSuccessRestoreDefault = "The product has been reset to maximum performance (default configuration).";
var gsConfirmRestoreEnhanced = "Are you sure you wish to restore the Enhanced configuration? Note: Enhanced configuration will reset your product to maximum protection.";
var gsSuccessRestoreEnhanced = "The product has been reset to maximum protection (Enhanced configuration).";

// Apply All control
var gsNoChanges = "There are no changes to apply.";
var gsPendingChanges = "The settings have changed.";

// String resources for rollup controls
gsCollapse = "Collapse";
gsExpand = "Expand";

// Dashboard
var gsEditTaskSchedule = "Edit Update Schedule";
var gsNotAvailable = "Not Available";
var gsUpdateStatus = "Update Status";
var gsNotScheduled = "Not Scheduled";
var gsUpdateFreqs = new Array;
gsUpdateFreqs["once"] = "Once";
gsUpdateFreqs["hourly"] = "Hourly";
gsUpdateFreqs["daily"] = "Daily";
gsUpdateFreqs["weekly"] = "Weekly";
gsUpdateFreqs["monthly"] = "Monthly";

// String resources for lazy loading
var gsConfigLoadErr = "Error loading required configuration data. This page may not function correctly.";

// String resources for file category selector control
var fcs_st = {};
fcs_st["__categories"] = "File categories:";
fcs_st["__subcats"] = "Subcategories:";
fcs_st["__all"] = "All";
fcs_st["__clear_all"] = "Clear selections";
fcs_st["__everything"] = "Everything";
fcs_st["__subcat_directive"] = "[Select one or more]";

// Validation labels for diagnostics
var gDiagnosticLabels= new Object();
gDiagnosticLabels["idDebugLogMaxSize"] = "Maximum size of debug log file";
gDiagnosticLabels["idDebugLogLocation"] = "Debug file location";
gDiagnosticLabels["idPLMaxDbSize"] = "Maximum database size";
gDiagnosticLabels["idPLDatabaseLocation"] = "Database location";
gDiagnosticLabels["idPLDbFilename"] = "Database filename";
gDiagnosticLabels["idPLMaxAgeOfEntries"] = "Maximum age of entry";
gDiagnosticLabels["idPLQueryTimeout"] = "Query timeout";

//Validation Labels for E-mailValidator
var gEmailLabels = new Object();
gEmailLabels["idAdminEmail"] = "Administrator Email";
gEmailLabels["idSenderEmail"] = "Sender Email";
gEmailLabels["idSubject"] = "Subject";

// Product log
var gLogLevels=[];
gLogLevels[0]="Information";
gLogLevels[1]="Warning";
gLogLevels[2]="Error";

// Button names
var strReleaseToOwner   = "Release";
var strDownload		= "Download";
var strForward		= "Forward";
var strExport		= "Export to CSV File";
var strSubmitToAvert   = "Submit to McAfee Labs";
var strView				= "View";
var strAddToBlockList = "Blacklist Sender";
var strAddToAllowList = "Whitelist Senders";

// Strings for the custom config progress monitor
var pm_st = {};
pm_st["__default_loading_msg"] = "Loading additional configuration data (%1); please wait...";
pm_st["Engine"] = "engine capabilities";
pm_st["DefaultAlerts"] = "default alerts";
pm_st["SpamRules"] = "spam rules";
pm_st["CSRules"] = "dlp and compliance rules";
pm_st["__xml_parse_err"] = "Error parsing %1; the configuration file may be corrupt.";

// ePO 3.5 Inherit
var gInherited = "Inherited";

//TaskStatus Strings
var gsNewScan = "New Scan";
var gsOnDemandScans = "On-Demand Scans";
var gsStatusReports = "Status Reports"
var gsNewReport = "New Report"
//string for problem in opening UI
var gsUIOpenError = "There was an unknown error while opening the Product UI. Please try again.";

// Avert report names
var gsDescription = "Description";
var gsAVERTReportFail = "Failed to load report, refreshing may fix the problem.";

// Policy Manager rule template strings
var gsRuleTemplateValue      = "<select a rule template>";

// ActiveWidget Grid related strings
var gsGridNoData       = "No data found.";
var gsGridLoading      = "Loading data, please wait...";
var gsGridSorting      = "Sorting...";

// Default task names
var gsDefTaskNames = new Object();

//Shared Resources-Tabs
var gsScannersAlerts = "Scanners & Alerts";
var gsFilterRules = "DLP and Compliance Dictionaries";
var gsTimeSlots = "Time Slots";

//validation for ASCII name
var gsASCIIAlert = "You can enter only the following ASCII characters: A-Z a-z 0-9 _ ."

//These variables are used in error messages
var gsErrMaxItemSize = "Maximum item size";
var gsErrMaxQuerySize = "Maximum query size";
var gsErrMaxItemAge = "Maximum item age";
var gsErrDiskIntervalCheck = "Disk size check interval";
var gsErrDiskSpaceWarn = "Disk space warning";
var gsErrDbLocationType = "Database location";
var gsErrMQMPort = "Port";
var gsErrCallbackPort = "Callback port";
var gsErrMQMIpAddress = "IP address";
var gsErrMQMCommunicationMode = "Communication Mode";
var gsErrMQMBWListUpdateInterval = "BW List Update Interval (hours)";
var gsErrAlertFileName = "Alert filename";
var gsErrDATSettings = "Maximum number of old DATs";
var gsErrFileName = "Filename";
var gsErrMailURLScore = "Higher URL reputation threshold should be greater than Lower URL reputation threshold";
var gsMagnifyGraph = "Magnify Graph";

var arrRepositoriesColumnNames = new Array;
arrRepositoriesColumnNames[ 0 ] = "Repository Description";//Name
arrRepositoriesColumnNames[ 1 ] = "Order";//Order
arrRepositoriesColumnNames[ 2 ] = "Enabled";//Enabled
arrRepositoriesColumnNames[ 3 ] = "RepositoryType";//RepositoryType


var gstrEnabled = "Enabled";
var gstrDisabled = "Disabled";
var gstrAddRepository = "Add Repository";
var gstrEditRepository = "Save";
var gstrViewRepositoryDetails = "View Details";
var gsMaxResRange = "Please enter an integer value between 1 and 99.";
var gsInvalidBWEmailAlert = "Invalid or Duplicate Entries : ";
var gsInvalidFileExtn = "Only *.txt or *.csv files are supported";
var gstrOK = "OK";
var gstrCancel = "Cancel";
var gsConfirmDeleteAll = "This will delete all items. Do you want to continue?";
var gsSearchValueTooLong = "Please enter text with a maximum of 255 characters."
var gstrMaxAgeInfo = "For this change to take effect, run the Purge and Optimization tasks.";

//Log global variables
var gDBMacroDispTable = new Array("<Install Folder>", "<System Drive>", "<Program Files>", "<Windows Folder>", "<Data Folder>", "(Full Path)");
var gDebugLogLocationMacroDispTable = new Array( "<Desktop>", "<Install Folder>", "<System Drive>", "<Program Files>", "<Windows Folder>", "(Full Path)");
var gPLMacroDispTable = new Array("<Desktop>", "<Install Folder>", "<System Drive>", "<Program Files>", "<Windows Folder>", "(Full Path)");

// Error Message
strErrorMessages[0xA0010107] = "Releasing Virus infected mails/attachments is not supported.";
strErrorMessages[0xA0010108] = "Downloading Virus infected mails/attachments is not supported.";
strErrorMessages[0xA0010109] = "Recipient Information Missing. Cannot be released.";
strErrorMessages[0xA001010A] = "This document does not belong to server. Cannot be released.";
strErrorMessages[0xA001010B] = "Forwarding Virus infected mails/attachments is not supported.";
strErrorMessages[0xA001010C] = "Viewing Virus infected mails/attachments is not supported.";
strErrorMessages[0xA001010D] = "Recipient Information Missing. Cannot be forwarded.";
