﻿//
// RTEStrings.js
// String table for the rich text editor.
//
// Copyright (C) 2009 McAfee, Inc. All rights reserved.
//

var rte_st = new Object();
rte_st["reset"] = "Réinitialiser";
rte_st["style"] = "[Style]";
rte_st["<P>"] = "Paragraphe <p>"
rte_st["<H1>"] = "En-tête 1 <h1>"
rte_st["<H2>"] = "En-tête 2 <h2>"
rte_st["<H3>"] = "En-tête 3 <h3>"
rte_st["<H4>"] = "En-tête 4 <h4>"
rte_st["<H5>"] = "En-tête 5 <h5>"
rte_st["<H6>"] = "En-tête 6 <h6>"
rte_st["<ADDRESS>"] = "Adresse <address>"
rte_st["<PRE>"] = "Préformaté <pre>"
rte_st["font"] = "[Police]";
rte_st["sans"] = "Sans Serif";
rte_st["serif"] = "Serif";
rte_st["mono"] = "Monospace";
rte_st["size"] = "[Taille]";
rte_st["1"] = "Extrêmement petite";
rte_st["2"] = "Très petite";
rte_st["3"] = "Petite";
rte_st["4"] = "Moyen";
rte_st["5"] = "Grande";
rte_st["6"] = "Très grande";
rte_st["7"] = "Extrêmement grande";
rte_st["bold"] = "Gras";
rte_st["italic"] = "Italique";
rte_st["uline"] = "Souligné";
rte_st["justifyleft"] = "Aligner à gauche";
rte_st["justifycenter"] = "Centrer";
rte_st["justifyright"] = "Aligner à droite";
rte_st["justifyfull"] = "Justifier";
rte_st["insertorderedlist"] = "Liste classée";
rte_st["insertunorderedlist"] = "Liste non classée";
rte_st["outdent"] = "Retrait négatif";
rte_st["indent"] = "Retrait";
rte_st["forecolor"] = "Couleur du texte";
rte_st["hilitecolor"] = "Couleur d'arrière-plan";
rte_st["inserthorizontalrule"] = "Règle horizontale";
rte_st["tokens"] = "[Variables]";

rte_st["url"] = "URL :";
rte_st["text"] = "Texte :";
rte_st["newWindow"] = "Ouvrir le lien dans une nouvelle fenêtre";
rte_st["insertlink"] = "Insérer un lien";
rte_st["cancel"] = "Annuler";
rte_st["url1"] = "URL";
rte_st["linkText"] = "Texte du lien";
rte_st["imageurl"] = "URL de l'image :";
rte_st["altText"] = "Texte de remplacement :";
rte_st["altAsTitle"] = "Utiliser ce texte comme titre de l'image";
rte_st["insertimage"] = "Insérer une image";
rte_st["rows"] = "Lignes :";
rte_st["rows1"] = "Lignes";
rte_st["columns"] = "Colonnes :";
rte_st["columns1"] = "Colonnes";
rte_st["width"] = "Largeur du tableau :";
rte_st["width1"] = "Largeur";
rte_st["pixels"] = "pixels";
rte_st["percent"] = "pour cent";
rte_st["usePercent"] = "Pourcentage";
rte_st["thickness"] = "Épaisseur de la bordure :";
rte_st["thickness1"] = "Épaisseur de la bordure";
rte_st["padding"] = "Remplissage des cellules :";
rte_st["padding1"] = "Remplissage";
rte_st["spacing"] = "Espacement des cellules :";
rte_st["spacing1"] = "Espacement";
rte_st["inserttable"] = "Insérer un tableau";
rte_st["readonly"] = "Lecture seule";
rte_st["modeSel"] = "Afficher :";
rte_st["wysiwygMode"] = "Contenu HTML (WYSIWYG)";
rte_st["sourceMode"] = "Contenu HTML (source)";
rte_st["ptMode"] = "Contenu en texte brut";

// Error messages
rte_st["preload_err"] = "Erreur lors du préchargement du contenu";
