﻿//
// RTEStrings.js
// String table for the rich text editor.
//
// Copyright (C) 2009 McAfee, Inc. All rights reserved.
//

var rte_st = new Object();
rte_st["reset"] = "リセット";
rte_st["style"] = "[スタイル]";
rte_st["<P>"] = "段落 <p>"
rte_st["<H1>"] = "見出し 1 <h1>"
rte_st["<H2>"] = "見出し 2 <h2>"
rte_st["<H3>"] = "見出し 3 <h3>"
rte_st["<H4>"] = "見出し 4 <h4>"
rte_st["<H5>"] = "見出し 5 <h5>"
rte_st["<H6>"] = "見出し 6 <h6>"
rte_st["<ADDRESS>"] = "アドレス <address>"
rte_st["<PRE>"] = "書式設定前 <pre>"
rte_st["font"] = "[フォント]";
rte_st["sans"] = "Sans Serif";
rte_st["serif"] = "Serif";
rte_st["mono"] = "等幅";
rte_st["size"] = "[サイズ]";
rte_st["1"] = "超極小";
rte_st["2"] = "極小";
rte_st["3"] = "小";
rte_st["4"] = "中";
rte_st["5"] = "大";
rte_st["6"] = "極大";
rte_st["7"] = "超極大";
rte_st["bold"] = "太字";
rte_st["italic"] = "斜体";
rte_st["uline"] = "下線";
rte_st["justifyleft"] = "左揃え";
rte_st["justifycenter"] = "中央揃え";
rte_st["justifyright"] = "右揃え";
rte_st["justifyfull"] = "両端揃え";
rte_st["insertorderedlist"] = "順序付きリスト";
rte_st["insertunorderedlist"] = "順序なしリスト";
rte_st["outdent"] = "アウトデント";
rte_st["indent"] = "インデント";
rte_st["forecolor"] = "テキスト色";
rte_st["hilitecolor"] = "背景色";
rte_st["inserthorizontalrule"] = "水平ルール";
rte_st["tokens"] = "[トークン]";

rte_st["url"] = "URL:";
rte_st["text"] = "テキスト:";
rte_st["newWindow"] = "リンクを新しいウィンドウで開く";
rte_st["insertlink"] = "リンクを挿入する";
rte_st["cancel"] = "キャンセル";
rte_st["url1"] = "URL";
rte_st["linkText"] = "リンク テキスト";
rte_st["imageurl"] = "イメージ URL:";
rte_st["altText"] = "代替テキスト:";
rte_st["altAsTitle"] = "このテキストをイメージのタイトルとして使用する";
rte_st["insertimage"] = "イメージを挿入する";
rte_st["rows"] = "行:";
rte_st["rows1"] = "行";
rte_st["columns"] = "列:";
rte_st["columns1"] = "列";
rte_st["width"] = "表の幅:";
rte_st["width1"] = "幅";
rte_st["pixels"] = "ピクセル";
rte_st["percent"] = "パーセント";
rte_st["usePercent"] = "パーセント";
rte_st["thickness"] = "罫線の幅:";
rte_st["thickness1"] = "罫線の幅";
rte_st["padding"] = "セル パディング:";
rte_st["padding1"] = "パディング";
rte_st["spacing"] = "セル間のスペース:";
rte_st["spacing1"] = "スペース";
rte_st["inserttable"] = "表の挿入";
rte_st["readonly"] = "読み取り専用";
rte_st["modeSel"] = "表示:";
rte_st["wysiwygMode"] = "HTML コンテンツ (WYSIWYG)";
rte_st["sourceMode"] = "HTML コンテンツ (ソース)";
rte_st["ptMode"] = "プレーンテキスト コンテンツ";

// Error messages
rte_st["preload_err"] = "エラー読み込み前コンテンツ";
