// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Create a new CS rule, includinf one condition with one phrase
// (lists all conditions)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================
var qparams = queryParameters();
var gCondition_pp_str='';
var gPhrase_pp_str='';
var gConditionPb=null;

function page_init()
{
      try
      {
		top.gPageStack.OnLoad();
		// For Phrase tab validation
		csr_condition_tabs.addValidation(0,csw_vframeworks["main_form"]);
		// For File Format tab validation
        csr_condition_tabs.addValidation(1,vframeworks["file_format"]);
      }
      catch(e)
	  {  alert(e.message);
      }
}


//======================================
// Asynchronous data load function
//======================================

// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function Show(pbIn, ppIn)
{
    var category = qparams["cat"]

	if ("string" == typeof(ppIn))
    {   gCondition_pp_str= ppIn;
    }
    else
    {   gCondition_pp_str= ppIn.GetPath();
    }

    gConditionPb = CSRules_MakePb(pbIn, gCondition_pp_str)

    CSRFFPanel_CreateNode(gConditionPb, gCondition_pp_str)
    CSRFFPanel_InitFF();
    CSRFFPanel_DrawFF(gConditionPb, gCondition_pp_str)

    gPhrase_pp_str = gConditionPb.GetNextElementEnum(gCondition_pp_str+".CFRule.Match");
    CSRP_Show(gConditionPb, gPhrase_pp_str, "Match");
}

//Asynchronous data validation function
function Validate() {

	var ok = CSRFF_Validate();     //file format validation.
    if(!ok) return false;
    return CSRP_Validate();     //phrase panel validation.
}

 // Asynchronous data save function
function Apply(pb_null,ppOut,save)
{
    //save file format and phrase in new rule property bag, then save the
    //complete rule in global property bag
    var pbT=gConditionPb;

    CSRFFPanel_Apply(gCondition_pp_str, pbT);
    CSRP_Apply(pbT);

    var pbOut=CSRules_GetTopPb();

   	if (gConditionPb != pbOut)
	{
         pbOut.DeleteList(gCondition_pp_str);
         gConditionPb.GetElement(gCondition_pp_str, pbOut);
		 change=true;

	}

    if (change)
    {   top.gPageStack.Active().SetModified(true);
    }


    return top.gPageStack.Active().pb
}

//==========================================================================================
//Callback function to list required configuration data
//==========================================================================================
function GetCustomConfigReq() {
	return ["CSRules"];
}
