// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Create a new CS rule, includinf one condition with one phrase
// (lists all conditions)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================
var qparams = queryParameters();
var gCondition_pp_str='';
var gPhrase_pp_str='';
document.onmousemove=mouseTrack; //for tooltip display

function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}

//======================================
// Asynchronous data load function
//======================================

// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function Show(pb_null, ppIn)
{
   //hide New Condition button
   var div=document.getElementById("newcondition_btn");
   if(div)
   {
       div.style.display = "none";
   }

   //display rest of page
   var category = qparams["cat"]
   CSRulePanel_Show(ppIn, category)
   gCondition_pp_str=  gCSRulePanel.pb.GetNextElementEnum( gCSRulePanel.pp_str+".ConditionRule");

   //create condition node with the Apply and CFRule nodes inside
   CSRFFPanel_CreateNode(gCSRulePanel.pb, gCondition_pp_str)
   CSRFFPanel_InitFF();
   CSRFFPanel_DrawFF(gCSRulePanel.pb, gCondition_pp_str)

   gPhrase_pp_str = gCSRulePanel.pb.GetNextElementEnum(gCondition_pp_str+".CFRule.Match");
   CSRP_Show(gCSRulePanel.pb, gPhrase_pp_str, "Match");

}

//Asynchronous data validation function
function Validate() {
	var ok = CSRulePanel_Validate(/*false*/);
	if(!ok) return false;
	//file format validation.
    ok = CSRFF_Validate();
    if(!ok) return false;

    return CSRP_Validate(); //phrase panel validation.
}

 // Asynchronous data save function
 //return the global property bag (unchanged)
function Apply(pb_null,ppOut,save)
{
    //save file format and phrase in new rule property bag, then save the
    //complete rule in global property bag
    var pbT=gCSRulePanel.pb;

    CSRFFPanel_Apply(gCondition_pp_str, pbT);
    CSRP_Apply(pbT);

    //add new rule to the top propertybag
    var pbOut=CSRules_GetTopPb();
    CSRulePanel_Apply(pbOut);

    return top.gPageStack.Active().pb
}

//==========================================================================================
//Callback function to list required configuration data
//==========================================================================================
function GetCustomConfigReq() {
	return ["CSRules"];
}

function UpdateRuleControls()
{
	var val=document.getElementById("regexp").checked;
	document.getElementById("complex_ctl").disabled = val;
	if (val == true)
	{
		CSRPhrase_ToggleComplex(false);
		document.getElementById("complex_ctl").checked = false;
	}

	var div=document.getElementById("regexp");
	

	if(div.checked)
	{
		var div1=document.getElementById("regexp");
		div1.checked = "checked"

		var div=document.getElementById("wildcard");
		if (div)
		{
			div.disabled="true"
		}

		/*div=document.getElementById("exact_match");
		if (div)
		{
			div.disabled="true"
		}*/
		
		div=document.getElementById("isstart");
		if (div)
		{
			div.disabled="true"
		}
		div=document.getElementById("isend");
		if (div)
		{
			div.disabled="true"
		}
	}
	else
	{
		var div1=document.getElementById("simplestring");
		div1.checked = "checked"
		
		var div=document.getElementById("wildcard");
		if (div)
		{
			
			div.disabled=""
		}

		/*div=document.getElementById("exact_match");
		if (div)
		{
			div.disabled=""
		}*/
		
		div=document.getElementById("isstart");
		if (div)
		{
			div.disabled=""
		}
		div=document.getElementById("isend");
		if (div)
		{
			div.disabled=""
		}

	}
}