// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Edit One CS rule
// (lists all conditions)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================

var gFileSelector;
var csrff_dataBindings = new Array();
var vframeworks = new Object();



function CSRFFPanel_InitFF()
{

    var fcsProps = {SelectAllCheck:true,width:300,width2:280};
    gFileSelector = new FileCatSelector(fileCats, "ff_div", "gFileSelector", fcsProps, "C")
    gFileSelector.draw();
    CSRFFPanel_Validation_Init();
    var db=new FCSDataBinding(gFileSelector, "Applies");
    db.leaf="section";
    csrff_dataBindings.push(db);
    return gFileSelector;

}

function CSRFFPanel_Validation_Init()
{
	var forms = ["file_format"];
    var CatSelCheckVal=new CatSelectionCheckValidator(gFileSelector);
    var fieldName =	"ff_div" + "_ctl" + "_all"; //Refer FileCatSelector.js for input.name

    for (var i = 0; i < forms.length; i++)
    {
        var form = forms[i];
        if (document.forms[form])
        {
            vframeworks[form] = new ValidationFramework(form);
            vframeworks[form].formAction = std_val_form_action;
            vframeworks[form].fieldAction = std_val_field_action;
            //Form level validation and tablevel validation
			vframeworks[form].addLabeledValidator(fieldName,"FileFormat",CatSelCheckVal);
        }
    }
}

/**
 * Asynchronous data validation function
 */
function CSRFF_Validate()
{
    var ok = vframeworks["file_format"].onsubmit()
	return ok;
}

//create node for the file format selection
//parameters:
//pbOut=property bag
//pp_str=container path (condition)
//creates the condition node if it does not exist.
function CSRFFPanel_CreateNode(pbOut, pp_str)
{
    var ppT = new PropertyPath(pp_str);

    //create the condition node with the file format element
    pbOut.SetProperty(ppT);

	ppT.Append("Applies");
    pbOut.SetProperty(ppT);
	ppT.SetTempLeaf("section")
    pbOut.SetProperty(ppT, "ALL");
	ppT=new PropertyPath (pp_str);

}




function CSRFFPanel_DrawFF(pbIn, pp_str)
{
    var ppT=new PropertyPath(pp_str);
    for (var i = 0; i < csrff_dataBindings.length; i++)
    {
        csrff_dataBindings[i].set(ppT, pbIn);
    }
}



function CSRFFPanel_Apply(pp_str, pb)
{
    var changed=false;
    var ppT = new PropertyPath(pp_str);
    var pbT = pb;
    for (var i = 0; i < csrff_dataBindings.length; i++)
    {
        if (csrff_dataBindings[i].get(ppT, pbT))
        {
            changed = true;
        }
    }

	return changed;

}
