//Copyright (C) 2017 McAfee, Inc.  All rights reserved.

var gIsEPO4 =((top.gIsEPO4 == McUndefined)||(top.gIsEPO4 == false))? false : true;
//defination of the AVERT report lists, filled in by Avert report generator
var gsAvertReports = new Array()
var gsAvertReportNames = new Array()

//definition of serverside mechanism to use, depends on WebServer & Platform
var gsDynamicGateway = "dynamicpage.dll"

//declare an uninitialised variable for use as 'undefined'
var McUndefined
var gsMaxCVSRecords = "10000"

//definition of foreigh languages array
var gForeignLanguages = new Array("de", "es", "fr", "ja","zh-cn", "zh-tw", "ko")
var helpWindow

// ppSupportsDisableInterface  - set to true in PointProductSpecific.js
// when the ppDisable() function has been implemented
var ppSupportsDisableInterface = false

//Initially linux flag will be off. Once we load PlatformSpecific.js after common.js glinux flag will be put on.
var gLinux =0;

// On some browsers and the stand-alone UI the Onkeypress event
// is fired for some system keys, such as left arrow etc. The following
// are allowed key codes for numeric fields
var gAllowedKeyCodes = [46,9,8,144,145]

/////////////////////////////////////////////////////////////////////////////
// ppWelcomeAlert - has the pp implemented welcome alert
var ppWelcomeAlert = false


var mouseX = 0;
var mouseY = 0;

///////////////////////////////////////////////////
//
// Carries out specified function only after
// complete frameset has loaded.
//
// Important: if given function call contains quotes
//            or double quotes then they must be escaped
//
var gFramesetLoadTimeout=0
function DoOnFramesetLoad(functionCall)
{
	// Start interval
	gFramesetLoadTimeout=setTimeout("DoOnFramesetLoadDo(\"" + functionCall +"\")" ,100)
}

function DoOnFramesetLoadDo(functionCall)
{
	// Do nothing if all frames not loaded or config is being modified
	if (!parent.gbFramesetLoaded || !parent.gbConfigLoaded)
	{
		gFramesetLoadTimeout=setTimeout("DoOnFramesetLoadDo(\"" + functionCall +"\")" ,100)
		return
	}

	// Stop interval
	clearTimeout(gFramesetLoadTimeout)
	// Call function
	eval(functionCall)
}


/////////////////////////////////////////////////////////
//
// Removes all the rows from the given table element
//
function RemoveAllRows(aTable)
{
	while (aTable.rows.length >0)
	{
		aTable.deleteRow(0)
	}
}

/////////////////////////////////////////////////////////
//
// Returns the value of the cookie with the given label
//
function getCookieValue(labelName)
{
    var doc = document

    if ( parent.document != document )
        doc = parent.document

	var cookieData   = doc.cookie
	var cookieLength = cookieData.length
	var cStart = -1
	var cEquals = 0

	do
	{
		// Look for end of current cookie
		var cEnd = cookieData.indexOf(";", cStart+1)
		if (cEnd == -1)
			cEnd = cookieLength

		// Look for label/val seperator
		cEquals = cookieData.indexOf("=", cStart+1)

		// Handle no value
		if (cEquals == -1)
			return ""

		// Check for label
		if (labelName == cookieData.substring(cStart+1,cEquals))
			return unescape(cookieData.substring(cEquals+1,cEnd))

		// Move to next label
		cStart = cEnd+1
	}
	while (cStart <  cookieData.length)
    return ""
}

function getCookieBoolean(labelName)
{
	var sCookieValue = getCookieValue(labelName);
	var bBoolean	 = false;

	if( sCookieValue == "1")
		bBoolean = true;

	return(bBoolean);
}

function setCookieBoolean(labelName, bBoolean, bPermanent)
{
	var	sCookieValue = "0";

	if( bBoolean )
		sCookieValue = "1";

	setCookieValue(labelName, sCookieValue, bPermanent);
}

function setCookieValueIfBlank( labelName, sValue, bPermanent )
{
	var sCurrentValue = getCookieValue(labelName);
	if( sCurrentValue == "" )
		setCookieValue(labelName, sValue, bPermanent);
}

function setCookieBooleanIfBlank(labelName, bValue, bPermanent)
{
	if( bValue == true )
		setCookieValueIfBlank(labelName, "1", bPermanent);
	else
		setCookieValueIfBlank(labelName, "0", bPermanent);
}

function setCookieValue(labelName,value,bPermanent)
{
	var str = labelName + "=" + escape(value)

	// Store value for a year if requested
    // If we are clearing the value, set the expire time to NOW to get
    // around a problem with the standalone UI where cookies were
    // disapearing!
	if (bPermanent || value == "" )
	{
		var dt = new Date()

        if ( bPermanent )
        {
            dt.setUTCFullYear(dt.getUTCFullYear() +1)
        }

		str += "; expires =" + dt.toGMTString()
	}

    var doc = document

    if ( parent.document != document )
        doc = parent.document

	doc.cookie = str
}


////////////////////////////////////////////////
//
// Returns the display name of the given envelope
// propery or "" if it doesnt exist
//
function GetPropName(id)
{

	var name = gsPropNames[id]
	if (name == McUndefined)
		name =id
	return name
}
////////////////////////////////////////////////
//
// Returns the index of the given property id
// or -1 if it doesnt exist
//
function GetPropIndex(id)
{
	for (var i=0; i < gEnvProps.length;i++)
	{
		if (gEnvProps[i] == id)
			return i
	}
	return -1
}

////////////////////////////////////////////////
//
// Returns number as string with fixed number
// of chars (zeros are used to pad)
//
function FormatNum(value,places)
{
	//calc extra zeros
	var str = ""
	str += value
	var zeros = places - str.length

	// return string
	str = ""
	for (var i =0; i < zeros; i++)
		str += "0"
	return str + value;
}

////////////////////////////////////////////////
//
// Convert the given Date object to/from XML datetime
// format (CCYY-MM-DDThh:mm:ss) using UTC value
//
function DateToXMLUTC(date)
{
	var xml = ""
	xml += FormatNum(date.getUTCFullYear(),4)
	xml += "-" + FormatNum(date.getUTCMonth()+1,2)
	xml += "-" + FormatNum(date.getUTCDate(),2)
	xml += "T" + FormatNum(date.getUTCHours(),2)
	xml += ":" + FormatNum(date.getUTCMinutes(),2)
	xml += ":" + FormatNum(date.getUTCSeconds(),2)
	return xml
}
function XMLToDateUTC(xml)
{
	if(xml == undefined)
		return ""

	var date = new Date()
	date.setUTCFullYear(parseInt(xml.substr(0,4),10))
	date.setUTCDate(parseInt(xml.substr(8,2),10))
	date.setUTCMonth(parseInt(xml.substr(5,2),10)-1)
	date.setUTCHours(parseInt(xml.substr(11,2),10))
	date.setUTCMinutes(parseInt(xml.substr(14,2),10))
	date.setUTCSeconds(parseInt(xml.substr(17,2),10))
	return date
}

////////////////////////////////////////////////
//
// Convert the given Date object to/from XML datetime
// format (CCYY-MM-DDThh:mm:ss) using local time value
//
function DateToXML(date)
{
	var xml = ""
	xml += FormatNum(date.getFullYear(),4)
	xml += "-" + FormatNum(date.getMonth()+1,2)
	xml += "-" + FormatNum(date.getDate(),2)
	xml += "T" + FormatNum(date.getHours(),2)
	xml += ":" + FormatNum(date.getMinutes(),2)
	xml += ":" + FormatNum(date.getSeconds(),2)
	return xml
}
function XMLToDate(xml)
{
	var date = new Date()
	date.setFullYear(parseInt(xml.substr(0,4),10))
	date.setMonth(parseInt(xml.substr(5,2),10)-1)
	date.setDate(parseInt(xml.substr(8,2),10))
	date.setHours(parseInt(xml.substr(11,2),10))
	date.setMinutes(parseInt(xml.substr(14,2),10))
	date.setSeconds(parseInt(xml.substr(17,2),10))
	return date
}

/////////////////////////////////////////////////////////
//
// min/max functions
//
function max(a,b)
{
	return a > b ? a: b
}
function min(a,b)
{
	return a > b ? b: a
}

/////////////////////////////////////////////////////////
//
// Parses string of tokens delimited by given char
// into array.
//
function ParseString(strIn, delimiter)
{
	var iDelim=0
	var values = new Array()
	var str = strIn
	while (str.length > 0 && iDelim > -1)
	{
		iDelim = str.indexOf(delimiter)
		values[values.length] = -1 == iDelim ? str : str.substr(0,iDelim)
		str = str.substr(iDelim+1)
	}
	return values
}

/////////////////////////////////////////////////////////
//
//  Greys/ungreys given control using ambient color
//
function GreyUngrey(id,onoff)
{
 	document.getElementById(id).style.backgroundColor = (onoff ? "BUTTONFACE" : "#FFFFFF")
}

/////////////////////////////////////////////////////////
//
// Toggles enabled state of the given control
//
function ToggleControl(id)
{
	document.getElementById(id).disabled = !document.getElementById(id).disabled
	GreyUngrey(id,document.getElementById(id).disabled)
}

/////////////////////////////////////////////////////////
//
// Enabled/disables given control
//
function EnableControl(id,bEnable)
{
	document.getElementById(id).disabled = !bEnable
	GreyUngrey(id,!bEnable)
}

/////////////////////////////////////////////////////////
//
//  Returns true if given string is made up of chars
//  '0'-'9'
//
function IsValidNumeric(str)
{
	return parseInt(str,10) == str
}

////////////////////////////////////////////////
//
// Sets Visibility of element with given id
// Use "display" to rerender surrounding html
// if on ie but not otherwise because it doesnt
// work properly (as of netscape 6)
//
function SetVisible(elementID, bVisible, bForceNonIE)
{
	var element = xbGetElementById(elementID)

	// Use "display" if IE ...
	if (document.all && bForceNonIE == false)
		element.style.display = bVisible ? "block" : "none"

        // .. otherwise use cross-browser standard
	else
	{
		var elementStyle = new xbStyle(element)
 		if (bVisible)
			elementStyle.setVisibility('visible')
		else
			elementStyle.setVisibility('hidden')
	}
}

/////////////////////////////////////////////////
//
// Returns index of value in array or -1 if not
// found. The search is case sensitive.
//
function FindInArray(array, value)
{
	for (var i= 0; i < array.length; i++)
	{
		if (array[i] == value)
			return i
	}
	return -1
}

/////////////////////////////////////////////////
//
// Returns index of value in array or -1 if not
// found. The search is NOT case sensitive.
//
function FindInArrayNoCase(array, value)
{
	for (var i= 0; i < array.length; i++)
	{
		if (array[i].toLowerCase() == value.toLowerCase())
			return i
	}
	return -1
}

////////////////////////////////////////////////////////////////////////////////
//
// Allows dynamic pages from non-iis installation
// McDynamic is set by an argument to mainframe.htm
// "NoIIS"
function GetDynamicPageUrl(args, suffix)
{
    // Check for HTTP UI
    var val = getCookieValue("McDynamic")
	if ( val == "NoIISMoz")
	{
		args += "&b="
		args += val
	}
    // In order to prevent problems with extended (non-Latin) characters being incorrectly
    // interpreted by IIS we call the encodeURIComponent() function. For a description of
    // this funtion see JavaScript Bible 4th Edition Pages 1092-1094
    var encodedArgs = encodeURIComponent(args)

    if (suffix == McUndefined)
		suffix = "html"

    if ( val == "" && !parent.gbNoIIS )
    {
        /*This gives the option for the platform specific
          implementation to override the location and name of the
          cgi script
        */
        if(this.PSGetDynamicPageURL !== undefined)
        {
            return(this.PSGetDynamicPageURL(args, suffix));
        }
        else
        {
		// Build relative path assume url of the form http://machine/product/...
		var index =0
		for (var i = 0; i <4; i++)
			index = location.href.indexOf("/",index+1)
		return location.href.substring(0, index+1) + "cgi-bin/dynamic/" +gsDynamicGateway+ "?" + escape(encodedArgs)
        }
    }
    else
    {
		if( val == "NoIISMoz")
		{
			var index =0
			index = location.href.indexOf("/ui/")
			filename = location.href.substring(0, index+1) + "ui/cgi-bin/dynamic/STANDALONE.cgi"+ "?" + escape(encodedArgs)
			return filename;
		}
		else
		{
			//Old IE standalone version
 			filename = window.external.SetDynamicPageQuery(escape(encodedArgs))
			return location.href.substr(0, location.href.indexOf("/ui/") + 4)+ filename + "." + suffix
		}
    }
}


/////////////////////////////////////////////////
// Checks if a given string is empty
// by testing it for null and checking whether
//  its trimmed equivalent is of zero length
//
function IsEmpty(szString)
{
	var fIsEmpty = ((szString==null) || (szString.length==0)) ;

	if (!fIsEmpty)
	{
		szString=trim_string(szString) ;
		fIsEmpty = (szString.length==0) ;
	}

	return fIsEmpty ;
}


/////////////////////////////////////////////////
// Removes leading and trailing blanks from a string
// trimmed string is returned by the function
//
function trim_string(str)
{
     var ichar, icount;
     var strValue = str;
     ichar = strValue.length - 1;
     icount = -1;
     while (strValue.charAt(ichar)==' ' && ichar > icount)
         --ichar;
     if (ichar!=(strValue.length-1))
         strValue = strValue.slice(0,ichar+1);
     ichar = 0;
     icount = strValue.length - 1;
     while (strValue.charAt(ichar)==' ' && ichar < icount)
         ++ichar;
     if (ichar!=0)
         strValue = strValue.slice(ichar,strValue.length);
     return strValue;
}


/////////////////////////////////////////////////
// Name		    :: OnlyNumeric
// Arguments	::
// Description  :: This function should vbe called from OnKeyDown and OnPaste Events.
//				   All the non-Numeric key are eaten
//
function OnlyNumeric()
 {
   if (event.type == "keydown")
   {
        OnlyNumeric_KeyDown();
   }
   else if (event.type == "paste")
   {
        OnlyNumeric_Paste();
   }
}

/////////////////////////////////////////////////
// Name		    :: OnlyNumeric_KeyDown
// Arguments	::
// Description  :: Helper function for OnlyNumeric
//                 Limit key-strokes to numeric values only
//
function OnlyNumeric_KeyDown()
{
var character = String.fromCharCode(window.event.keyCode);


    if ( window.event.ctrlKey == true )
    {
        return;
    }

	if ( ( window.event.keyCode >= 96 ) && ( window.event.keyCode <= 105 ) )
	{
		return;
	}

	if  ( ( character >= "0" ) && ( character <= "9"  ) && ( window.event.shiftKey == false ) )
	{
		return;
	}

	if  ( ( window.event.keyCode == 46 ) ||			//delete
		  ( window.event.keyCode == 9 )  ||			//tab
		  ( window.event.keyCode == 8 )  || 		//backspace
		  ( window.event.keyCode == 36 ) ||			//home key
		  ( window.event.keyCode == 35 ) ||			//end key
		  ( window.event.keyCode == 39 ) ||			//--> right
		  ( window.event.keyCode == 37 ) ||			//<-- Key
		  ( window.event.keyCode == 45 ) )			//insert key
	{
		return;
	}

	event.returnValue = false;
}

/////////////////////////////////////////////////
// Name		    :: OnlyNumeric_Paste
// Arguments	::
// Description  :: Helper function for OnlyNumeric
//                 Paste clipboard data only if numeric
//
function OnlyNumeric_Paste()
{
    var sVal= window.clipboardData.getData("Text");
    var iVal= 0;

    while (sVal.length && (sVal.charAt(0) == '0'))
       sVal = sVal.substring(1, sVal.length);

    iVal= parseInt(sVal,10);

    if (isNaN(iVal) || (String(iVal) != sVal))
    {
        event.returnValue= false;
    }
}

// Escapes the < > & ' and " characters so they will render correctly in HTML
function ReplaceSpecialHTMLChars( string )
{
	var str = "";

	if ( string == undefined ) return str;

	// Replace token with given value
	for(var i = 0; i < string.length; i++)
	{
		switch(string.charAt(i))
		{
		case '<':
			str += "&lt;"
			break
		case '>':
			str += "&gt;"
			break
		case '&':
			str += "&amp;"
			break
		case '\'':
			str += "&#39;"
			break
		case '\"':
			str += "&quot;"
			break
		case ' ':
		    str += "&nbsp;";
		default:
			str += string.charAt(i)
			break
		}
	}

	return str
}

////////////////////////////////////////////////
//
// Generic escape and unescape
//
function McEscape(strIn, protectedChars)
{
	var strOut = "";
	if ( strIn == undefined ) return strOut;
	for(var i = 0; i < strIn.length; i++)
	{
		if (strIn.charAt(i)=='^' || protectedChars.indexOf(strIn.charAt(i)) != -1)
			strOut += '^'
		strOut += strIn.charAt(i)
	}
	return strOut
}
function McUnescape(strIn)
{
	var strOut = "";
	if ( strIn == undefined ) return strOut;
	for(var i = 0; i < strIn.length; i++)
	{
		if (strIn.charAt(i)=='^')
			i++
		strOut += strIn.charAt(i)
	}
	return strOut
}

function EscapeForJS(strIn)
{
	var strOut = ""
	if ( strIn == undefined ) return strOut;
	protectedChars="\/\"\'\t\b\n\r\f";
	for(var i = 0; i < strIn.length; i++)
	{
		if (strIn.charAt(i)=='\\' || protectedChars.indexOf(strIn.charAt(i)) != -1)
			strOut += '\\'
		strOut += strIn.charAt(i)
	}
	return strOut
}

//
// a leap year is divisble by 4 but not 100, or divisible by 400
// (this works for past-1752 years)

function IsLeapYear( year )
{
	var ret = false

	if( year % 4 == 0 && year % 100 != 0 )
	{
		ret = true
	}
	else
	{
		if( year % 400 == 0 )
		{
			ret = true
		}
		else
		{
			ret = false
		}
	}

	return ret
}

function ShowElement(id)
{
	document.getElementById(id).style.display = "block";

}
function HideElement(id)
{
	document.getElementById(id).style.display = "none";
}


///////////////////////////////////////////////////////////////////////////////
//
// Bowser neutral calls to deal with IFrames
//
function GetDocumentFromIFrame(objFrame)
{
	if (navigator.appVersion.indexOf("MSIE ") > 0) // IE
	{
		return objFrame.document ;
	}
	else
	{
		//get the document from the passed in element
		var doc = objFrame.contentDocument;

		//if there was no contentDocument, try getting it from the frameElement
		if(doc == McUndefined)
			doc = objFrame.frameElement.contentDocument;

		return doc;
	}
}

function GetIFrameFromDocument(objDoc/* Object*/, FrameName /*string*/)
{
	if (navigator.appVersion.indexOf("MSIE ") > 0) // IE
	{
		return objDoc.frames[FrameName] ;
	}
	else
	{
		var frame = objDoc.getElementById(FrameName);
		if(frame == McUndefined)
			frame = objDoc.getElementByName(FrameName);

		return  frame;
	}
}

//////////////////////////////////////////////////////////////
//
// Validate Text/HTML input for the presence of Script keyword.
//
function ScriptInputValidation(value,verbose,html)
{

	var invalid = false;
	value = value.toLowerCase(value);       //to make it case insensitive.
	var index;

	if(html)
		index = value.indexOf("&lt;");
	else
		index = value.indexOf("<");

	if( index != -1 )
	{
		var tagValue = value.substring(index);

		if( tagValue.match("script") != null )
		  invalid = true;
		else
		  invalid = false;
	}
   else
	{
	   invalid = false;     //no script key word within the <>
	}

	if(	invalid && verbose )
		alert(gsScriptNotAllowed);

	return !invalid;
}
//////////////////////////////////////////////////////////////
//
// Validate email address with wild cards
//
function ValidEmail(address, verbose)
{
    var invalid = false;
    if (null == verbose)
        verbose = true;
	address  = trim_string( address );
	//Check for null string
	if( address.length == 0 )
	{
		invalid = true;
	}
	//Check for presence of last "@" symbol
	if( !invalid )
	{
		breakIndex = address.lastIndexOf( "@" );
		if( breakIndex == -1)        // @ not present
		 	invalid = true;
	}
	var localPart;
   	var domainPart;
	//Check for length of User and Domain part
	if( !invalid)
	{
		localPart = address.substring(0, breakIndex);
		domainPart = address.substring(breakIndex + 1);

		if( localPart.length >256 || domainPart.length > 64 )
				invalid = true;
	}
	// Check for something before and after the @
	if (!invalid)
	{
        if( localPart.length == 0 || domainPart.length ==0)
			invalid = true;
    }
    var specialCharsAllowed = false;
	//Check for quotes in the Local Part
	if( ! invalid && localPart.indexOf("\"") == 0)
	{
		var endQuote = localPart.lastIndexOf("\"");
		if ( endQuote != -1 && address.charAt(endQuote +1 ) == "@" )          // here we need to use the whole address to gethold of "@"
		{
			specialCharsAllowed = true;
			for(var i=1;i<localPart.length-1;i++)		  //presence of quotes in the quoted local part.
				if ( localPart.charAt(i) == "\"" )
				{
					invalid = true;
				}
		}
	}
	//localpart vaildity
    if ( !invalid &&  !specialCharsAllowed && !allValidChars( localPart, true ) )
    {
        invalid = true;
    }

	//domainpart Validity
    if ( !invalid &&  !allValidChars( domainPart, false ) )
    {
		invalid =true;
    }
	// Check for presence of . at start of localPart or at the end of the localPart
	// Similar check for domainPart
	if (!invalid)
	{
        startindex = localPart.indexOf(".");
		endindex  =	localPart.lastIndexOf(".");
		
		if(startindex != -1 && endindex != -1)
		{
			if( startindex == 0 || endindex == (localPart.length - 1) )
				invalid = true;
		}

		if( !invalid)
		{
        	startindex = domainPart.indexOf(".");
			endindex  =	domainPart.lastIndexOf(".");
			if(startindex != -1 && endindex != -1)
			{
				if( startindex == 0 || endindex == (domainPart.length - 1) )
					invalid = true;
			}
		}
    }
	if (invalid && verbose)
	    alert(gsInvalidEmail);

	return !invalid;
}

function SplitOutsideQuotes(str, delimiter) {
	var len = str.length
	var arr = new Array()
	var substr = ""
	var bInsideQuotes = false
	
	for(i=0; i < len; i++) {	
		if(str.charAt(i) == delimiter.charAt(0)) {
			if(!bInsideQuotes) {
				arr[arr.length] = substr
				substr = ""
				continue
			}
		}
		if(str.charAt(i) == '"')
			bInsideQuotes = !bInsideQuotes
		else if(str.charAt(i) == '\\') {		
			substr += str.charAt(i)
			i++
			if(i >= len)
				return new Array() // Error
		}
		substr += str.charAt(i)
	}
	
	if(bInsideQuotes)
		return new Array() // Error
	if(substr != "")
		arr[arr.length] = substr
	return arr
}

function IsDuplicate(strIn , item2)
{
	var icount =0;
	for(var i = 0; i < strIn.length; i++)
	{
		if (strIn.charAt(i)== item2 )
		{
			i++;
			icount++;
		}
	}
	if (icount > 1) return true;

	return false

}

function allValidChars(email,isLocal)
{
  	//both for local and domain part, space is also included
  	var specialchars = "()<>:;@\, ";
  	// only for local part.
  	var sqbrackets = "[]";

	// local/domain part contains quotes.
	if( email.indexOf("\"") != -1)
		return false;

	/*if( !isLocal )
	{
		//domain part does not contain period.
		if( email.indexOf(".") == -1)
			return false;
	}
	*/

 	for (var i=0; i < email.length; i++)
	{
		var letter = email.charAt(i).toLowerCase();
		//special chars are present in the local or domain part
		if (specialchars.indexOf(letter) != -1)
			return false;

		if(isLocal)
		{
			//only for the local part
			if( sqbrackets.indexOf(letter) != -1)
				return false;
		}
	}
	return true;
}

// provides combo compatibility for IE and Firefox
function addOption(selectElement,newOption)
{
  // First try the DOM2 method ...
  try {
   selectElement.add(newOption,null);
  }
  // ... And if that doesn't work use the IE-only method
  catch (e) {
    selectElement.add(newOption,selectElement.length);
  }
}

// Cross browser only numeric check
function OnlyNumeric2(event)
{
	var charCode = (event.which) ? event.which : event.keyCode
	if (charCode > 31 && (charCode < 48 || charCode > 57))
	{
		// Is it one of the allowed keys
		for( var n = 0; n < gAllowedKeyCodes.length; n++ )
			if( gAllowedKeyCodes[n] == charCode )
				return true;

		return false

	}

	return true

}

//////////////////////////////////////////////
//
// Create an array in the current frame
//
function NewArray()
{
	return new Array
}

//////////////////////////////////////////////
//
// Create an object in the current frame
//
function NewObject()
{
	return new Object
}

////////////////////////////////////////////////////////////////////////////////////////////////
//
// Returns number of days in given month
//
function getMonthLength(cMonth,cYear)
{
	if (cMonth==1 || cMonth==3 || cMonth==5 || cMonth==7 || cMonth==8 || cMonth==10 || cMonth==12)
		monthLength = 31
	else
		if (cMonth==4 || cMonth==6 || cMonth==9 || cMonth==11)
			monthLength = 30
		else
			if (cYear % 100 == 0)
				monthLength = (cyear % 400 == 0) ? 29 : 28
			else
				if (cYear % 4 == 0)
					monthLength = 29
				else
					monthLength = 28;

       return monthLength
}


/**
 * Makes a table an SDL (standardized data list) by setting properties in
 * a table object
 * @param tableName the name of the table to process
 * @param hasHeader true if the first row of the table is a header
 * @param altShading true if alternate rows are to be shaded differently
 */
function makeSDL(tableName, hasHeader, altShading) {
    if (null == altShading)
        altShading = true;
    var table = document.getElementById(tableName);
    if (table) {
        table.border = 0;
        table.cellPadding = 0;
        table.cellSpacing = 0;
        var className = table.className;
        table.className = addClass(className, "dataSubTable");
        var rows = table.rows;
        var rowCount = rows.length;
        // Get the index of the last visible row
        var lastVisible = rowCount - 1;
        for (var i = lastVisible; i >= 0; i--) {
            if ("none" != rows[i].style.display) {
                lastVisible = i;
                break;
            }
        }
        for (var i = 0; i < rowCount; i++) {
            var row = rows[i];
            var className = row.className;
            var applyShading = (0 == i && hasHeader) ? false : true;
            if (applyShading) {
                var v = hasHeader ? (i + 1) : i;
                if (v % 2) {
                    className = addClass(className, altShading ? "row1" : "row0");
                } else {
                    className = addClass(className, "row0");
                }
            }
            if (i == lastVisible) {
                className = addClass(className, "lastRow");
            }
            row.className = className;
            var tds = row.cells;
            var cellCount = tds.length;
            for (var j = 0; j < cellCount; j++) {
                var cell = tds[j];
                className = cell.className;
                className = addClass(className, "dst");
                if (j == cellCount - 1) {
                    className = addClass(className, "eor");
                }
                cell.className = className;
            }
        }
    }
}

function addClass(className, classToAdd) {
    var components = [];
    if (undefined === className) {
        className = "";
    }
    else {
        components = className.split(" ");
    }
    for (var i = components.length - 1; i >= 0; i--) {
        if (components[i] == classToAdd) {
            // Nothing to do
            return className;
        }
    }
    components.push(classToAdd);
    return components.join(" ");
}

function removeClass(className, classToRemove) {
    if (classToRemove == className) {
        return "";
    }
    var start = className.indexOf(classToRemove);
    if (-1 == start) {
        return className;
    }
    var re = new RegExp(classToRemove + "\\s*");
    return className.replace(re, "");
}

/**
 * Reverses a string
 * @param s the string to reverse
 * @return the reversed string
 */
function strrev(s) {
    //var chars = s.split("");
    //chars.reverse();
    //return chars.join("");
    return s.split("").reverse().join("");
}

/**
 * Formats a number with language-specific features: grouping character, number
 * of digits in a group and the decimal separator
 * @param n the number to format
 * @param ds the decimal separator
 * @param gc the grouping character
 * @param gd the number of digits in a group
 * @return the formatted number
 */
function formatNumber(n, ds, gc, gd) {
    // Split the number around the decimal point
    /*var nt = n.toString();
    var parts = nt.split('.');

    // Take the integer part of the input and reverse it
    var int_part = strrev(parts[0]);
    var res = "";
    // Go through the reversed part of the string and add grouping characters
    // after each group of digits
    var ncs = int_part.length;
    for (var i = 0; i < ncs; i++) {
        if (0 == (i % gd)) {
            if ((0 != i) && (i != ncs - 1)) {
                // Stick a grouping character in
                res += gc;
            }
        }
        res += int_part.charAt(i);
    }

    var output = strrev(res);
    if (parts.length > 1) {
        // Add the decimal separator and the part after the decimal point
        output += ds + parts[1];
    }
    return output;*/
    var text = strrev(n.toString());
    // Replace the decimal separator with the locale specific decimal
    text = text.replace(/\./, ds);
    var pattern = "(";
    // Build up a pattern for inserting the grouping characters
    for (var i = 0; i < gd; i++) {
        pattern += "\\d";
    }
    pattern += ")(?=\\d)(?!\\d*";
    if ('.' == ds) {
        pattern += "\\.";
    } else {
        pattern += ds;
    }
    pattern += ")";
    var re = new RegExp(pattern, "g");
    text = text.replace(re, "$1" + gc);
    return strrev(text);
}

/**
 * Renders a number as 20K, 30M, 50G, etc. according to its order; this
 * can produce better looking output than the number alone
 * @param n the number to render
 * @param fd the number of fractional digits to display
 * @param symList a list of localized symbols for K, M and G
 * @param bytes true if the number represents bytes, false otherwise
 * @return a formatted number
 */
function sFormatNumber(n, fd, symList, bytes) {
    var billion = Math.pow(10, 9);
    var million = Math.pow(10, 6);
    var thousand = Math.pow(10, 3);
    if (bytes) {
        billion = Math.pow(2, 30);
        million = Math.pow(2, 20);
        thousand = Math.pow(2, 10);
    }
    var symbol = undefined;
    var x = Math.abs(n);
    if (x > billion) {
        n /= billion;
        symbol = symList[2];
    } else if (x > million) {
        n /= million;
        symbol = symList[1];
    } else if (x > thousand) {
        n /= thousand;
        symbol = symList[0];
    } else {
        symbol = symList[3];
    }
    // Round the number to an appropriate number of decimal places
    n = Number(n.toFixed(fd));
    // In IE toLocaleString always adds two decimal places, which is
    // not what is required if there are no fractional digits to show
    var ret = (fd > 0) ? n.toLocaleString() : n.toString();
    if (symbol) {
        ret += symbol;
    }
    return ret;
}

/**
 * Formats a string, interpolating variable values into placeholders; the
 * unformatted string takes the form "text %1 more text %2: %3"
 * @param unf the unformatted string
 * @param inserts a list of values to insert into the string
 * @return the formatted string
 */
function formatString(unf, inserts) {
    var ret = unf;
    if (inserts) {
        var iCount = inserts.length;
        for (var i = 0; i < iCount; i++) {
            var pattern = "%" + (i + 1);
            var re = new RegExp(pattern, "g");
            ret = ret.replace(re, inserts[i]);
        }
    }
    return ret;
}

/**
 * Resolves a string and formats it
 * @param st a string table
 * @param key the lookup key in the table
 * @param inserts a list of values to insert into the string
 * @return the formatted string
 */
function resolveString(st, key, inserts) {
    var ret = key;
    if (st && st.hasOwnProperty(key)) {
        ret = formatString(st[key], inserts);
    }
    return ret;
}


/**
 * Displays / hides summary popup information
 * @param divId the ID of the summary information div
 * @param onState true if the popup is to be displayed, false otherwise
 */
function dhtmlSummaryPop(divId, onState) {
    var dhtmlSummary = document.getElementById(divId);
    if (dhtmlSummary) {
        dhtmlSummary.style.display = (onState) ? "block" : "none";
        if (onState) {
            var left = mouseX + 5;
            if (left + 300 > 800) {
                // Show the popup to the right of the mouse pointer
                left -= 300;
            }
            var top = mouseY + 5;
            dhtmlSummary.style.left = left + "px";
            dhtmlSummary.style.top = top + "px";
        }
    }
}

/**
 * Appends a parameter to a URI
 * @param uri the URI to modify
 * @param param the parameter to append
 * @param val the value of the parameter
 * @return the modified URI
 */
function uriAppend(uri, param, val) {
    if (-1 == uri.indexOf("?", 0)) {
        uri += "?";
    } else {
        uri += "&";
    }
    uri += param + "=" + encodeURIComponent(val);
    return uri;
}

/**
 * Splits a path into a (virtual) directory, basename and ending
 * @param path the path to split
 * @return the split path (an Object with "directory", "basename"
 * and "ending" properties)
 */
function splitPath(path) {
    var ret = new Object();
    // Separate directory and file name
    var elems = path.split(/[\/\\]/);
    var fName = elems[elems.length - 1];
    // Remove the file name from the list of elements
    elems.length -= 1;
    if (elems) {
        // ...and join them back up to form the directory
        ret["directory"] = elems.join("/");
    }
    else {
        ret["directory"] = "";
    }

    // Split the filename around the final period
    ret["ending"] = "";
    if (fName.indexOf(".") > 0) {
        elems = fName.split(".");
        ret["ending"] = elems[elems.length - 1];
        elems.length -= 1;
        fName = elems.join(".");
    }
    ret["basename"] = fName;
    return ret;
}

/**
 * Gets the query parameters from a URI
 * @return the parsed and decoded parameters in a JavaScript Object
 */
function queryParameters() {
    var ret = new Object();
    // Get any parameters passed to the URI
    var query = window.location.search;
    if (query) {
        // The query string includes the leading '?' - get rid of it
        query = query.substring(1);
        var params = query.split("&");
        for (var i = params.length - 1; i >= 0; i--) {
            var pair = params[i].split("=");
            var paramName = pair[0];
            var paramVal = null;
            if (pair.length > 1) {
                paramVal = decodeURIComponent(pair[1]);
            }
            if (!ret.hasOwnProperty(paramName)) {
                ret[paramName] = new Array();
            }
            ret[paramName].push(paramVal);
        }
    }
    return ret;
}

/**
 * Checks that query parameters contain a certain value, setting a
 * default if absent
 */
function fixQParams(qParams, param, def) {
    if (undefined === qParams[param]) {
        qParams[param] = [];
        qParams[param].push(def);
    }
}

/**
 * Enables / disables all the controls on a form at once
 * @param formName the name of the form to be disabled
 * @param enabledFlag true if the controls are to be enabled, false otherwise
 */
function setFormEnabledState(formName, enabledFlag) {
    var disabled = !enabledFlag;
    var f = document.forms[formName];
    if (f) {
        var elems = f.elements;
        for (var i = 0; i < elems.length; i++) {
            elems[i].disabled = disabled;
        }
    }
}

/**
 * Generates a GUID for unique IDs and suchlike; GUID is compatible
 * with the output of Win32 UuidCreate() function
 * @param guidBase a string that is prefixed to the GUID
 */
function MakeGuid(guidBase) {
    // Generate four random, thirty-two bit numbers
    var random = [];
    var b32 = Math.pow(2, 32);
    var max = b32 - 1;
    for (var i = 0; i < 4; i++) {
        random.push(Math.floor(max * Math.random()));
    }
    // Bits 12-16 of the second GUID DWORD contain a version number, which is
    // 0100 (v4) in our case, signifying random numbers in all sections
    random[1] &= 0xFFFF0FFF;
    random[1] |= 0x4000;
    if (random[1] < 0) {
        random[1] += b32;
    }
    // Bits 30-32 of the third GUID DWORD contain variant information, which
    // is 10- in our case signifying standard format
    random[2] &= 0x3FFFFFFF;
    random[2] |= 0x80000000;
    if (random[2] < 0) {
        random[2] += b32;
    }
    // Encode all numbers in hexadecimal
    var strings = [];
    for (var i = 0; i < random.length; i++) {
        var s = random[i].toString(16);
        // pad with zeroes if required
        var s2 = "";
        var paddingRequired = 8 - s.length;
        for (var j = 0; j < paddingRequired; j++) {
            s2 += '0';
        }
        strings.push(s2 + s);
    }
    var blob = strings.join("").toUpperCase();
    var parts = [];
    // The format of a GUID is 8-4-4-4-12
    var selectors = [8, 4, 4, 4, 12];
    var currIdx = 0;
    for (var i = 0; i < selectors.length; i++) {
        var len = selectors[i];
        var part = blob.substring(currIdx, currIdx + len);
        parts.push(part);
        currIdx += len;
    }
    var ret = "";
    if (guidBase)
        ret += guidBase + ":";
    ret += parts.join("-");
    return ret;
}


/**
 * Dynamically includes JavaScript files
 * @param src the source of the JavaScript
 */
function includeJS(src) {
    var addScript = true;
    var scripts = document.getElementsByTagName("script");
    var nScripts = scripts.length;
    for (var i = 0; i < nScripts; i++) {
        if (scripts[i].src == src) {
            addScript = false;
        }
    }
    if (addScript) {
        try {
            // Create a new script element
            var newScript = document.createElement("script");
            newScript.src = src;
            newScript.type = "text/javascript";
            // ...and add it to the head of the document
            document.getElementsByTagName("head")[0].appendChild(newScript);
            /*if (document.getElementsByTagName("script").length == nScripts) {
            alert("Failed to add script \"" + src + "\"");
            }*/
        }
        catch(e) {
            alert(e);
        }
    }
}

/**
 * Strips surrounding quotes from a string
 * @param s the string to unquote
 * @param q the quotation mark; defaults to double-quotes
 */
function unquote(s, q) {
    var ret = s;
    if (null == q)
        q = "\"";
    var sLen = s.length;
    if (q == s.charAt(0) && q == s.charAt(sLen - 1)) {
        ret = s.substring(1, sLen - 1);
    }
    return ret;
}

/**
 * Gets policyset-specific UI flags
 * @param pSet the policy set
 * @param fName the flag name
 * @param def the default value
 */
function getUIFlag(pSet, fName, def) {
    var ret = def;
    if (null == pSet || "" == pSet)
        pSet = "__default";
    if (null != this.pp_ui_flags && null != pp_ui_flags[pSet]
        && null != pp_ui_flags[pSet][fName])
        ret = pp_ui_flags[pSet][fName];
    return ret;
}

/**
 * Joins two strings with the given token
 * @param s1 string to join too
 * @param s2 string to join with s1
 * @param t token to join strings with
 */
function joinStrings(s1, s2, t) {
	var sReturn = "";

	if( s1.length > 0 )
		sReturn = s1 + t;
	sReturn = sReturn + s2;

   return(sReturn);
}

/**
 * Performs a hex dump of string data
 */
function HexDump(s) {
    var lines = [];
    var idx = 0;
    while (idx < s.length) {
        lines.push(HexDump2(s, idx));
        idx += 16;
    }
    return lines.join("\n");
}

function HexDump2(s, idx) {
    var count = 0;
    var s1 = "";
    var s2 = "";

    while (count < 16) {
        var index = idx + count;
        if (count && (0 == count %4))
            s1 += " ";
        if (index >= s.length) {
            s1 += "00";
        }
        else {
            var cCode = s.charCodeAt(index);
            var sCode = cCode.toString(16);
            if (sCode.length < 2)
                sCode = "0" + sCode;
            s1 += sCode;
            if (cCode <= 32) {
                s2 += ".";
            }
            else {
                s2 += s.charAt(index);
            }
        }
        ++count;
    }
    return s1 + " : " + s2;
}

////////////////////////////////////////////////////////////////////////////////
// Conversion functions

function toInteger(x) {
    var ret = parseInt(x, 10);
    if (isNaN(ret))
        ret = 0;
    return ret;
}

// Cross-browser code to retrieve the caret position in a text input control
function cb_getCaretPos(e) {
    if (!e)
        return -1;
    var ret = -1;
    if (e.selectionStart != undefined) {
        // Mozilla: nice and easy
       return e.selectionStart;
    }
    else if (undefined != e.createTextRange) {
        // IE: not so easy
        var currSel = document.selection.createRange();
        if (currSel) {
            var tr = e.createTextRange();
            ret = 0;
            while (currSel.compareEndPoints("StartToStart", tr) > 0) {
                tr.moveStart("character", 1);
                ++ret;
            }
        }
    }
    return ret;
}

// Cross-browser integer input validator
function cb_numOnly(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    if (evt) {
        return cb_decimalOnly2(evt, false, true);
    }
}

// Cross-browser integer input validator (non-negative)
function cb_numOnlyNN(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    if (evt) {
        return cb_decimalOnly2(evt, false, false);
    }
}

// Cross-browser floating-point only input validator
function cb_decimalOnly(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    if (evt) {
        return cb_decimalOnly2(evt, true, true);
    }
}

// Cross-browser floating-point only input validator (non-negative)
function cb_decimalOnlyNN(evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    if (evt) {
        return cb_decimalOnly2(evt, true, false);
    }
}

// Keypress even handler for integer / decimal fields
function cb_decimalOnly2(evt, dsPermitted, negPermitted) {
    var ret = true;
    // See whether a decimal separator is permitted (it won't be if
    // there already is one)
    var dsChar = (null == this.locale_ds) ? locale_ds : '.';
    var evtSrc = (evt.target) ? evt.target : evt.srcElement;
    var v = evtSrc ? evtSrc.value : null;
    if (evtSrc && v) {
        if (-1 != v.indexOf(dsChar))
            dsPermitted = false;
        if (-1 != v.indexOf('-'))
            negPermitted = false;
        if (negPermitted)
            negPermitted = (cb_getCaretPos(evtSrc) <= 0);
    }
    // Allow control characters along with numbers
    var permittedRanges = [[0],[48,57]];
    if (dsPermitted)
        permittedRanges.push([dsChar.charCodeAt(0)]);
    if (negPermitted)
        permittedRanges.push(["-".charCodeAt(0)]);
    var charCode = (null != evt.charCode) ? evt.charCode :
        ((evt.keyCode) ? evt.keyCode : evt.which);
    if (!cc_checkInRange(charCode, permittedRanges)) {
        if (evt.returnValue)
            evt.returnValue = false;
        else if (evt.preventDefault)
            evt.preventDefault();
        ret = false;
    }
    return ret;
}

// Checks that a character code lies within one of a number of ranges
function cc_checkInRange(charCode, ranges) {
    var ret = false;
    for (var i = 0; i < ranges.length; i++) {
        var range = ranges[i];
        if (charCode >= range[0] && charCode <= range[range.length - 1]) {
            ret = true;
            break;
        }
    }
    return ret;
}

/**
 * Restricts input in a text field to certain characters
 * @param evt an event object; may be null depending on the
 * browser
 * @param charRanges an array of strings representing contiguous character
 * ranges; e.g. A-Z is specified as "AZ"
 */
function cb_restrictInput(evt, charRanges) {
    var ret = true;
    var ccRanges = [[0]];
    // Convert the character ranges to character codes
    for (var i = 0; i < charRanges.length; i++) {
        var cr = charRanges[i];
        var ncr = cr.length;
        if (0 == ncr)
            continue;
        if (1 == ncr) {
            ccRanges.push([cr.charCodeAt(0)]);
        }
        else {
            ccRanges.push([cr.charCodeAt(0),
                cr.charCodeAt(ncr - 1)]);
        }
    }
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    if (evt) {
        var charCode = (null != evt.charCode) ? evt.charCode :
            ((evt.keyCode) ? evt.keyCode : evt.which);
        if (!cc_checkInRange(charCode, ccRanges)) {
            if (evt.returnValue)
                evt.returnValue = false;
            else if (evt.preventDefault)
                evt.preventDefault();
            ret = false;
        }
    }
    return ret;
}

// Sets fields to allow numeric-input only
function setNumeric(formName, fields, decimal, negAllowed) {
    var f = document.forms[formName];
    if (!f)
        return;
    var fn = cb_numOnlyNN;
    if (decimal) {
        fn = negAllowed ? cb_decimalOnly : cb_decimalOnlyNN;
    }
    else if (negAllowed) {
        fn = cb_NumOnly;
    }
    for (var i = 0; i < fields.length; i++) {
        var e = f.elements[fields[i]];
        if (e)
            e.onkeypress = fn;
    }
}

// Canonicalizes newline sequences to "\r\n"
function fixNewLines(s) {
    // Initially convert \r\n sequences to \n
    var a = s.split("\r\n");
    var b = a.join("\n");
    // Convert any remaining \r characters to \n
    a = b.split("\r");
    b = a.join("\n");
    // Now convert all \n characters to \r\n sequences
    a = b.split("\n");
    return a.join("\r\n");
}

// Converts an XML string to a document object
function xmlStr2DocObject(xmlStr, dataSource) {
    var doc = null;
    if (!xmlStr)
        return null;
    if (null != window.DOMParser) {
        var parser = new DOMParser();
        doc = parser.parseFromString(xmlStr, "text/xml");
    }
    else if (null != window.ActiveXObject) {
        doc = new ActiveXObject("msxml2.DOMDocument.3.0");
        doc.async = false;
        doc.resolveExternals = false;
        doc.validateOnParse = false;

        // Parse
        doc.loadXML(xmlStr);
        if (doc.parseError.errorCode != 0) {
            throw new Error(resolveString(pm_st, "__xml_parse_err", [dataSource]));
        }
    }
    return doc;
}

/**
 * Adds callbacks to form controls to do change notification
 * @param notifyFn the notification function to call; may be a Function object or
 * a string
 * @param exceptions fields that are not subject to change notification (keyed by
 * form name / field name)
 */
function addChangeNotification(notifyFn, exceptions) {
    var forms = document.forms;
    for (var i = forms.length - 1; i >= 0; i--) {
        var formName = forms[i].name;
        var elems = forms[i].elements;
        for (var j = elems.length - 1; j >= 0; j--) {
            var input = elems[j];
            var fieldName = input.name;
            if (exceptions && exceptions[formName] && exceptions[formName][fieldName])
                continue;
            addChangeNotificationToCtl(input, notifyFn);
        }
    }
}

/**
 * Adds change notification to a form control; attempts to hook the appopriate
 * event for the control type
 * @param ctl the control of interest
 * @param notifyFn the notification function to call
 */
function addChangeNotificationToCtl(ctl, notifyFn) {
    if (!ctl || !notifyFn)
        return;

    var ctlType = ctl.type;
    if (!ctlType) // Form controls should have a "type" attribute
        return;

    var evtMap = {"click":0, "keypress":0, "change":0, "paste":0, "cut":0, "focus":0};

    switch(ctlType) {
        case "checkbox":
        case "radio":
        case "select-one":
        case "selct-multiple":
            //evtMap["change"] = 1;
            evtMap["focus"] = 1;
            break;

        case "text":
        case "password":
        case "textarea":
            //evtMap["change"] = 1;
            //evtMap["keypress"] = 1;
            //evtMap["paste"] = 1;
            //evtMap["cut"] = 1;
            evtMap["focus"] = 1;
            break;

        default:
            break;
    }

    for (var evtType in evtMap) {
        try {
            if (evtMap[evtType]) {
                chainEventHandler(ctl, evtType, notifyFn);
            }
        }
        catch(e) { dumpException(e); }
    }
}


/**
 * Chains event handling on a control
 * @param ctl the control of interest
 * @param evt the event name to chain (specify, e.g., "click" rather than "onclick")
 * @param handler the function to add to the event chain
 *
 * NOTE: this function is currently used for setting modified flags when focus
 * moves to a control; while it can chain with an existing event handler for other events,
 * (e.g. "onchange"), the old handler will only work correctly if it takes a single
 * event parameter.
 *
 */
function chainEventHandler(ctl, evt, handler) {
    if (!ctl || !evt || !handler)
        return;
    var handlerFn = 'function' == typeof(handler) ? handler : new Function(handler);
    var evtKey = "on" + evt;
    var oldHandler = ctl[evtKey];

    if ('function' != typeof(ctl[evtKey])) {
        // First in the chain
        ctl[evtKey] = handlerFn;
    }
    else {
        // Create a lambda to call the old handler followed by the new handler
        ctl[evtKey] = function(windowEvent) {
            var ret = true;
            if (oldHandler)
                ret = oldHandler(windowEvent);
            if (null == ret || true == ret)
                ret = handlerFn(windowEvent);
            return ret;
        }
    }
}

/*
 * The (optional) platform specific JS file may contain functions
 * of the same name, and therefore override any function
 * in Common.js
 */
includeJS("../../js/PlatformSpecific.js");


// Default Picker for identity rules
function DefaultPicker()
{
}
DefaultPicker.prototype.Draw=function()
{
   var ctl= document.createElement("input");
   ctl.type = "text";
   ctl.className = "textField";
   ctl.id = K_IPK_CTL;
   return ctl;
}
DefaultPicker.prototype.Validate=function()
{
	return true;
}
DefaultPicker.prototype.Selection=function()
{
    return [document.getElementById(K_IPK_CTL).value];
}

// Email picker for identity rules
function ePicker()
{
}
ePicker.prototype = new DefaultPicker
ePicker.prototype.constructor = ePicker
ePicker.prototype.Validate=function()
{
	return ValidEmail(this.Selection()[0]);
}

function TooltipControl(bShow, tooltipText)
{
	if (document.getElementById("idMcToolTip"))
	   {
			dhtmlPopup = document.getElementById("idMcToolTip");
			dhtmlPopup.style.display = (bShow) ? "block" : "none";

			if (bShow)
			{
				var divTitle = document.getElementById( "idToolTipText" );
				RenderTooltip(divTitle, tooltipText);
				dhtmlPopup.style.left = (mouseX-15) + "px";
				dhtmlPopup.style.top = (mouseY+20) + "px";
			}

	   }

}

function RenderTooltip(divTitle, tooltipText)
{
	if( divTitle)
	{
			divTitle.innerHTML = tooltipText;
	}
}

function mouseTrack(e)
{
		if (e)
		{
			mouseX = e.pageX;
			mouseY = e.pageY;
		}
		else
		{
			if (event)
			{
				mouseX = event.x;
				mouseY = event.y;
			}
		}

}
function ConvertToLocaleDateFormat(srcDate)
{
	var sFormattedDate = parent.gSystemStatePB.GetProperty("systemstate.slongdate");
	if(McUndefined == sFormattedDate)
	{
		sFormattedDate = "dddd, MMMM dd, YYYY";
	}
	sFormattedDate=sFormattedDate.replace(/\'/g,"");

	var re = /dddd/
	sFormattedDate = sFormattedDate.replace(re, strDays[srcDate.getDay()]);

	re = /ddd/
	sFormattedDate = sFormattedDate.replace(re, strShortDays[srcDate.getDay()]);

	re = /dd/
	sFormattedDate = sFormattedDate.replace(re, srcDate.getDate());

	re  = /d(?![a-z])/
	sFormattedDate = sFormattedDate.replace(re, srcDate.getDate());

	re = /MMMM/
	sFormattedDate = sFormattedDate.replace(re, strMOnths[srcDate.getMonth()]);

	re = /MMM/
	sFormattedDate = sFormattedDate.replace(re, strShortMOnths[srcDate.getMonth()]);

	re = /MM/
	sFormattedDate = sFormattedDate.replace(re, srcDate.getMonth()+1);

	if(this.locale_id !="0407")
	{
		//this is to remove a specical case in german where first digit is getting replace by month number "M" is replaced with '3'
		re = /M(?![a-z])/
		sFormattedDate = sFormattedDate.replace(re, srcDate.getMonth()+1);
	}

	re = /yyyy/
	sFormattedDate = sFormattedDate.replace(re, srcDate.getFullYear());

	re = /yyy/
	sFormattedDate = sFormattedDate.replace(re, srcDate.getFullYear());

	re = /yy/
	sFormattedDate = sFormattedDate.replace(re, (srcDate.getFullYear()%100) < 10 ?  ("0" + srcDate.getFullYear()%100) : (srcDate.getFullYear()%100));

	//var xx = /y(?![a-z,\b])/
	re = /\by/
	sFormattedDate = sFormattedDate.replace(re, srcDate.getFullYear()%1000);

	return (sFormattedDate);
}

function ConvertToLocaleTimeFormat(srcTime)
{
	var sFormattedTime = 	parent.gSystemStatePB.GetProperty("systemstate.stimeformat");

	if(McUndefined == sFormattedTime)
	{
		sFormattedTime = "H:mm:ss tt";
	}

	if(sFormattedTime.search("h") != -1) //12 Hours Format
	{
		if(srcTime.getHours() == 0)
		{
			re = /hh/g; // Since the format is 'hh' need to add leading zero to hour value
			sFormattedTime = sFormattedTime.replace(re, "12");
			re = /h/g;
			sFormattedTime = sFormattedTime.replace(re, "12");
		}
		else if(srcTime.getHours() < 10) //time between 1 to 9
		{
			re = /hh/g; // Since the format is 'hh' need to add leading zero to hour value
			sFormattedTime = sFormattedTime.replace(re, "0" + srcTime.getHours());
			re = /h/g;
			sFormattedTime = sFormattedTime.replace(re, srcTime.getHours());
		}
		else if ((srcTime.getHours() > 12 && srcTime.getHours() < 22)) //time between 13 to 21
		{
			re = /hh/g; // Since the format is 'hh' need to add leading zero to hour value
			sFormattedTime = sFormattedTime.replace(re, "0" + (srcTime.getHours()-12));
			re = /h/g;
			sFormattedTime = sFormattedTime.replace(re, srcTime.getHours()-12);
		}
		else if(srcTime.getHours() >= 22)
		{
			re = /hh/g;
			sFormattedTime = sFormattedTime.replace(re, srcTime.getHours()-12);
			re = /h/g;
			sFormattedTime = sFormattedTime.replace(re, srcTime.getHours()-12);
		}
		else
		{
			re = /hh/g;
			sFormattedTime = sFormattedTime.replace(re, srcTime.getHours());
			re = /h/g;
			sFormattedTime = sFormattedTime.replace(re, srcTime.getHours());
		}
	}
	else //24 Hours Format
	{

		// for HH we need to differentiate between 0-9 and 10-23
		if(srcTime.getHours() < 10)
		{
			re = /HH/g;
			sFormattedTime = sFormattedTime.replace(re, "0" + srcTime.getHours());
		}
		else
		{
			re = /HH/g;
			sFormattedTime = sFormattedTime.replace(re, srcTime.getHours());
		}
		// for H we need not differentiate between 0-9 and 10-23
		re = /H/g;
		sFormattedTime = sFormattedTime.replace(re, srcTime.getHours());
	}

	if(srcTime.getMinutes() < 10)
	{
		re = /mm/g;
		sFormattedTime = sFormattedTime.replace(re, "0" + srcTime.getMinutes());
	}
	else
	{
		re = /mm/g;
		sFormattedTime = sFormattedTime.replace(re, srcTime.getMinutes());
	}
	re = /m/g;
	sFormattedTime = sFormattedTime.replace(re, srcTime.getMinutes());

	if(srcTime.getSeconds() < 10)
	{
		re = /ss/g;
		sFormattedTime = sFormattedTime.replace(re, "0" + srcTime.getSeconds());
	}
	else
	{
		re = /ss/g;
		sFormattedTime = sFormattedTime.replace(re, srcTime.getSeconds());
	}
	re = /s/g;
	sFormattedTime = sFormattedTime.replace(re, srcTime.getSeconds());

	re = /tt/g;
	if(srcTime.getHours() >= 12)
	{
		sFormattedTime = sFormattedTime.replace(re, "PM");
	}
	else
	{
		sFormattedTime = sFormattedTime.replace(re, "AM");
	}

	return (sFormattedTime);
}

function PSGetFilterValues(str)
{
return str;
}

function PSEscapeQueryString(str)
{
return(str);
}

function PSGetImportConfig()
{
	ImportConfig();
}

function PSGetDatabaseLocationPath(macroTableVal, path)
{
path = macroTableVal + "\\" + path;
return path;
}

function PSGetDebugLogLocationPath(macroTableVal , path)
{
path = macroTableVal + "\\" + path;
return path;
}

function PSGetPLPath(macroTableVal , path)
{
path = macroTableVal + "\\" + path;
return path;
}


//function to escape special chars(_)  with '\' for database search
function EscapeSpecialChars(value)
{
	var str="";
	var size=value.length;
	var i;

	for(i=0;i<size;i++)
	{
		if(value.charAt(i)=="_")
		{
			str+="\\_";
			
		}
		else if(value.charAt(i)=="%")
		{
			str+="\\%";
			
		}
		else
			  str+=value.charAt(i)		 
	}
	value =str;
	
	return value;
}


function GetLang()
{
	
	var lang ="0409";
	if(gIsEPO4)
		lang = top.iframeID_NAP.location.pathname.split('Locale')[1].substr(1,4);
	else
		lang = parent.gSystemStatePB.GetProperty("systemstate.langid");

    var cp = "en";
	if (lang == "2052" || lang == "0804") cp = "zh-CN";
	if (lang == "1031" || lang == "0407") cp = "de";
	if (lang == "1036" || lang == "040c" || lang == "040C") cp = "fr";
	if (lang == "1034" || lang == "040a" || lang == "040A") cp = "es";
	if (lang == "1041" || lang == "0411") cp = "ja";
	if (lang == "1028" || lang == "0404") cp = "zh-TW";
	if (lang == "1042" || lang == "0412") cp = "ko";

	return cp;

}

////////////////////////////////////////////////
//
// Generic escape and unescape
//
function McEscapeStr(strIn, protectedString)
{
	var strOut = "";
	if ( strIn == undefined ) return strOut;
	for(var i = 0; i < strIn.length; i++)
	{	
		var str = strIn.substr(i, 7);
		if(str == protectedString)
		{
			strOut += '^^'
		}
		
		strOut+=strIn.charAt(i)
	}
	return strOut
}

function EncodeXSSChars(str)
{
	var newStr="";		
	var bReplaced = false;
	
	str = McEscapeStr(str, "~mcamp~");
	str = McEscapeStr(str, "~mcgrt~");
	str = McEscapeStr(str, "~mclst~");
	str = McEscapeStr(str, "~mccln~");
	str = McEscapeStr(str, "~mcdqt~");
	str = McEscapeStr(str, "~mcbsl~");
	str = McEscapeStr(str, "~mcfsl~");


	
	//replace the special chars inside the ()
	for(var i = 0; i < str.length; i++)
	{
		var tempStr="";
		newStr += str.charAt(i);
		if(str.charAt(i) == '(')
		{
			i++;
			while(i != str.length)
			{				
				tempStr += str.charAt(i++);				
			}	
			
			tempStr += str.charAt(i);
			
			tempStr = tempStr.replace("^&", "^~mcamp~");
			newStr += tempStr.replace(/>/g, "^~mcgrt~");
			newStr = newStr.replace(/</g, "^~mclst~");
			newStr = newStr.replace(/;/g, "^~mccln~");
			newStr = newStr.replace(/\\/g, "^~mcbsl~");
			newStr = newStr.replace(/\//g, "^~mcfsl~");


			
			
			bReplaced = true;
		}		
	}
	
	if(bReplaced){
		str = newStr;		
	}
	newStr = "";
	
	//replace the special chars inside the "" 
	for(var i = 0; i < str.length; i++)
	{
		var tempStr="";
		newStr += str.charAt(i);
		if(str.charAt(i) == '"')
		{
			i++;
			while(str.charAt(i) != '"')
			{				
				tempStr += str.charAt(i++);
			}	
			
			tempStr += str.charAt(i);
			
			newStr += tempStr.replace("&", "^~mcamp~");
			newStr = newStr.replace(/>/g, "^~mcgrt~");
			newStr = newStr.replace(/</g, "^~mclst~");
			newStr = newStr.replace(/;/g, "^~mccln~");
			newStr = newStr.replace(/\\/g, "^~mcbsl~");
			newStr = newStr.replace(/\//g, "^~mcfsl~");
		}
	}
		    newStr = newStr.replace(/"/g, "^~mcdqt~");
	return newStr;
}


