//Copyright (C) 2010 McAfee, Inc.  All rights reserved.
///////////////////////////////////////////////////////
//
// Show initial settings
//
function Show(pb)
{
	var excl_pp = new PropertyPath("VSAPI2Excl.Exclusion");		
	var select = document.getElementById("mbExcluded");
		   
    excl_pp.BeginEnum();
	var exclValue;
    while(true) 
	{		
		exclValue = pb.GetProperty(excl_pp);
		if (exclValue !== undefined)
		{			
			select.options[select.options.length] = new Option(exclValue, exclValue);	
			excl_pp.IncrementEnum();			
		}
		else
		{
			break;
		}       
    }
    excl_pp.EndEnum();
}

///////////////////////////////////////////////////////
//
// Validate selections
//
function Validate()
{
	return true		
}

///////////////////////////////////////////////////////
//
// Store selections in wizard property bag
//
function Apply(pb)
{
	var select = document.getElementById("mbExcluded");
	var exclusions = [];
	for(var i=0; i < select.options.length; i++)
	{		
        exclusions.push(select.options[i].value);
    }	
	exclusions.sort();
	
	var exclPP = new PropertyPath("VSAPI2Excl.Exclusion")
    pb.DeleteList(exclPP);
    
	// Recreate the list
    var ppT = new PropertyPath(exclPP);
    ppT.BeginEnum();
	
	for(var i=0; i < exclusions.length; i++, ppT.IncrementEnum())
	{
		pb.SetProperty(ppT, exclusions[i]);        
    }	

	top.SetModified(false);
	return(pb);	
}

function AddMailExclusion()
{
	var exclusion = document.getElementById("mbToExclude").value;
	var select = document.getElementById("mbExcluded");
	
	if(exclusion == "")
	{
		alert(gsEnterMBToAdd);
	}
	
	
	if(!ValidateTextInput(exclusion))
	{
		alert(gsScriptNotAllowed);
		return;
	}

	if(!ValidateHtmlInput(exclusion))
	{
		alert(gsScriptNotAllowed);
		return;
	}	
	
	if(!ValidateAlertTextInput(exclusion))
	{
		alert(gsScriptNotAllowed);
		return;
	}
	
	for(var i=0; i < select.options.length; i++)
	{
		if(select.options[i].value.toUpperCase() == exclusion.toUpperCase())
		{
			alert(gsDuplicateExclusion);
			return;
		}
	}
	
	select.options[select.options.length] = new Option(exclusion, exclusion);	
	document.getElementById("mbToExclude").value = '';
	top.SetModified(true);
}

function RemoveMailExclusion()
{
	var select = document.getElementById("mbExcluded");
	var flag = new Array();	
	var mbDeleted = false;
	for(var i=0; i<select.options.length; i++)
	{
		flag[i] = select.options[i].selected;
	}
	
	while(i--)
	{
		if(flag[i])
		{
			select.remove(i);		
			mbDeleted = true;
		}
	}
	
	if(!mbDeleted)
		alert(gsSelectMBToRemove);
	else
		top.SetModified(true);
}
