//Copyright (C) 2005 McAfee, Inc.  All rights reserved.

var selector = null
var selectors = new Array()
var gppToAppend = "";
var labelMap = new Object();
//var bIsEPO = (typeof(gEPOMode) != "undefined" && gEPOMode)
var gP =new Picker("\\")
var pb = new PropertyBag()

var bIsEPO = true;
var gIsEPO4 = true;
var McUndefined;
var odScanSettingForm = "odscansettings_form";

function Show(pb, pp)
{
	ShowSelection(pb, pp)
}

function Apply(pb, pp)
{
	ApplySelection(pb, pp)
}

function InitializeSettings()
{
	document.getElementById("Buffer").style.display="none";

	pbIn = new PropertyBag();
	var pp = new PropertyPath("ePOTask");
	
	enumeratePB(pbIn);
	
	selectors[0] = new Selector("selector0")
	
	selector = selectors[0];
	
	var path = new PropertyPath(pp.GetPath())
	// Get allExcept value
	path.Append("What.OnDemand")
	path.SetTempLeaf("AllExcept")
	var bAllExcept =  pbIn.GetProperty(path.GetPath())
	path.SetTempLeaf("");
	
	// Load scan targets
	var path1 = new PropertyPath(pp.GetPath())

	// Get allExcept value
	path1.Append("What.OnDemand")

	path1.Append("Target")
	path1.BeginEnum()

	while (pbIn.GetProperty(path1.GetPath()) != McUndefined)
	{
		//  workspace
		path1.SetTempLeaf("Workspace")
		var workspace = pbIn.GetProperty(path1.GetPath())

		// folder
		path1.SetTempLeaf("Folder")
		var folder = pbIn.GetProperty(path1.GetPath())
		
		if( workspace )
		{
			// subfolders indicator
			path1.SetTempLeaf("Recursive")
			var recursive= pbIn.GetProperty(path1.GetPath())
			if(recursive)
				icon = "TwoStackedClosedFolders.gif";
			else
				icon = "ClosedFolder.gif";

			selector.Add(workspace + "\\" + folder, icon)
		}	
		// Move to next target
		path1.SetTempLeaf("")
		path1.IncrementEnum()	
	}		

	// Assume scan selected if any targets are present
	EnablePickers(selector.entries.length > 0)
	if (selector.entries.length > 0)
	{
		if (bAllExcept)
		{
			document.getElementById("AllExcept").checked = true
			ScanRadioSelected(true)
		}
		else 	
			document.getElementById("ScanSelected").checked = true
	}
	else
		document.getElementById("ScanAll").checked = true
}

function ApplyValues()
{
	var strSettings = "";
	//prepare folder inclusion/exclusion list in Buffer
	if (!document.getElementById("ScanAll").checked)
	{
		selector = selectors[0];

		for (var i= 0; i < selector.entries.length;i++)
		{
			strSettings += selector.entries[i].path.substr(0, selector.entries[i].path.indexOf("\\")) + "\t";
			strSettings += selector.entries[i].path.substr(selector.entries[i].path.indexOf("\\")+1) + "\t";
			strSettings += (selector.entries[i].icon != "ClosedFolder.gif") + "\r\n";			
		}
		
	}
	document.getElementById('Buffer').value=strSettings;
	/*var dummyVal;	// when we want to set the value as gValueless as opposed to undefined which can lead to faulty parsing of the Property Bag.
	var path = new PropertyPath("ePOTask");
	pb.SetProperty(path.GetPath());

	path.SetTempLeaf("Type")
	pb.SetProperty(path.GetPath(), "ScanTask")
	path.SetTempLeaf("Name")
	pb.SetProperty(path.GetPath(), "On-Demand Task")
	path.SetTempLeaf("")

	path.Append("What.OnDemand");
	// Set "AllExcepted" flag if scanning all except selected folders
	if (document.getElementById("AllExcept").checked)
	{
		path.SetTempLeaf("AllExcept")
		pb.SetProperty(path.GetPath(), true)
		path.SetTempLeaf("")
	}

	// Iterate through folder selections, if we are not scanning all
	path.Append("Target")	
	if (!document.getElementById("ScanAll").checked)
	{
		path.BeginEnum()
		selector = selectors[0];

		for (var i= 0; i < selector.entries.length;i++)
		{
			// Add root
			pb.SetProperty(path.GetPath())

			// Add workspace
			path.SetTempLeaf("Workspace")
			pb.SetProperty(path.GetPath(), selector.entries[i].path.substr(0, selector.entries[i].path.indexOf("/")))

			// Add folder
			path.SetTempLeaf("Folder")
			pb.SetProperty(path.GetPath(), selector.entries[i].path.substr(selector.entries[i].path.indexOf("/")+1))
			
			// Add subfolders indicator
			path.SetTempLeaf("Recursive")
			pb.SetProperty(path.GetPath(), selector.entries[i].icon != "ClosedFolder.gif")

			// Carry on to next folder
			path.SetTempLeaf("")
			path.IncrementEnum()
		}
	}
	*/

	/*path1 = new PropertyPath("ePOTask")
	path1.Append("What.OnDemand")

	path1.SetTempLeaf("ScanOnlyDL")
	if( document.getElementById("scanalldl").checked )
		pb.SetProperty(path1.GetPath(), "1")
	else
		pb.SetProperty(path1.GetPath(), "0")

				
	path1.SetTempLeaf("FileExtExclusions")
	var fileExtensions = document.getElementById("taFileEx").value;
	
	if(fileExtensions == "")
		pb.SetProperty(path1.GetPath(), "")
	else
	{
		var params = fileExtensions.split(";")
		var fileExt = "";
        for (var i = 0; i <= params.length - 1; i++) 
		{
            if(trim_string(params[i]) != "")
				fileExt += params[i] + ";";
        }
		
		if(fileExt == "")
			pb.SetProperty(path1.GetPath(), "");
		else
			pb.SetProperty(path1.GetPath(), fileExt.substring(0,fileExt.length-1));
	}
	path1.SetTempLeaf("ScanType")
	var ScanSelection = "";
	if( document.getElementById("ScanOff").checked )
		ScanSelection = "0"
	else if( document.getElementById("ResumeScan").checked )
		ScanSelection = "1"
	else if( document.getElementById("IncrementalScan").checked )
		ScanSelection = "2"
	pb.SetProperty(path1.GetPath(), ScanSelection)

	if(ScanSelection == "1")
	{
		// Store Resume scan settings
		path1.SetTempLeaf( "ResScanParam" )

		if( document.getElementById("ResforDatChange").checked )
			pb.SetProperty(path1.GetPath(),"Y")
		else
			pb.SetProperty(path1.GetPath(),"N")
	
		path1.SetTempLeaf( "IncScanParam")
		pb.SetProperty(path1.GetPath(),"")	
	}
	else if (ScanSelection == "2")
	{
		// Store incremental scan settings
		path1.SetTempLeaf( "IncScanParam" )

		if( document.getElementById("IncDateScan").checked )
		{
			pb.SetProperty(path1.GetPath(),"LSD")
			path1.SetTempLeaf("")
			path1.SetTempLeaf("LastScanDate")

			if((pb.GetProperty(path1.GetPath()) == "") || (pb.GetProperty(path1.GetPath()) == McUndefined))
			{
				pb.SetProperty(path1.GetPath(),"")
			}
		}
		else if( document.getElementById("IncDateSpec").checked )
		{
			pb.SetProperty(path1.GetPath(),DateToXML(FromControls("dt")))
		}
		path1.SetTempLeaf( "ResScanParam")
		pb.SetProperty(path1.GetPath(),"")	

	}
	else if(ScanSelection == "0")
	{
		path1.SetTempLeaf( "IncScanParam" )
		pb.SetProperty(path1.GetPath(), "")
		path1.SetTempLeaf( "ResScanParam" )
		pb.SetProperty(path1.GetPath(), "")
	}*/
	//populateArrays();
}

///////////////////////////////////////////////////////
//
// Enable/disable picker and buttons
//
function EnablePickers(bEnable)
{
	gP.Enable(bEnable)
	document.getElementById("addrec").disabled = !bEnable
	document.getElementById("add").disabled = !bEnable
	document.getElementById("remove").disabled = !bEnable

	//add pop up text to buttons
	var btn = document.getElementById("addrec")
	btn.title = bEnable ? gsAddFolderTree : ""
	btn = document.getElementById("add")
	btn.title = bEnable ? gsAddFolder : ""
	btn = document.getElementById("remove")
	btn.title = bEnable ? gsRemoveFolder : ""

	if( !bIsEPO ) {
		GreyUngrey("picker", !bEnable)
		GreyUngrey("selector", !bEnable)
	} else {
		for(var i = 0; i < selectors.length; ++i ){
			GreyUngrey("selector"+i, !bEnable)
			document.getElementById("idServerName"+i).disabled = !bEnable
			document.getElementById("idDbName"+i).disabled = !bEnable
		}
	}
}
function ScanRadioSelected(bExcept)
{
	var picker2Title = document.getElementById("picker2Title")
	if(bExcept)
		picker2Title.innerHTML = gsScanExcept;
	else
		picker2Title.innerHTML = gsScanSelected;
	
	EnablePickers(true)	
}
///////////////////////////////////////////////////////
//
// Validate selections
//
function Validate()
{
	// Most validation happens on the fly on this page

	//make sure we have not chosen scan selected but selected nothing
	if ( document.getElementById("ScanSelected").checked == true || document.getElementById("AllExcept").checked == true ) 
	{
		if(selector.entries.length == 0)
		{
			alert(gsScanNoFoldersSelected);
			return false
		}
			
	}
	if ( document.getElementById("ScanAll").checked == true) 
	{
		if(gP.Auth == false)
		{
			alert(gsSQLAuthenticationFailed)
			return false
		}
	}
	
	return true		
}

///////////////////////////////////////////////////////
//
// Store selections in wizard property bag
//
function ApplySelection(pb,pp)
{
	var path = new PropertyPath(pp.GetPath())
	
	path.Append("What")
	pb.DeleteElement(path)
	pb.SetProperty(path)

	//add the 'OnDemand' property
	path.Append("OnDemand")
	pb.SetProperty(path.GetPath())

	// Set "AllExcepted" flag if scanning all except selected folders
	if (document.getElementById("AllExcept").checked)
	{
		path.SetTempLeaf("AllExcept")
		pb.SetProperty(path.GetPath(), true)
		path.SetTempLeaf("")
	}
	
	// Iterate through folder selections, if we are not scanning all
	path.Append("Target")	
	if (!document.getElementById("ScanAll").checked)
	{
		path.BeginEnum()
	
		for (var i= 0; i < selector.entries.length;i++)
		{
			// Add root
			pb.SetProperty(path.GetPath())

			// Add workspace
			path.SetTempLeaf("Workspace")
			pb.SetProperty(path.GetPath(), selector.entries[i].path.substr(0, selector.entries[i].path.indexOf("/")))

			// Add folder
			path.SetTempLeaf("Folder")
			pb.SetProperty(path.GetPath(), selector.entries[i].path.substr(selector.entries[i].path.indexOf("/")+1))
			
			// Add subfolders indicator
			path.SetTempLeaf("Recursive")
			pb.SetProperty(path.GetPath(), selector.entries[i].icon != "ClosedFolder.gif")

			// Carry on to next folder
			path.SetTempLeaf("")
			path.IncrementEnum()
		}
	}

	// Set task type
	path.SetTempLeaf("What")
	pb.SetProperty(path) 
	path.SetTempLeaf("Type")
	pb.SetProperty(path,"ScanTask")
	path.SetTempLeaf("")
}

/////////////////////////////////////////////
//
// Adds folder current selected in picker
//
function AddSelectedFolder(icon)
{
	var serverCtl = document.getElementById('idServerName'+getIdSuffix())
	var dbCtl = document.getElementById('idDbName'+getIdSuffix())
	if (gP.selected == McUndefined && IsEmpty(serverCtl.value))
	{
		alert(gsSelectFolderToAdd);
		return
	}

	if( gP.selected != McUndefined )
	{
		var bFound = false;
		for (var sel in gP.selected)
		{
			bFound = true;
			var path=gP.GetPath(gP.selected[sel]);
			getSelector().Add(gP.GetPath(gP.selected[sel]),icon);
		}

		if( bFound )
		{
			gP.RemoveSelection()
		}
		else if(AddRemoteFolder(icon))
		{
			serverCtl.value = ""
			dbCtl.value = ""
		}
	}
}

/////////////////////////////////////////////
//
// Deletes item currently selected in selector
//
function RemoveSelectedFolder()
{
	if (getSelector().FirstSelection()<0)
	{
		alert(gsSelectFolderToRemove);
		return
	}
	getSelector().RemoveSelection()
}

/////////////////////////////////////////////
//
// Adds folder and server typed in by the user
//
function AddRemoteFolder(icon)
{
	var serverCtrl = document.getElementById("idServerName"+getIdSuffix())
	var dbCtrl = document.getElementById("idDbName"+getIdSuffix())

	// Remove leading/trailing whitespace from the names
	var server = serverCtrl.value
	server = server.replace(/^\s+/g, '').replace(/\s+$/g, '');
	if( IsEmpty(server) ) {
		alert(gsSelectFolderToAdd);
		return false
	}
	
	/*
	if(ValidateWebApp(server) == null)
	{
		alert(gsInValidWebApp);
		return false
	}

	if(IsEmpty(dbCtrl.value) != true)
	{
		var db = dbCtrl.value

		// Replace any whitespaces left again
		db = db.replace(/^\s+/g, '').replace(/\s+$/g, '');

		//db = db.toLowerCase();
		//var spsVersion = document.getElementById("sps2003").checked ;
		var spsVersion = false ;
		if(spsVersion == false )
			var httpRegEx = /(http|https):\/\/([^/]+)/
		else
			var httpRegEx = /([^/]+)/

		if(spsVersion == false && db.match(httpRegEx) != null )
		{
			var defaultSplit = db.split("default");

			if(defaultSplit.length > 1)
			{
				var strVal = "["
				strVal += defaultSplit[0].substring(0, defaultSplit[0].length-1) +"]"
				strVal += "/[default]"
				var sections = defaultSplit[1].split("/");

				for (var i= 0; i < sections.length;i++)
				{
					if(trim_string(sections[i]) != "")
					{
						if(i == 0)
						{
							strVal += sections[i] +"]"
						}
						else
						{
							strVal += "/["+sections[i] +"]"
						}
					}
				}
				strVal += "/"

				var strTemp = "["+server+"]" +"/" + strVal;

				for (var i= 0; i < selectors[0].entries.length;i++)
				{
					if (selectors[0].entries[i].path == strTemp)
					{
						alert(gsFolderExists);
						return;
					}		
				}
				
				getSelector().Add( "["+server+"]" + "/" + strVal,icon)
			}
			else
			{
				var lines = db.split("//");
				if(lines.length == 2)
				{
					if(lines[1].indexOf("\\",0) == -1)
					{
						var sections = lines[1].split("/");

						var strVal = "[http://"
						for (var i= 0; i < sections.length;i++)
						{
							if(trim_string(sections[i]) != "")
							{
								if(i == 0)
								{
									strVal += sections[i] +"]"
								}
								else
								{
									strVal += "/["+sections[i] +"]"
								}
							}
						}
						strVal += "/"

						var strTemp = "["+server+"]" +"/" + strVal;
						for (var i= 0; i < selectors[0].entries.length;i++)
						{
							if (selectors[0].entries[i].path == strTemp)
							{
								alert(gsFolderExists);
								return;
							}		
						}

						getSelector().Add( "["+server+"]" + "/" + strVal,icon)
					}
					else
						alert(gsInValidTarget);
				}
			}
		}
		else if(spsVersion == true && db.match(httpRegEx) != null)
		{
			var lines = db.split("//");
			if(lines.length > 1)
			{
				alert(gsInValidTarget);
			}
			else
			{
				var lines = db.split("/");
				var tmpFolder="";
				if(lines.length > 1)
				{
					for (var i= 0; i < lines.length;i++)
					{
						// Replace any whitespaces left again
						if(lines[i].length)
						{
							lines[i] = lines[i].replace(/^\s+/g, '').replace(/\s+$/g, '');
							if(lines[i].length > 0)
								tmpFolder += lines[i] + "/";
						}
					}
					db = tmpFolder;
				}
				if(db.charAt(db.length-1)!="/")
					db = db + "/";

				if(db.charAt(0)=="/")
				{
					getSelector().Add( server + db,icon)
				}
				else
				{
					getSelector().Add( server + "/" + db,icon)
				}
			}
		}
		else
		{
			alert(gsInValidTarget);
		}

	}
	else
	{
		for (var i= 0; i < selectors[0].entries.length;i++)
		{
			var strTemp = "";
			//var spsVersion = document.getElementById("sps2003").checked ;
			var spsVersion = false ;
			if(spsVersion)
				strTemp = server+"/";
			else
				strTemp = "["+server+"]/";
			if (selectors[0].entries[i].path == strTemp)
			{
				alert(gsFolderExists);
				return;
			}		
		}
		//var spsVersion = document.getElementById("sps2003").checked ;
		var spsVersion = false ;
		if(spsVersion)
			getSelector().Add( server+"/" ,icon)
		else
			getSelector().Add( "["+server+"]/" ,icon)
	}
*/
	var db = dbCtrl.value;
	getSelector().Add( server+"\\"+db ,icon)
	return true
}

function getSelector()
{

	if(document.getElementById("inclusion_div").style.display == "block")
	{
		return selectors[0];
	}
	else
	{
		alert(gsUndefinedSelector);
	}

}

function getIdSuffix()
{
	if(document.getElementById("inclusion_div").style.display == "block")
	{
		return 0;
	}
	else
	{
		alert(gsUndefinedSelectorID);
	}
}

function setSelector(tabName)
{
	if( bIsEPO ) {
		selector = (tabName == "Inclusions" ? selectors[0] : selectors[1])
	}
}

function ValidateWebApp(address)
{
	var cannonicalRegEx = /^[^/\!:*\?<>\|\^#{}%&~\+]+$/i
	//var abbreviatedRegEx = /^.+(?=\/)\/.+/
	var result = address.match(cannonicalRegEx)
	/*if( result == null ) {
		if( address.search(/^CN=/i) == -1 &&
			address.search(/\/OU=/i) == -1 &&
			address.search(/\/O=/i) == -1 &&
			address.search(/\/C=/i) == -1 && !IsEmpty(address) ) {
			result = address.match(abbreviatedRegEx)
		}
	}*/
	return result
}

function OnClickODSTRadio()
{
	EnableNoOfThreadsEditField( "idODST", document.getElementById("rad1").checked == true )
}

function EnableNoOfThreadsEditField( varControlId, bEnable )
{
	OrionCore.setEnabledById(varControlId, !bEnable);
}

function EnableIncrScan( option )
{
	if( option == 0 )
	{
		document.getElementById("dtDay").disabled = true
		document.getElementById("dtMonth").disabled = true
		document.getElementById("dtYear").disabled = true
		document.getElementById("dtHour").disabled = true
		document.getElementById("dtMin").disabled = true
		document.getElementById("IncDateScan").disabled = true
		document.getElementById("IncDateSpec").disabled = true
		document.getElementById("ResforDatChange").disabled = true
	}
	else if( option == 1 )
	{
		document.getElementById("dtDay").disabled = true
		document.getElementById("dtMonth").disabled = true
		document.getElementById("dtYear").disabled = true
		document.getElementById("dtHour").disabled = true
		document.getElementById("dtMin").disabled = true
		document.getElementById("IncDateScan").disabled = true
		document.getElementById("IncDateSpec").disabled = true
		document.getElementById("ResforDatChange").disabled = false
	}
	else if( option == 2 )
	{
		if(document.getElementById("IncDateSpec").checked)
		{
			document.getElementById("dtDay").disabled = false
			document.getElementById("dtMonth").disabled = false
			document.getElementById("dtYear").disabled = false
			document.getElementById("dtHour").disabled = false
			document.getElementById("dtMin").disabled = false
		}
		else
		{
			document.getElementById("dtDay").disabled = true
			document.getElementById("dtMonth").disabled = true
			document.getElementById("dtYear").disabled = true
			document.getElementById("dtHour").disabled = true
			document.getElementById("dtMin").disabled = true
		}
		document.getElementById("IncDateScan").disabled = false
		document.getElementById("IncDateSpec").disabled = false
		document.getElementById("ResforDatChange").disabled = true
	}
}
function checkDate( option)
{
	if(option == 0 )
	{
		document.getElementById("dtDay").disabled = true
		document.getElementById("dtMonth").disabled = true
		document.getElementById("dtYear").disabled = true
		document.getElementById("dtHour").disabled = true
		document.getElementById("dtMin").disabled = true
	}
	else if (option == 1 )
	{
		document.getElementById("dtDay").disabled = false
		document.getElementById("dtMonth").disabled = false
		document.getElementById("dtYear").disabled = false
		document.getElementById("dtHour").disabled = false
		document.getElementById("dtMin").disabled = false
	}
}

function populateArrays(){
    var outString = ""
    // Iterate through properties
    for (var a in pb.propValues)
    {
        // Add name to output string
        outString += WriteValue(a);

        // Add value to output string
        outString += WriteValue(pb.GetProperty(a));
    }
	var Buffer = document.getElementById("Buffer");
    Buffer.value=outString;
}

////////////////////////////////////////////////
//
// Adds value to output string with length
//
function WriteValue(value)
{
    if (value == gValueless)
        return "ffffffff";
    else
    {
        // Get length as 8 char hex string
        var length = 0;
        if (typeof value != "string")
        {
            var temp = "" + value;
            length = temp.length;
        }
        else {
            // Replace naked \n or \r characters with \r\n sequences
            while (-1 != value.indexOf('\r\n')) {
                value = value.replace('\r\n', "\n");
            }
            while (-1 != value.indexOf('\r')) {
                value = value.replace('\r', "\n");
            }
            var lines = value.split("\n");
            if (lines.length > 1) {
                value = lines.join("\r\n");
            }
            length = value.length;
        }
        var temp2 = length.toString(10)
        while (temp2.length < 8)
            temp2 = "0" + temp2
        /*if (typeof value == "string")
            alert("Length: " + length + "\n" + HexDump(value));*/
        return temp2 + value
    }
}
// Input restrictions for the file name patterns
function fnCheckInput(evt) {

    return cb_restrictInput(evt, ["AZ", "az", "09", "!", "#)", "+-",
        ";", "=", "@", "[", "]`", "{", "}", "~"]);
}

function textCounter(field,cntfield,maxlimit) 
{
	if (field.value.length > maxlimit) 
		field.value = field.value.substring(0, maxlimit);
	else
		cntfield.value = maxlimit - field.value.length;
}

////////////////////////////////////////////////////////////
//
// Initalize datatime controls using given date
//
function InitDTControls(idRoot, date)
{
	// Min
	var ctrl = document.getElementById(idRoot+"Min")
	var mins = date.getMinutes()
	for (var i =1; i <= 59; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(FormatNum(i,2))
		opt.appendChild(name)
		if (i==mins)
			opt.selected=true
		ctrl.appendChild(opt)	
	}

	// Hour
	var ctrl = document.getElementById(idRoot+"Hour")
	var hour = date.getHours()
	for (var i =1; i <= 23; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(FormatNum(i,2))
		opt.appendChild(name)
		if (i==hour)
			opt.selected=true
		ctrl.appendChild(opt)	
	}

	// Day
	var month = date.getMonth()
	var year = date.getFullYear()
	var numDays = getMonthLength(month+1,year)
	var ctrl = document.getElementById(idRoot+"Day")
	var day = date.getDate()
	for (var i =2; i <= numDays; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		if (i==day)
			opt.selected=true
		ctrl.appendChild(opt)	
	}
		
	// Month
	var ctrl = document.getElementById(idRoot+"Month")
	ctrl.selectedIndex = month 
	
	// Year
	var ctrl = document.getElementById(idRoot+"Year")
	for (var i =2005; i < 2021; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		if (i==year)
			opt.selected=true
		ctrl.appendChild(opt)
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
//
// determine monthLength
//
function getMonthLength(cMonth,cYear)
{
	if (cMonth==1 || cMonth==3 || cMonth==5 || cMonth==7 || cMonth==8 || cMonth==10 || cMonth==12)
		monthLength = 31
	else
		if (cMonth==4 || cMonth==6 || cMonth==9 || cMonth==11)
			monthLength = 30
		else
			if (cYear % 100 == 0)
				monthLength = (cyear % 400 == 0) ? 29 : 28
			else
				if (cYear % 4 == 0)
					monthLength = 29
				else
					monthLength = 28;

       return monthLength
}
////////////////////////////////////////////////
//
// Retrieves value from dt controls
// and returns as a Date object
//
function FromControls(idRoot)
{
	if (idRoot==McUndefined)
		idRoot = gIdRoot
	var dt = new Date()
	dt.setDate(document.getElementById(idRoot+"Day").selectedIndex+1)
	dt.setMonth(document.getElementById(idRoot+"Month").selectedIndex)
	dt.setFullYear(document.getElementById(idRoot+"Year").selectedIndex+2004)		
	dt.setHours(document.getElementById(idRoot+"Hour").selectedIndex)
	dt.setMinutes(document.getElementById(idRoot+"Min").selectedIndex)
	dt.setSeconds( 0 )
	return dt
}

//////////////////////////////////////////////////////////
//
// Updates days in month on month change
//
function OnMonthChange(idRoot, selectedDay)
{
	if (typeof selectedDay == "undefined") {
		selectedDay = document.getElementById(idRoot+"Day").selectedIndex
	}
	var month= document.getElementById(idRoot+"Month").selectedIndex
	var year= document.getElementById(idRoot+"Year").selectedIndex
	
	var numDays = getMonthLength(month+1,year+2004)
	var ctrl = document.getElementById(idRoot+"Day")
	while (ctrl.childNodes.length > 0)
	{
		ctrl.removeChild(ctrl.childNodes[0])
	}

	for (var i =1; i <= numDays; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		ctrl.appendChild(opt)
		if (i == selectedDay+1)
		    opt.selected=true
	}	
}
function DisableSchedular(bEnable)
{
	if(bEnable)
	{
		document.getElementById("taFileEx").disabled = true
		document.getElementById("ResumeScan").disabled = true
		document.getElementById("IncrementalScan").disabled = true
		document.getElementById("ScanOff").checked = true
		EnableIncrScan(0);
	}
	else
	{
		document.getElementById("taFileEx").disabled = false
		document.getElementById("ResumeScan").disabled = false
		document.getElementById("IncrementalScan").disabled = false
	}
}