//Copyright (C) 2016 McAfee, Inc. All rights reserved.
// Validators
var vfOnAccess		= new ValidationFramework("onaccessForm");

var labelMap = new Object();
labelMap["Timeout"] = gsScanTimeoutString;
labelMap["OASRollingLAgeLmt"] = gsLowerAgeLimit;

function Show(pbIn)
{
	// Initialize validators
	var rv = new RequiredValidator();
	var nv = new NumericValidator();	

	var rangeVtor = new RangeValidator(1, 5000);
	var OAScanLowerAgeLimitRangeVtor = new RangeValidator(1, 2147483647);
	var rangeMailSize = new RangeValidator(1, 9999);
//	var cvScanTimeout	= new CrossValidator("value >= 0 && value <= 5000", gsScanTimeout); 

	vfOnAccess.addValidator("Timeout", rv);
	vfOnAccess.addValidator("Timeout", nv);
	vfOnAccess.addValidator("Timeout", rangeVtor);
//	vfOnAccess.addValidator("Timeout", cvScanTimeout);

	setNumeric("onaccessForm", ["Timeout"], true, false);
	vfOnAccess.addValidator("MailSizeLimit", nv);
	vfOnAccess.addValidator("MailSizeLimit", rangeMailSize);

	vfOnAccess.addValidator("OASRollingLAgeLmt", rv);
	vfOnAccess.addValidator("OASRollingLAgeLmt", nv);
	vfOnAccess.addValidator("OASRollingLAgeLmt", OAScanLowerAgeLimitRangeVtor);

//	vfOnAccess.addValidator("Timeout", cvScanTimeout);

//	setNumeric("onaccessForm", ["OnAccessScanningRollingLowerAgeLimit"], true, false);

	vfOnAccess.labelMap = labelMap;
    vfOnAccess.formAction = std_val_form_action;
	vfOnAccess.fieldAction = std_val_field_action;
	
	if (top.gPageStack.ReturnedFrom() == McUndefined)
	{
		top.gPB.GetElement("Scheduler",pbIn)
 	}
			
	var pp = new PropertyPath("VSAPI2")
	
	// General settings	
      
      //hide the Bidirectional check box
      var chkBox=document.getElementById("asg")
      chkBox.style.display='none';

	pp.SetTempLeaf("Enabled")
	document.getElementById("Enabled").checked = pbIn.GetProperty(pp)

	pp.SetTempLeaf("Transport")
	document.getElementById("TransportScan").checked = pbIn.GetProperty(pp)

	/*var mode = document.getElementById("Mode")
	if (mode != McUndefined)
	{
		mode.selectedIndex = parseInt(pbIn.GetProperty(pp),10)
    	}*/
		
	pp.SetTempLeaf("OnFail")
	document.getElementById("oa_generic_disabledmsg").style.display = "none"
	switch (pbIn.GetProperty(pp))
	{
		case 0:
			document.getElementById("OnFail").selectedIndex = 0
		break
		case 6:
			document.getElementById("OnFail").selectedIndex = 1
			document.getElementById("oa_generic_disabledmsg").style.display = ""
		break
		default:
			document.getElementById("OnFail").selectedIndex = 0
		break
	}
	
	pp.SetTempLeaf("OnProductFail")
	document.getElementById("oa_product_disabledmsg").style.display = "none"
	switch (pbIn.GetProperty(pp))
	{
		case 0:
			document.getElementById("OnProductFail").selectedIndex = 0
		break
		case 6:
			document.getElementById("OnProductFail").selectedIndex = 1
			document.getElementById("oa_product_disabledmsg").style.display = ""
		break
		default:
			document.getElementById("OnProductFail").selectedIndex = 0
		break
	}
	
	
// Lower Age Limit -----------------

	pp.SetTempLeaf("BackgroundScanningLowerAgeLimit")
	var lDate=XMLToDate(pbIn.GetProperty(pp));
	var hours=FormatNum(lDate.getHours(),2);

	document.getElementById("lrDay").selectedIndex=lDate.getDate() - 1;
	document.getElementById("lrMonth").selectedIndex=lDate.getMonth();
	document.getElementById("lrYear").selectedIndex= lDate.getFullYear() -  2003;
	document.getElementById("lrHour").selectedIndex=hours;
	document.getElementById("lrMin").selectedIndex=FormatNum(lDate.getMinutes(),2);
	document.getElementById("lrSec").selectedIndex=FormatNum(lDate.getSeconds(),2);

// End of Lower Age Limit -------------

// Upper Age Limit -----------------
	pp.SetTempLeaf("TillDate")
	document.getElementById("TillDate").checked = pbIn.GetProperty(pp)	
	if (document.getElementById("TillDate").checked == true)
	{
		var dateControls = new Array("urDay","urMonth","urYear","urHour","urMin","urSec");
		for(var i=0;i<dateControls.length;i++)
		{
			var id = dateControls[i];
			document.getElementById(id).disabled = true;
		}
	}
	//else
	//{
	pp.SetTempLeaf("BackgroundScanningUpperAgeLimit")
	var uDate=XMLToDate(pbIn.GetProperty(pp));
	var uhours=FormatNum(uDate.getHours(),2);


	document.getElementById("urDay").selectedIndex=uDate.getDate() - 1;
	document.getElementById("urMonth").selectedIndex=uDate.getMonth();
	document.getElementById("urYear").selectedIndex= uDate.getFullYear() -  2003;
	document.getElementById("urHour").selectedIndex=uhours;
	document.getElementById("urMin").selectedIndex=FormatNum(uDate.getMinutes(),2);
	document.getElementById("urSec").selectedIndex=FormatNum(uDate.getSeconds(),2);	
	//}

// End of Upper Age Limit -------------
	
	// VSAPI config
	pp.SetTempLeaf("Proactive")
	document.getElementById("Proactive").checked = pbIn.GetProperty(pp)

	 pp.SetTempLeaf("Transport")
	if(pbIn.GetProperty(pp))
		document.getElementById("TransportScan").checked = true 
	else
		document.getElementById("TransportScan").checked = false

	document.getElementById("TransportScan").checked = pbIn.GetProperty(pp)

	pp.SetTempLeaf("Background")
	document.getElementById("Background").checked = pbIn.GetProperty(pp)

	pp.SetTempLeaf("TransportExclusion")
	document.getElementById("OutBox").checked = (!pbIn.GetProperty(pp))

	pp.SetTempLeaf("BackgroundScanningAttachmentMessagesOnly")
	document.getElementById("msgWithAttch").checked = pbIn.GetProperty(pp)

	pp.SetTempLeaf("BackgroundScanningOnlyUnscanned")
	document.getElementById("onlyUnscanned").checked = pbIn.GetProperty(pp)

	pp.SetTempLeaf("UpdateTransportAVStamp")
	document.getElementById("trnsptScanStmp").checked = pbIn.GetProperty(pp)

	pp.SetTempLeaf("BackgroundScanningIgnoreStamp")
	document.getElementById("forceScanAll").checked = pbIn.GetProperty(pp)

	pp.SetTempLeaf("BackgroundScanningSkipStampUpdate")
	document.getElementById("uptdScanStmp").checked = pbIn.GetProperty(pp)

/*	var translevel = document.getElementById("Translevel")
	if (translevel != McUndefined)
	{
		pp.SetTempLeaf("TransportAVAPI")
		translevel.checked = pbIn.GetProperty(pp)
	}
*/

	pp.SetTempLeaf("Timeout")
	document.getElementById("Timeout").value = pbIn.GetProperty(pp)
	
	pp.SetTempLeaf("OnAccessScanningRollingLowerAgeLimit")
	document.getElementById("OASRollingLAgeLmt").value = pbIn.GetProperty(pp)

	pp.SetTempLeaf("Threads")
	var threads1 = pbIn.GetProperty(pp)
	if (threads1 == -1)
	{
		document.getElementById("DefaultThreads").checked = true
	}
	else
	{
		document.getElementById("DefaultThreads").checked = false
		document.getElementById("Threads").value = pbIn.GetProperty(pp)
		
	}

	EnableControl("Threads",!document.getElementById("DefaultThreads").checked && this.bEnabled)
	
	pp.SetTempLeaf("ExcludeLargeEmailScan")
	var ExcludeLargeEmailScan = pbIn.GetProperty(pp)
	document.getElementById("ExcludeLargeEmailScan").checked = ExcludeLargeEmailScan
	
	if(ExcludeLargeEmailScan==false)
	{
		document.getElementById("MailSizeLimit").disabled = true
		document.getElementById("MailSizeMBKB").disabled = true
	}
		
	pp.SetTempLeaf("MailSizeLimit")
	document.getElementById("MailSizeLimit").value = pbIn.GetProperty(pp)
	
	pp.SetTempLeaf("MailSizeMBKB")
	var MBKB = pbIn.GetProperty(pp)
	if(MBKB=="MB")
	{
		document.getElementById("MailSizeMBKB").selectedIndex = 1 //index for MB
	}
	else
	if(MBKB=="KB")
	{
		document.getElementById("MailSizeMBKB").selectedIndex = 0 //index for KB
	}
	
	/////////DBS changes - BEGIN
	//The state(check/uncheck) of the DBS check boxes should be based on their values in XML.
		pp.SetTempLeaf("DBS_Inbound")
			document.getElementById("DBSInbound").checked = pbIn.GetProperty(pp)

		pp.SetTempLeaf("DBS_Outbound")
			document.getElementById("DBSOutbound").checked = pbIn.GetProperty(pp)


		pp.SetTempLeaf("DBS_Internal")
			document.getElementById("DBSInternal").checked = pbIn.GetProperty(pp)
	/////////DBS changes - END

	
	pp.SetTempLeaf("")
	///////Now do the Grey/Ungrey stuffs
	setVSAPI();//vsapi settings will take care of background settings
	//setTransport();
      showTransport();
	
	DisableControlsAsPerExRole()
	// if(gIsEPO4)
    // {		
		// document.getElementById("UsrJunkFldrRouting_div").style.display = "inline";
		// pp.SetTempLeaf("SpamUserRouting")
		// document.getElementById("spamuserrouting").checked = pbIn.GetProperty(pp);		
	// }	
}

function Validate()
{	
	if(document.getElementById("Background").checked == true)
	{
		var year = parseInt(document.getElementById("lrYear").selectedIndex + 2003,10)
		var month = document.getElementById("lrMonth").selectedIndex
		var day = document.getElementById("lrDay").selectedIndex + 1 

	// Create Date Object		
		var dt	  = new Date( year, month, day )
		var hours = document.getElementById("lrHour").selectedIndex	
		
		dt.setHours(hours)
		dt.setMinutes(document.getElementById("lrMin").selectedIndex)
		dt.setSeconds(document.getElementById("lrSec").selectedIndex)

	// End of Lower Age Limit Apply -------------

	// Upper Age Alias ToDate-----------------  
		if(document.getElementById("TillDate").checked == true)
		{
			//check the lower age less than current date
			var today = new Date();
			if (dt > today)
			{
				alert(gsVSAPI2UpperAgeLimitWithTillDate);
				setTimeout("_set_focus(\"onaccessForm\", \"lrDay\")", 200);
				return false;
			}
		}
		else
		{
				var uyear = parseInt(document.getElementById("urYear").selectedIndex + 2003,10)
				var umonth = document.getElementById("urMonth").selectedIndex
				var uday = document.getElementById("urDay").selectedIndex + 1 

			// Create Date Object			
				var udt	  = new Date( uyear, umonth, uday )
				var uhours = document.getElementById("urHour").selectedIndex 
				
			
				udt.setHours(uhours)
				udt.setMinutes(document.getElementById("urMin").selectedIndex)
				udt.setSeconds(document.getElementById("urSec").selectedIndex)
				//validate date with lower age
				if(dt > udt)
				{
					alert(gsVSAPI2UpperAgeLimitWithoutTillDate);
					setTimeout("_set_focus(\"onaccessForm\", \"urDay\")", 200);
					return false;
				}
		}		
	}

	if(document.getElementById("DefaultThreads").checked == false)
	{
		var OAThreads = document.getElementById("Threads").value
		if( OAThreads < 1 || OAThreads > 50)
		{
			alert(gsVSAPINoOfScanThreads)
			setTimeout("_set_focus(\"onaccessForm\", \"Threads\")", 200);
			return false;
		}
	}
	else
	{
		document.getElementById("Threads").value = ""
	}

	return(vfOnAccess.onsubmit());
}

function Apply(pb)
{    
	if(document.getElementById("DefaultThreads").checked == false)
	{
		var OAThreads = document.getElementById("Threads").value
		if(isNaN(OAThreads))
		{
		alert(gsVSAPINoOfScanThreads)
		return false;
		}
	}
	var pp = new PropertyPath("VSAPI2")
	pb.SetProperty(pp);
	pp.SetTempLeaf("Enabled");
	pb.SetProperty(pp, document.getElementById("Enabled").checked);
	

/*	var mode = document.getElementById("Mode")
	if (mode != McUndefined)
	{
		pp.SetTempLeaf("Transport")
		pb.SetProperty(pp,mode.selectedIndex)
	}
*/

	pp.SetTempLeaf("OnFail")	
	switch (document.getElementById("OnFail").selectedIndex)
	{
		case 0:
			pb.SetProperty(pp,0)
		break
		case 1:
			pb.SetProperty(pp,6)
		break
		default:
			pb.SetProperty(pp,0)
		break
	}
	
	pp.SetTempLeaf("OnProductFail")	
	switch (document.getElementById("OnProductFail").selectedIndex)
	{
		case 0:
			pb.SetProperty(pp,0)
		break
		case 1:
			pb.SetProperty(pp,6)
		break
		default:
			pb.SetProperty(pp,0)
		break
	}

// Lower Age Alias FromDate-----------------    

	pp.SetTempLeaf("BackgroundScanningLowerAgeLimit");

	var year = parseInt(document.getElementById("lrYear").selectedIndex + 2003,10)
	var month = document.getElementById("lrMonth").selectedIndex
	var day = document.getElementById("lrDay").selectedIndex + 1 

// Create Date Object	
	
    var dt	  = new Date( year, month, day )

	var hours = document.getElementById("lrHour").selectedIndex 
	
	
	dt.setHours(hours)
	dt.setMinutes(document.getElementById("lrMin").selectedIndex)
	dt.setSeconds(document.getElementById("lrSec").selectedIndex)

	pb.SetProperty(pp,DateToXML(dt))

// End of Lower Age Limit Apply -------------

// Upper Age Alias ToDate-----------------  
	pp.SetTempLeaf("TillDate");
	pb.SetProperty(pp,document.getElementById("TillDate").checked)
	pp.SetTempLeaf("BackgroundScanningUpperAgeLimit");
	var uyear = parseInt(document.getElementById("urYear").selectedIndex + 2003,10)
	var umonth = document.getElementById("urMonth").selectedIndex
	var uday = document.getElementById("urDay").selectedIndex + 1 

// Create Date Object			
	var udt	  = new Date( uyear, umonth, uday )
	var uhours = document.getElementById("urHour").selectedIndex 
	


	udt.setHours(uhours)
	udt.setMinutes(document.getElementById("urMin").selectedIndex)
	udt.setSeconds(document.getElementById("urSec").selectedIndex)
	pb.SetProperty(pp,DateToXML(udt))
// End of Upper Age Limit Apply -------------

	// VSAPI Settings
	pp.SetTempLeaf("Proactive")
	pb.SetProperty(pp,document.getElementById("Proactive").checked )

	 pp.SetTempLeaf("Transport")
	pb.SetProperty(pp,document.getElementById("TransportScan").checked )
	if(pp,document.getElementById("TransportScan").checked)
		pb.SetProperty(pp,1)
	else
		pb.SetProperty(pp,0)

	pp.SetTempLeaf("Background")
	pb.SetProperty(pp,document.getElementById("Background").checked)

	pp.SetTempLeaf("TransportExclusion")
	pb.SetProperty(pp,(!document.getElementById("OutBox").checked))

	pp.SetTempLeaf("BackgroundScanningAttachmentMessagesOnly")
	pb.SetProperty(pp,document.getElementById("msgWithAttch").checked)

	pp.SetTempLeaf("BackgroundScanningOnlyUnscanned")
	pb.SetProperty(pp,document.getElementById("onlyUnscanned").checked)

	pp.SetTempLeaf("UpdateTransportAVStamp")
	pb.SetProperty(pp,document.getElementById("trnsptScanStmp").checked)

	pp.SetTempLeaf("BackgroundScanningIgnoreStamp")
	pb.SetProperty(pp,document.getElementById("forceScanAll").checked)

	pp.SetTempLeaf("BackgroundScanningSkipStampUpdate")
	pb.SetProperty(pp,document.getElementById("uptdScanStmp").checked)

	/*var translevel = document.getElementById("Translevel")
	if (translevel != McUndefined)
	{
		pp.SetTempLeaf("TransportAVAPI")
		pb.SetProperty(pp,translevel.checked)
	}*/

	pp.SetTempLeaf("OnAccessScanningRollingLowerAgeLimit")
	pb.SetProperty(pp,document.getElementById("OASRollingLAgeLmt").value)
	
	pp.SetTempLeaf("ExcludeLargeEmailScan")
	pb.SetProperty(pp,document.getElementById("ExcludeLargeEmailScan").checked )
	
	pp.SetTempLeaf("MailSizeMBKB")
	var MBKBElement = document.getElementById("MailSizeMBKB")
	var MBKBOption = MBKBElement.options[MBKBElement.selectedIndex].text // either MB or KB
	pb.SetProperty(pp,MBKBOption)
		
	pp.SetTempLeaf("MailSizeLimit")
	pb.SetProperty(pp,document.getElementById("MailSizeLimit").value)

	pp.SetTempLeaf("Timeout")
	pb.SetProperty(pp,document.getElementById("Timeout").value)
//	pb.SetProperty(pp.GetPath(),parseInt(document.getElementById("Timeout").value,10))
	
	pp.SetTempLeaf("Threads")
	if (document.getElementById("DefaultThreads").checked)
		pb.SetProperty(pp,-1)		
	else
		pb.SetProperty(pp,document.getElementById("Threads").value)
	
	
	/////////DBS changes - BEGIN
	pp.SetTempLeaf("DBS_Inbound")
	pb.SetProperty(pp,document.getElementById("DBSInbound").checked )

	pp.SetTempLeaf("DBS_Outbound")
	pb.SetProperty(pp,document.getElementById("DBSOutbound").checked )

	pp.SetTempLeaf("DBS_Internal")
	pb.SetProperty(pp,document.getElementById("DBSInternal").checked )
	/////////DBS changes - END
	
	pp.SetTempLeaf("SpamUserRouting")
	pb.SetProperty(pp, document.getElementById("spamuserrouting").checked ? 1 : 0)
	
	pp.SetTempLeaf("");

	top.SetModified(false);
	return(pb);
}

function OnBackgroundCheck()
{
	var pbInTemp;
	pbInTemp=top.gPageStack.Active().pb;

	// VSAPI Settings
	var pp = new PropertyPath("VSAPI2");
	pbInTemp.SetProperty(pp);

	pp.SetTempLeaf("Background");
	pbInTemp.SetProperty(pp, document.getElementById("Background").checked)
	
	pp.SetTempLeaf("BackgroundScanningAttachmentMessagesOnly")
	pbInTemp.SetProperty(pp,document.getElementById("msgWithAttch").checked)

	pp.SetTempLeaf("BackgroundScanningOnlyUnscanned")
	pbInTemp.SetProperty(pp,document.getElementById("onlyUnscanned").checked)

	pp.SetTempLeaf("UpdateTransportAVStamp")
	pbInTemp.SetProperty(pp,document.getElementById("trnsptScanStmp").checked)

	pp.SetTempLeaf("BackgroundScanningIgnoreStamp")
	pbInTemp.SetProperty(pp,document.getElementById("forceScanAll").checked)

	pp.SetTempLeaf("BackgroundScanningSkipStampUpdate")
	pbInTemp.SetProperty(pp,document.getElementById("uptdScanStmp").checked)

	pp.SetTempLeaf("Enabled");
	pbInTemp.SetProperty(pp, document.getElementById("Enabled").checked);

	pp.SetTempLeaf("OnFail")	
	switch (document.getElementById("OnFail").selectedIndex)
	{
		case 0:
			pbInTemp.SetProperty(pp,0)
		break
		case 1:
			pbInTemp.SetProperty(pp,6)
		break
		default:
			pbInTemp.SetProperty(pp,0)
		break
	}

	pp.SetTempLeaf("Proactive")
	pbInTemp.SetProperty(pp,document.getElementById("Proactive").checked )

	pp.SetTempLeaf("Background")
	pbInTemp.SetProperty(pp,document.getElementById("Background").checked)

	pp.SetTempLeaf("Timeout")
	pbInTemp.SetProperty(pp,document.getElementById("Timeout").value)

	pp.SetTempLeaf("Threads")
	if (document.getElementById("DefaultThreads").checked)
		pbInTemp.SetProperty(pp,-1)		
	else
		pbInTemp.SetProperty(pp,document.getElementById("Threads").value)

	pp.SetTempLeaf("Transport")

	var state=(document.getElementById("TransportScan").checked) ? 1 :0;
	pbInTemp.SetProperty(pp,state)
	
	pp.SetTempLeaf("OnAccessScanningRollingLowerAgeLimit")
	pbInTemp.SetProperty(pp,document.getElementById("OASRollingLAgeLmt").value)

	pp.SetTempLeaf("Timeout")
	pbInTemp.SetProperty(pp,document.getElementById("Timeout").value)
	
	pp.SetTempLeaf("Threads")
	if (document.getElementById("DefaultThreads").checked)
		pbInTemp.SetProperty(pp,-1)		
	else
		pbInTemp.SetProperty(pp,document.getElementById("Threads").value)

	pp.SetTempLeaf("DBS_Inbound")
	pbInTemp.SetProperty(pp,document.getElementById("DBSInbound").checked )

	pp.SetTempLeaf("DBS_Outbound")
	pbInTemp.SetProperty(pp,document.getElementById("DBSOutbound").checked )

	pp.SetTempLeaf("DBS_Internal")
	pbInTemp.SetProperty(pp,document.getElementById("DBSInternal").checked )
	
	// Lower Age Alias FromDate-----------------    

	pp.SetTempLeaf("BackgroundScanningLowerAgeLimit");

	var year = parseInt(document.getElementById("lrYear").selectedIndex + 2003,10)
	var month = document.getElementById("lrMonth").selectedIndex
	var day = document.getElementById("lrDay").selectedIndex + 1 

	// Create Date Object	
	
    var dt	  = new Date( year, month, day )
	var hours = document.getElementById("lrHour").selectedIndex 

	
	dt.setHours(hours)
	dt.setMinutes(document.getElementById("lrMin").selectedIndex)
	dt.setSeconds(document.getElementById("lrSec").selectedIndex)

	pbInTemp.SetProperty(pp,DateToXML(dt))

	// End of Lower Age Limit Apply -------------

	// Upper Age Alias ToDate-----------------  
	pp.SetTempLeaf("TillDate");
	pbInTemp.SetProperty(pp,document.getElementById("TillDate").checked)
	pp.SetTempLeaf("BackgroundScanningUpperAgeLimit");
	var uyear = parseInt(document.getElementById("urYear").selectedIndex + 2003,10)
	var umonth = document.getElementById("urMonth").selectedIndex
	var uday = document.getElementById("urDay").selectedIndex + 1 

	// Create Date Object			
	var udt	  = new Date( uyear, umonth, uday )
	var uhours = document.getElementById("urHour").selectedIndex 
	
	udt.setHours(uhours)
	udt.setMinutes(document.getElementById("urMin").selectedIndex)
	udt.setSeconds(document.getElementById("urSec").selectedIndex)
	pbInTemp.SetProperty(pp,DateToXML(udt))
	// End of Upper Age Limit Apply -------------

	pp.SetTempLeaf("");
}

function WarnIfDisableVSAPI ()
{
	if (!document.getElementById("Enabled").checked)
	{
		alert(gsVSAPI2Disabled)
	}
}

function WarnIfEnableTransportAVAPI ()
{
	var translevel = document.getElementById("Translevel")
	if (translevel != McUndefined && translevel.checked)
	{
		alert(gsTransAVAPIEnabled)
	}
}

function setBackground()
{
     var bState=!(document.getElementById("Background").checked) ? true : false;
     

     ctlList=new Array("msgWithAttch","onlyUnscanned","forceScanAll","uptdScanStmp",
						"lrDay","lrMonth","lrYear","lrHour","lrMin","lrSec",
						"urDay","urMonth","urYear","urHour","urMin","urSec","TillDate")
     for(var i=0;i<ctlList.length;i++)
     {
         var word=ctlList[i];
         
         var ctl=document.getElementById(word);
         ctl.disabled=bState;
     }

	if (document.getElementById("TillDate").checked == true)
	{
		var dateControls = new Array("urDay","urMonth","urYear","urHour","urMin","urSec");
		for(var i=0;i<dateControls.length;i++)
		{
			var id = dateControls[i];
			document.getElementById(id).disabled = true;
		}
	}
}

function setTransport()
{
    //check for disabling Transport Scan
    var svrRole=parent.gSystemStatePB.GetProperty("systemstate.exsvrrole");

    if(svrRole==0 || svrRole==2 || svrRole==4 || gIsEPO4)
    {
        if((document.getElementById("TransportScan").checked)==false)
        {
            var bAns=confirm(gsTransDisableWarning);
            if(bAns==false)
            {
                document.getElementById("TransportScan").checked=true;
                return;
            }        
        }
    }
   
    var bState=!(document.getElementById("TransportScan").checked) ? true : false;

    ctlList=new Array("trnsptScanStmp","DBSInbound","DBSOutbound","DBSInternal")
     
    for(var i=0;i<ctlList.length;i++)
    {
        var word=ctlList[i];
        var ctl=document.getElementById(word);
        ctl.disabled=bState;
     }

}

function showTransport()
{
    var bState=!(document.getElementById("TransportScan").checked) ? true : false;

    ctlList=new Array("trnsptScanStmp","DBSInbound","DBSOutbound","DBSInternal")
     
    for(var i=0;i<ctlList.length;i++)
    {
        var word=ctlList[i];
        var ctl=document.getElementById(word);
        ctl.disabled=bState;
    }
}


function setVSAPI()
{
    var bState=!(document.getElementById("Enabled").checked) ? true : false;

    ctlList=new Array("Proactive","OutBox","OASRollingLAgeLmt","Timeout","DefaultThreads")
     
    for(var i=0;i<ctlList.length;i++)
    {
        var word=ctlList[i];
        var ctl=document.getElementById(word);
        ctl.disabled=bState;
     }
     
     var defthread=document.getElementById("DefaultThreads");
     
     if(!defthread.checked)//if unchek disable the num thread field
     {
         var numthread=document.getElementById("Threads");
         numthread.disabled=bState;
         GreyUngrey('Threads',bState)
     }
     setBackgroundThroughVSAPI(bState);
        
}

function setBackgroundThroughVSAPI(bVSAPIState)
{
     
     if(bVSAPIState) //if VSAPI disabled, disable all background scan
     {
          ctlList=new Array("Background","msgWithAttch","onlyUnscanned","forceScanAll","uptdScanStmp",
							"lrDay","lrMonth","lrYear","lrHour","lrMin","lrSec",
							"urDay","urMonth","urYear","urHour","urMin","urSec","TillDate")
     
          for(var i=0;i<ctlList.length;i++)
          {
               var word=ctlList[i];
               var ctl=document.getElementById(word);
               ctl.disabled=bVSAPIState;
          }
          

     }
     else
     {
          var backEnabled=document.getElementById("Background");
          backEnabled.disabled=false;
          setBackground();
     }  
}

function DateValidation()
{	
	var dateControls = new Array("urDay","urMonth","urYear","urHour","urMin","urSec");
	for(var i=0;i<dateControls.length;i++)
	{
		var id = dateControls[i];
		document.getElementById(id).disabled = !document.getElementById(id).disabled;
	}
}

//////////////////////////////////////////////////////////////////////
//functions for Scheduling BackGround Scanning
function BGSStartSchedule()
{
	OnBackgroundCheck();
    if(!document.getElementById("Enabled").checked)
    {
        alert(gsVSAPIScanDisabled);
        return;
    }
	if(!document.getElementById("Background").checked)
    {
        alert(gsBackgroundScanDisabled);
        return;
    }
	var pp = new PropertyPath("Scheduler.Task")
	pp.BeginEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()
	top.gPageStack.Forward(new DialogPage("EditTaskSchedule.html",gsBGSStartSchedule), pp.GetPath())
}

function BGSStopSchedule()
{
	OnBackgroundCheck();
    if(!document.getElementById("Enabled").checked)
    {
        alert(gsVSAPIScanDisabled);
        return;
    }
	if(!document.getElementById("Background").checked)
    {
        alert(gsBackgroundScanDisabled);
        return;
    }
	var pp = new PropertyPath("Scheduler.Task")
	pp.BeginEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()
	pp.IncrementEnum()	
	top.gPageStack.Forward(new DialogPage("EditTaskSchedule.html",gsBGSStopSchedule), pp.GetPath())
}

function OnMonthChangeBS(val)
{
	var isLrUr;
	if(val == true)
	  isLrUr = "lr";
	else
	  isLrUr = "ur";
	var month= document.getElementById(isLrUr+"Month").selectedIndex
	var year= document.getElementById(isLrUr+"Year").selectedIndex
	var day = document.getElementById(isLrUr+"Day").selectedIndex
	var numDays = getMonthLength(month+1,year+2003)
	var ctrl = document.getElementById(isLrUr+"Day")
	while (ctrl.childNodes.length > 0)
	{
		ctrl.removeChild(ctrl.childNodes[0])
	}

	for (var i =1; i <= numDays; i++)
	{
		var opt=document.createElement("OPTION")
		var name = document.createTextNode(i)
		opt.appendChild(name)
		ctrl.appendChild(opt)
		if (i == day+1)
		    opt.selected=true	
	}	
}

function getMonthLength(cMonth,cYear)
{
	if (cMonth==1 || cMonth==3 || cMonth==5 || cMonth==7 || cMonth==8 || cMonth==10 || cMonth==12)
		monthLength = 31
	else
		if (cMonth==4 || cMonth==6 || cMonth==9 || cMonth==11)
			monthLength = 30
		else
			if (cYear % 100 == 0)
				monthLength = (cyear % 400 == 0) ? 29 : 28
			else
				if (cYear % 4 == 0)
					monthLength = 29
				else
					monthLength = 28;

       return monthLength
}
//////////////////////////////////////////////////////////////////////

// This function disables controls based on installed Exchange server roles.
function DisableControlsAsPerExRole() {
	var bShowVSAPI = false, bShowTransport = false
	
	if(IsBHInstalled() || IsGWInstalled()) {
		bShowTransport = true
	}
	
	if(IsMBInstalled()) {
		bShowVSAPI = true
	}	
	
	if((GetExVersion() == const_exVersion2013) || (!bShowVSAPI)){
		DisableFormControls(document.getElementById("oa_vsapi_div"))
		//document.getElementById("oa_vsapi_div").disabled = true
		if(GetExVersion() == const_exVersion2013)
			document.getElementById("oa_vsapi_disabledmsg_e13").style.display = ""
		else
			document.getElementById("oa_vsapi_disabledmsg").style.display = ""

		DisableFormControls(document.getElementById("oa_bgscan_div"))
		//document.getElementById("oa_bgscan_div").disabled = true
		if(GetExVersion() == const_exVersion2013)
			document.getElementById("oa_bgscan_disabledmsg_e13").style.display = ""
		else
			document.getElementById("oa_bgscan_disabledmsg").style.display = ""
		document.getElementById("linkBGStart").style.cursor = "default"
		document.getElementById("linkBGStop").style.cursor = "default"
		document.getElementById("linkBGStart").href = "#"
		document.getElementById("linkBGStop").href = "#"		
	}
	
	if(!bShowTransport) {	
		DisableFormControls(document.getElementById("oa_Txscan_div"))
		//document.getElementById("oa_Txscan_div").disabled = true
		document.getElementById("oa_Txscan_disabledmsg").style.display = ""
	}
}

function OnFailSettingChanged()
{
	document.getElementById("oa_generic_disabledmsg").style.display = "none"
	top.SetModified(true);
	if(document.getElementById("OnFail").selectedIndex == 1)
	{
        	if (confirm(strScanFailure))
		{
			document.getElementById("oa_generic_disabledmsg").style.display = ""
			top.SetModified(true);
		}
	    	else
		{
			document.getElementById("OnFail").selectedIndex = 0
			top.SetModified(false)
		}
	}
}

function OnProductFailSettingChanged()
{
	document.getElementById("oa_product_disabledmsg").style.display = "none"
	top.SetModified(true);
	if(document.getElementById("OnProductFail").selectedIndex == 1)
	{
        	if (confirm(strProductScanFailure))
		{
			document.getElementById("oa_product_disabledmsg").style.display = ""
			top.SetModified(true);
		}
	    	else
		{
			document.getElementById("OnProductFail").selectedIndex = 0
			top.SetModified(false)
		}
	}
}

function ExcludeLargeEmailScanChanged()
{
	var state = document.getElementById("ExcludeLargeEmailScan").checked;
	if(state==false)
	{
		document.getElementById("MailSizeLimit").disabled = true
		document.getElementById("MailSizeMBKB").disabled = true
	}	else
	{
		document.getElementById("MailSizeLimit").disabled = false
		document.getElementById("MailSizeMBKB").disabled = false
	
	}
}