// Copyright (C) 2009 McAfee, Inc.  All rights reserved.

function Show()
{
	// Set visible columns
	gVisibleCols = new Array("dts","onr","sbj","ftr")
	gAllowedCols = new Array("dts","onr","sbj","ftr","tik","fln","vrs","idy","efn","fdr","svr","avd","ave","ase","are")
	gSearchableCols = new Array("onr","sbj","ftr","tik","fln","vrs","idy","efn","fdr","svr","avd","ave","ase","are")
	gColNames = gStoreCols

	// Load query
	gColumnNames = gStoreCols
	gUIPlugin = "UIStore"
	gFilterRoot = "(rsn<>\"spam\")"
	QueryShow(strQtinedOther,new Array(strDelete,strReleaseToOwner,strDownload))

	// Disable the release to owner and download buttons
	document.getElementById( "action1" ).disabled = true;
	document.getElementById( "action2" ).disabled = true;
}

///////////////////////////////////////////////////////////////////////////
//
// Carry out an action
//
function Action(op)
{

	// Check for a selection
	if (QueryNoSelectedRecords() ==0)
	{
		alert(strNoRows)
		return
	}

	var str = ""
	switch (op)
	{
		case 0: // Delete
			str = "UIStore"+"&t=6"
			str = JoinFilters(str, QueryId())
			str = JoinFilters(str, QueryRecordsToDisplay())
			str = JoinFilters(str,QuerySelectedRecords())
		break

		case 1: // Release
			str = "UIPPInterface"+"&t=11"
			str = JoinFilters(str, QueryId())
			str = JoinFilters(str, QueryRecordsToDisplay())
			str = JoinFilters(str, QuerySelectedRecords())
		break

		case 2: // Download
			if (!QuerySelectOneRecord())
				return
			str = "UIStore"+"&t=1"
			str = JoinFilters(str, QueryId())
			str = JoinFilters(str, QueryRecordsToDisplay())
			str = JoinFilters(str, QuerySelectedRecords())
			str = JoinFilters(str, "n=" + QuerySelectedFileName("eml"))
		break
	}

	parent.hiddenFrame.location.href = GetDynamicPageUrl(str)
}

function OnMcGridClicked(selectionArray)
{
	var bButtonsDisabled = true;

	if( selectionArray.length == 1 )
	{
		var nRecNum = parseInt(selectionArray[0],10);
		var qtn = gQueryRecords[nRecNum][gVisibleCols.length];

		if( qtn && qtn == 1 )
			bButtonsDisabled = false;
	}

	document.getElementById( "action1" ).disabled = bButtonsDisabled;
	document.getElementById( "action2" ).disabled = bButtonsDisabled;
}

function OnSetRowIcon(row)
{
	var iconInfo;
	var nRecNum = parseInt(row,10);
	var qtn = gQueryRecords[nRecNum][gVisibleCols.length];

	if( qtn && qtn == 1 )
	{
		iconInfo = new Array();
		iconInfo["filename"] = "../../images/icons/qtndata.gif";
		iconInfo["alttext"] = strQuarantinedDataAlt;
	}
	else
	{
		iconInfo = new Array();
		iconInfo["filename"] = "../../images/icons/noqtndata.gif";
		iconInfo["alttext"] = strNoQuarantinedDataAlt;
	}

	return(iconInfo);
}
