// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================
var dataBindings=[];
//var pageProperties=[];
var settingsType = "AS";
var vframeworks=[];

//====================================================================================
// Draw and data management
//=====================================================================================
    var sa_rv = new RequiredValidator();
    var sa_nv = new FloatValidator();


    //populate html with score values if known
    function displayScore()
	{
    var div_id;

          for(i=0;i<top.polctx.polSetting["t_values"].length;i++)
		  {  div_id = document.getElementById("THRESHOLD_DIV"+i)
             if (div_id)
             {    var dhtml = resolveString(cse_pp_st, "ACT_AS_Score");
			      dhtml += " " + top.polctx.polSetting["t_values"][i];
		          div.innerHTML = dhtml;
             }
          }

    }

    function enableActionValueCtl(b, n) {
	var tr = document.getElementById("spam_threshold_row" + n);
	var formName = "spam_actions_" + n;
	var fieldName = "ScoreBasedActionValue" + n;
	var vframework = vframeworks[formName];
	if (b) {
	    tr.style.display = "";
	    vframework.addValidator(fieldName, sa_rv);
	    vframework.addValidator(fieldName, sa_nv);
	}
	else {
	         tr.style.display = "none";
	         if (!vframework.check(fieldName)) {
		        document.forms[formName].elements[fieldName].value =
		        pageProperties[fieldName];
		        vframework.onchange(fieldName);
	         }
	         vframework.clearValidators(fieldName);
	     }
    }

    function checkScoreBasedAction(checked, n) {

	var disabled = true;
	var className = "st disabled";
	if (checked) {
	    disabled = false;
	    className = "st";
	}
	var trs = [document.getElementById("spam_threshold_row" + n),
	    document.getElementById("spam_action_list_row" + n),
        document.getElementById("spam_action_list_row2" + n)];
	for (var i = 0; i<trs.length; i++) {
	    if (trs[i]) {
		var tds = trs[i].cells;
		for (var j = 0; j < tds.length; j++) {
		    tds[j].className = className;
		}
	    }
	}
    var eId = "spam" + n + "f_sec_header";
    var e = document.getElementById(eId);
    className = "disabled";
    if (checked) {
        e.className = removeClass(e.className, className);
    }
    else {
        e.className = addClass(e.className, className);
    }
	var formName = "spam_actions_" + n;
	var vframework = vframeworks[formName];
	var f = document.forms[formName];
	if (f) {
	    var elems = f.elements;
	    for (var i = 1; i<elems.length; i++) {
		elems[i].disabled = disabled;
	    }
	    var fieldName = "ScoreBasedActionValue" + n;
	    if (checked) {
		vframework.addValidator(fieldName, sa_rv);
		vframework.addValidator(fieldName, sa_nv);
	    }
	    else {
		if (!vframework.check(fieldName)) {
		    document.forms[formName].elements[fieldName].value =
			pageProperties[fieldName];
		    vframework.onchange(fieldName);
		}
		vframework.clearValidators(fieldName);
	    }
	}
	setFormEnabledState("spam" + n + "_actions_f_p", !disabled);
	setFormEnabledState("spam" + n + "_actions_f_s", !disabled);
    }

//=========================================================
// Mandatory Functions
//=========================================================

function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp) {

    gPolAction = new PolicyAction (pbIn, pp, true);
	gPolAction.Show()

    for (var i=1; i<4; i++)
    {
   	    act = gPolAction.GetProp("Action"+i);

		var enable_ctl = document.getElementById("chkbox_ScoreBasedAction" + i);
		if (enable_ctl)
		{
		    enable_ctl.checked=(act!="");
			checkScoreBasedAction(enable_ctl.checked, i)
        }
    }

}

/**
 * Asynchronous data validation function
 */
function Validate() {
    var ok = true;
    return ok;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb_null,pp_null,save)
{
    gPolAction.Apply();

    for (var i=1; i<4; i++)
    {
		var enable_ctl = document.getElementById("chkbox_ScoreBasedAction" + i);
		if (enable_ctl)
		{
		    if (!enable_ctl.checked)
			gPolAction.SetProp("Action"+i, "");
        }
    }


	top.gPageStack.Active().SetModified(true);

    //top.gPageStack.Active().SetModified(false);
   	if (!save) return top.gPageStack.Active().pb
}

