// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================


var pageProperties=[];
var settingsType = "AV";
var vframeworks=[];


function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}

function changeCleanOption(cleanChecked)
{
    var labelText = resolveString(cse_pp_st,"__cleaning_succeeds_action");
    var enabled = true;
    if (!cleanChecked) {
	       enabled = false;
	    }
    var cl = "disabled";
    var e = document.getElementById("avs_sec_header");
    if (e) {
            e.innerHTML = labelText;
            if (cleanChecked) {
                e.className = removeClass(e.className, cl);
            }
            else {
                e.className = addClass(e.className, cl);
            }
     }
	 setFormEnabledState("clean_actions", enabled);

	 var elems = document.forms["av_actions_s_s"].elements;
	 for (var i = 0; i<elems.length; i++)
     {
	     if (elems[i].type == "checkbox")
         {
		         elems[i].disabled = !enabled;
                 if(!enabled)
                 { elems[i].checked = false;
                 }
	     }
	 }

}

function getCleanOptionCheckState()
{
	return document.forms["av_actions_s_p"].elements[0].checked;
}

function hideCleanOption()
{
	   var f = document.forms["av_actions_s_p"];
	   f.elements[0].checked = false;
	   var elems = document.forms["av_actions_s_s"].elements;
	   for (var i = 0; i<elems.length; i++)
       {
	      if (elems[i].type == "checkbox")
          {
		       elems[i].checked = false;
	      }
	   }

	   changeCleanOption(false);
	   document.getElementById("clean_option_row").style.display = "none";
}



/**
 * Asynchronous data load function
 */
function Show(pbIn, ppIn)
{
	//pageProperties["ShowCookieOptions"]=pp_ui_flags["Default"]["PupTypesHidden"]
    gPolAction = new PolicyAction (pbIn, ppIn, true);
	gPolicyAlerts.Init(pbIn, ppIn, true)

    //top.getCustomPB("DefaultAlerts_en_US").ShowValues();
	gPolAction.Show();
	gPolicyAlerts.ShowAll();
    PolActions_LocalRestore(gPolicyAlerts) ;

	var clean_ctl = document.getElementById("CLEAN_CTL");
	if (clean_ctl)
	{
		    changeCleanOption(clean_ctl.checked)

	}

	for(var i=0;i<gPolAction.dataBindings.length;i++)
    {
	     var f=document.forms[gPolAction.dataBindings[i].fpForm];
	     if (f && f.init)
	     {   PolicyAction_onclick(f.elements["pri_actions"], gPolicyAlerts.GetId(i));
	     }
	}

    var div= document.getElementById("malware_div");
    if(div)
    {    var txt= top.polctx.polSetting["MAL"];
         div.innerHTML = "";
         if(txt)
         {    if(txt !="")
              {   div.appendChild(document.createTextNode(txt));
                  return;
              }
         }

         txt = resolveString(cse_pp_st,"__no_malware_configured" );
         div.appendChild(document.createTextNode(txt));

    }

}

/**
 * Asynchronous data validation function
 */
function Validate() {
    var ok = true;
    return ok;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb_null,pp_null,save)
{
var change = false;
    if (gPolAction.Apply())
    {  change = true;
    }


	if (gPolicyAlerts.Apply())
	{  change = true;
	}

	if (change)
	{  	top.gPageStack.Active().SetModified(true);
	}

   	if (!save) return top.gPageStack.Active().pb
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
	return ["DefaultAlerts"];
}
