// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
//====================================================================================
// Const and Flags
//=====================================================================================
var dataBindings=[];
var gPagePb;

//====================================================================================
// Draw and data management
//=====================================================================================


//store local configuration temporarily
function PolSetting_CS_LocalStore()
{
     PolSetting_StoreLocalCopy( true, null);

     //save this settings propertybag, including alert and cb selection
     var ppT=PolSetting_GetPPNode("");
     var pbT= new PropertyBag();
     gPagePb.GetElement(ppT, pbT);
     ppT.Append("CSESettings");
     for (var i = 0; i < dataBindings.length; i++)
	 {        this.dataBindings[i].get(ppT, pbT);
     }
     gPolicyAlerts.Apply(pbT);

     top.polctx.polSetting["tmp_pb"]= pbT;

     //save current alert selection
  	 top.polctx.polSetting["tmp_alerts"]=[];
	 if(gPolicyAlerts)
	 {  gPolicyAlerts.LocalStore(top.polctx.polSetting["tmp_alerts"]);
     }
}

//restore local configuration if any
function PolSetting_CS_LocalRestore()
{
    PolSetting_RestoreLocalCopy();

    //restore local property bag
    var ppT=PolSetting_GetPPNode("");
    if(top.polctx.polSetting["tmp_pb"])
    {
       var pbT = PropertyBag.Recreate(top.polctx.polSetting["tmp_pb"])
       ppT.Append("CSESettings");
       for (var i = 0; i < this.dataBindings.length; i++)
	   {    this.dataBindings[i].set(ppT, pbT);
       }
       gPagePb = pbT;

       top.polctx.polSetting["tmp_pb"]=null;

    }
    else
    {
        var pbT=PolSetting_GetPb();
        gPagePb=new PropertyBag()
        pbT.GetElement(ppT, gPagePb);
    }

}

//open the edit alert page
//pol_alerts is gPolicyAlerts, as set up in html alert component
function PolSetting_CS_EditAlert( pol_alerts, ae_id, create)
{
    PolSetting_CS_LocalStore()
    if(pol_alerts)
    {
         pol_alerts.EditAlert(ae_id, create);
    }
}

//open the edit actions page
//note that the path is the rule in modif mode,or the setting path in create mode
function PolSetting_CS_EditActions(create, ndx)
{
    PolSetting_CS_LocalStore();

    var title = resolveString(cse_pp_st, "ACT_PAGE_TITLE", [resolveString(cse_pp_st,"CS")]);
    var target;
    var pp_str;

    if(create)
    {
       //top.polctx.polSetting["CS_ACT"] = gContentRules.rulesTable;
       pp_str=PolSetting_GetPPNode("").GetPath();
       target =  "PolActions_CS.html"
    }
    else
    {   var name = gContentRules.rulesTable.GetKey(ndx);
	
        pp_str=gContentRules.rulesTable.GetPath(ndx);
		var rule;
		var rulename;
		if( name.indexOf(":") != -1 )
		{
			rule = name.split(':')
			rulename = rule[1].slice(0,rule[1].length);
			rulename = trim_string(rulename);
		}
	
		if(gContentRules.GetScoreFromName("RefRuleGroup",rulename) == McUndefined)
			name += "," + "0"
		else if(gContentRules.GetScoreFromName("RefRuleGroup",rulename) != "")
			name += "," + "1"
		else
			name += "," + "0"
        target =  "PolActions_CS.html?name=" + name;

    }

    var page = new DialogPage( target , title );
	top.gPageStack.Forward(page, pp_str);
}

//open the edit alert page
function PolSetting_CS_DeleteAction(pos)
{
     gPagePb.DeleteElement(gContentRules.rulesTable.GetPath(pos))
     PolSetting_CS_DrawActions(gPagePb, false)
     PolSetting_SetModify();

}

//param is the path to the settings
function PolSetting_CS_DrawOptions(inherit)
{
  var ppT=PolSetting_GetPPNode("");
  var pbT=gPagePb;
  ppT.Append("CSESettings");
  for (var i = 0; i < dataBindings.length; i++)
  {   dataBindings[i].set(ppT, pbT);
  }


  f=document.forms["alert_fld_form"];
  f.ScanIntoDocs.disabled=inherit;
  f.GruntScan.disabled=inherit;
}


function makeCSActionStyle(table)
{
    if (!table) return;

    table.border = 0;
    table.cellPadding = 0;
    table.cellSpacing = 0;
    var className = table.className;
    table.className = addClass(className, "dataSubTable");
    var rows = table.getElementsByTagName("tr");
    var rowCount = rows.length;
    for (var i = 0; i < rowCount; i++)
    {
            var row = rows[i];
            var className = row.className;

            if (i == 0) className = addClass(className, "header");
            else  className = addClass(className, "row1");
            if (i == rowCount - 1) className = addClass(className, "lastRow");

            row.className = className;
            var tds = row.cells;
            var cellCount = tds.length;
            for (var j = 0; j < cellCount; j++)
            {
                var cell = tds[j];
                className = cell.className;
                className = addClass(className, "dst");
                if (j == cellCount - 1)
                {
                    className = addClass(className, "eor");
                }
                cell.className = className;
            }//for
    }

}


function PolSetting_CS_DisplayTable( len, inherit)
{
  //init placeholder
  var dhtml="";
  var div = document.getElementById("act_div");
  if (div)  div.innerHTML = dhtml;

  //add table
  var tbl=document.createElement("table");
  div.appendChild(tbl);
  tbl.width="100%";

  var tbody=document.createElement("tbody");
  tbl.appendChild(tbody);

  //add title row
  var row=document.createElement("tr");
  tbody.appendChild(row);

  //add first title cell
  var cell= document.createElement("td");
  row.appendChild(cell);
  cell.colSpan="2";
  cell.style.fontWeight="bold";
  cell.appendChild(document.createTextNode(resolveString(cse_pp_st , "ACTTITLE_CS")));

  //add last title cell
  cell= document.createElement("td");
  row.appendChild(cell);
  cell.className = "noLeft rightAligned";
  cell.width="100px"
  if(inherit)
  {  dhtml="&nbsp;";
  }
  else
  {
     dhtml= '<A href="javascript:PolSetting_CS_EditActions(true)" class=BlueLink id="ACTIONS_LNK">'
     dhtml += resolveString(cse_pp_st , "__add_new_rule")+'</a>'
  }
  cell.innerHTML=dhtml;

  for (var i=0;i<len; i++ )
  {

      if( gContentRules.rulesTable.Deleted(i) )
	  {   continue;
	  }

      row=document.createElement("tr");
      tbody.appendChild(row);

      cell= document.createElement("td");
      row.appendChild(cell);
      cell.appendChild(document.createTextNode(gContentRules.rulesTable.GetKey(i)));
      cell= document.createElement("td");
      row.appendChild(cell);
	 cell.appendChild(document.createTextNode(gContentRules.rulesTable.GetVal(i)));
      cell= document.createElement("td");
      row.appendChild(cell);
      cell.width="130px";
	  if(inherit)
	  {   dhtml ="&nbsp;"
	  }
	  else
	  {
          dhtml  = '<A href="javascript:PolSetting_CS_EditActions( false, ' + i +')" class=BlueLink>'+resolveString(cse_pp_st , "__edit")+' </a>|'
          dhtml += '<A href="javascript:PolSetting_CS_DeleteAction(' + i + ')" class=BlueLink>'+resolveString(cse_pp_st , "__delete")+' </a>'
      }
      cell.innerHTML=dhtml;

  }

  makeCSActionStyle(tbl) ;

}


//draw the actions in place in the page _ assumes the div are present
// pb:property bag to read from
// pp:path to the actual setting
function PolSetting_CS_DrawActions( pb, inherit)
{
  var ppT=PolSetting_GetPPNode("");
  gContentRules.rulesTable= new PolicyAction (pb, ppT, false);
  var len=0;

  ppT.Append("RuleRef");
  ppT.BeginEnum();
  while(pb.GetProperty(ppT) !== undefined) {
       ppT.SetTempLeaf("id");
       var id = pb.GetProperty(ppT);
       ppT.SetTempLeaf("type");
       var type = pb.GetProperty(ppT);
	   ppT.SetTempLeaf("");

       var str = gContentRules.GetNameFromId(type, id)
       gContentRules.rulesTable.BuildRulesTable(str, type, len, id, ppT.GetPath());
       ppT.IncrementEnum();
       len++;
   }

   ppT.EndEnum();

   PolSetting_CS_DisplayTable(len, inherit);
}//fn

//re creates gPagePb  and refresh the page
function PolSetting_CS_ReInit()
{
	var inherit = PolSetting_CheckInherit();

    //reset the local property bag
    var pbT=PolSetting_GetPb();
	var pp_str = PolSetting_GetPPStr();
    gPagePb=new PropertyBag()
    pbT.GetElement(pp_str, gPagePb);

    PolSetting_CS_DrawOptions(inherit)
    PolSetting_CS_DrawActions(gPagePb, inherit)
	gPolicyAlerts.InitAll(gPolicyAlerts.alert_pb, gPagePb, pp_str)
	gPolicyAlerts.ShowAll();
    gPolicyAlerts.DisableAlertSel(inherit);

}


function PolSetting_CS_Draw(pbIn, inherit)
{
    gContentRules = new CSRules();
    var pp_str=PolSetting_GetPPStr();
    // Need to merge the CSPolicySettings related properties from the gPagePb
	// to pbIn as gPagePb shall contain the updated properties from the current page
	pbIn.SetProperties(gPagePb);

    //draw alerts - reinit if new alert was created
	gPolicyAlerts.InitAll(pbIn, gPagePb, pp_str)
	gPolicyAlerts.ShowAll();
	if(gPolicyAlerts && top.polctx.polSetting["tmp_alerts"])
    {
       gPolicyAlerts.LocalRestore(top.polctx.polSetting["tmp_alerts"]);
	   top.polctx.polSetting["tmp_alerts"]=null;
	}
    PolSetting_CS_DrawOptions( inherit )
    PolSetting_CS_DrawActions(gPagePb, inherit)
    gPolicyAlerts.DisableAlertSel(inherit);

}

//=========================================================
// Functions called when user interact with controls
//=========================================================

//inherit checkbox onclick
function OnclickInherit(val)
{  	PolSetting_SetModify();
    PolSetting_CS_ReInit()
}

//=========================================================
// Mandatory Functions
//=========================================================

/**
 * Asynchronous data load function
 */
function Show(pbIn, pp_null) {
    PolSetting_Show(pbIn);
    PolSetting_CS_LocalRestore();
	var inherit=PolSetting_CheckInherit();
    PolSetting_CS_Draw(pbIn, inherit);

}

/**
 * Asynchronous data validation function
 */
function Cancel() {
    PolSetting_Draw();
    PolSetting_CS_ReInit();
    top.gPageStack.Active().SetModified(false);
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    var ok = true;
    return ok;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pbOut,pp,save) {

  var pbT=PolSetting_GetPb();
  var ppT=PolSetting_GetPPNode("");

  //save rules
  var rpp_str=ppT.GetPath()+".RuleRef";
  pbT.DeleteList(rpp_str);
  gPagePb.GetElement(ppT, pbT);

  //save checkbox content
  ppT.Append("CSESettings");
  for (var i = 0; i < dataBindings.length; i++)
  {   dataBindings[i].get(ppT, pbT);
  }

  //save alert id and other polsetting data (e.g. inherit, time)
  gPolicyAlerts.Apply(pbT);

  //now apply everything for good and refresh the page
  var pbFinal=PolSetting_Apply("CS", true);
	
  // Refresh the page by reloading it.
  top.gPageStack.Active().SetModified(false);

  if(!gIsEPO4)
  {
	 top.SetModified(true);
	 var sel=document.getElementById("SETTING_SEL");
	 if(sel)
		 PolSetting_SelectFromCombo(sel)
  }
 
  return pbFinal;
}

//==========================================================================================
//Callback function to list required configuration data
//==========================================================================================


function GetCustomConfigReq() {
	return ["CSRules", "DefaultAlerts"];
}





