// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Edit Policy name, description and details

var vframeworks = new Object();
var origName = "";

function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
      {  alert(e.message);
      }
}

function Validation_Init()
{
   var form = "P_FORM"
   var reqV=new RequiredValidator();
   //var scriptV = new ScriptValidator();
   var scriptV = new InputTextValidator();

   if (document.forms[form])
   {
            vframeworks[form] = new ValidationFramework(form);
            vframeworks[form].formAction = std_val_form_action;
            vframeworks[form].fieldAction = std_val_field_action;
            vframeworks[form].addLabeledValidator("name", resolveString(cse_pp_st,"__name"), reqV);
            var inputArray= new Array();
			inputArray["SECTION"]="Policies";
			inputArray["origName"]=origName;
			vframeworks[form].addValidator("name",new DuplicatesValidator(top.polctx.myPolicySet,inputArray));
			vframeworks[form].addValidator("name",new LengthValidator());
			vframeworks[form].addValidator("name",scriptV);
			vframeworks[form].addLabeledValidator("description",resolveString(cse_pp_st,"__description"),scriptV);
   }

}


//Build Family:
//array of ids including this policy and all its descendants
//(not the ancestors) and siblings of the current policy
//current : id of current policy
function BuildFamily(current,familymap)
{

   var pList = top.polctx.myPolicySet.policies;
   var family = [];


   var pol_id=current;
   var finished=false;
   var i=0;
   var root=-1;

   var last_child=-1;
   var checkedindex=0;
   var count=0;


   //keep looking for ancestors in the list of policies
   //stop if no more ancestor is found or if it is root
   while ( finished == false )
   {
			count++;
			for(i=0;i<pList.length;i++)
			{
				if(count==1 && pList[i].id==pol_id)    //adding the current policy too in the map of family only the first time.
					{
						familymap[i]=1;
						root=i;
					}
				if(pList[i].parent_id==pol_id)
					{
						last_child++;          //increment the index of the child.
						family[last_child]=i;
						familymap[i]=1;  		//filling the map for look up
					}
			}

			if(count == 1 && family.length==0)
				break;


			if(checkedindex <= last_child)
				{
					index=family[checkedindex];    //index is being changed here
					pol_id=pList[index].id; //get hold of the next child's id, to find all its children.
					checkedindex++;
				}
			else
				finished=true;


   }

   family.unshift(root); //add the current policy's id on the top.      just to add to the family list.

}


//Draw the combo of possible parent policy
// parent = id of the parent policy
//current = id of current policy
function DrawParentCombo(parent, current)
{
    var pset = top.polctx.myPolicySet
    var len=pset.treeNdx.length
    var j;
    var pol_indent="";
	var familymap=new Array(len);      //map for remembering all the descendants of the current policy.

    var div = document.getElementById("parents_div");
    if (!div) return;

    div.innerHTML = "";

    var sel=document.createElement("select");
    div.appendChild(sel);
    sel.id="selParent";
    sel.style.width="200px"
    sel.onchange= new Function ("top.gPageStack.Active().SetModified(true);")


	for (j=0;j<len;j++)
		familymap[j]=0;        //default values into the map

    BuildFamily(current,familymap); //this one builds the family map (descendant policies id's of the current policy) which is used as a look up for later purposes.

	for (var i=0; i<len; i++)
    {
        var ndx=pset.treeNdx[i];
	    if (ndx==-1) continue;

        //don't add family (that is, itself and descendants)
        if(familymap[ndx]==1)
		{   continue;
        }

        var opt=document.createElement("option");
        sel.appendChild(opt);
        opt.value=pset.policies[ndx].id;
        if (opt.value == parent) opt.selected=true;

        var pol_indent="";
	    for (var j=0; j<pset.policies[ndx].indent; j++)
	    {
		    pol_indent+='\u00A0'+'\u00A0'+'\u00A0'+'\u00A0'
        }
		opt.appendChild(document.createTextNode(pol_indent+' '+pset.policies[ndx].name));

	}

}//fn



function Show(pb,pp)
{

    //current id
    pp.SetTempLeaf("id")
	var id = pb.GetProperty(pp);

    //Show name
	pp.SetTempLeaf("name")
	var name = pb.GetProperty(pp)
	origName = resolveString(cse_pp_st, name)
	if (name != McUndefined)
		document.getElementById("idName").value = origName;

    //Show description
	pp.SetTempLeaf("description")
	var descr = pb.GetProperty(pp)
	if (descr != McUndefined)
		document.getElementById("idDescription").value = resolveString(cse_pp_st, descr);

    //show parent
    pp.SetTempLeaf("parent")
    var parent=pb.GetProperty(pp)
    pp.SetTempLeaf("")

	DrawParentCombo(parent, id);
    Validation_Init();
}

function Validate()
{   var ok = vframeworks["P_FORM"].onsubmit()
	return ok;
}

//Save data
function Apply(pb,pp)
{
	// Save name
	pb.SetProperty(pp)
	pp.SetTempLeaf("name")
	pb.SetProperty(pp, document.getElementById("idName").value)

	// Don't save parent if there is no selection
    // so it will stay as before (probably null)
    var sel=document.getElementById("selParent");

    if (sel && sel.options.length>0)
    {
       var value=sel.options[sel.selectedIndex].value
       pp.SetTempLeaf("parent")
	   pb.SetProperty(pp, value);
    }

    //store description if there is any selected
	pp.SetTempLeaf("description")
	pb.SetProperty(pp, document.getElementById("idDescription").value)

    return pb;

}

