// Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//
// Description:
//
// History:  (Author/Comment)
// Sept 2005 :IL : Created

//====================================================================================
// Consts
//====================================================================================
var K_DELETED = 2
var K_ROOT = 1
var K_NOROOT  = 0

//====================================================================================
// globals and flags for this page 
//====================================================================================

//====================================================================================
// Draw and data management
//=====================================================================================

function PolicyUsers_DrawRootRule(is_root) {

    var res=false;

	if(is_root=="1") 
	{   
	    var text="";
        if(top.polctx.myPolicySet.policies.length>1)
		{   text=resolveString(cse_pp_st, "__default_applies");
		}
		else
		{   text=resolveString(cse_pp_st, "__always_applies");
	    }


	    var id_panel=document.getElementById("identity_panel")
		if(id_panel)
		{
		      res="true";
			  id_panel.innerHTML="";
	

			  var tbl=document.createElement("table");
              id_panel.appendChild(tbl);
              tbl.id="tbl_rule";
			  tbl.className="shadedTable";
			  tbl.width="80%"


              var tbody=document.createElement("tbody");
              tbl.appendChild(tbody);   
              var row=document.createElement("tr");
  	          tbody.appendChild(row); 
              var cell=document.createElement("td");
              row.appendChild(cell);
			  cell.appendChild(document.createTextNode(text))

		}

	}

    return res;


}

//=========================================================
// Mandatory Functions
//=========================================================

/**
 * Asynchronous data load function
 * enumerate all policyset until the one with the right name is found
 */
function Show(pbIn, ppIn) {

    myPbIn = pbIn;
	gIdentities=null;
   
    //replace this with pp passed as parameter
    basePP = top.polctx.myPolicySet.policies[top.polctx.myPolicySet.selection].pp_path;
	policyStatement_pb=pbIn;

    //initialise PolicySettingsList with the property bag and pp of current policy
	myPolicySettingsList.populate(pbIn, basePP)

    //get values from current policy
	var ppT = new PropertyPath(basePP)
    ppT.SetTempLeaf("IdentityRef");
	var idref=pbIn.GetProperty(ppT);
	ppT.SetTempLeaf("root");
	var is_root = PolicyUsers_DrawRootRule (pbIn.GetPropertyDef(ppT, "0"));
	if(is_root) return;


   //initialise identities object
	ppT.SetTempLeaf("name");
	var name=pbIn.GetProperty(ppT);
    var policySetName = top.polctx.myPolicySet.pp_key

    gIdentities = new Identities("gIdentities", pbIn, idref, name)
    gIdentities.PopulateAll(policySetName, pbIn);

}

/**
 * Asynchronous data validation function
 */
function Validate() {
    var ok = true;

    //check if no rules are present
	var lst = document.getElementById(K_LST_SEL);
	if (lst == McUndefined)
	{
	ok = false
	return ok;
	}    
	if( lst.options.length <= 0 )
	{
	alert(gsIdentityPageError)
	ok = false;
	}
	return ok;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb,pp,save) {
   

    if (!gIdentities.Validate() )
	{
	return false;
	}
    //save rules
    var id = gIdentities.CreateGroup(pb);
	
    //save refid if needed
	var ppT = new PropertyPath(basePP)
    ppT.SetTempLeaf("IdentityRef");
	var idref=pb.GetProperty(ppT);
	if(id != idref)
	{    pb.SetProperty(ppT, id);
	}
	
    return pb;
}

function Cancel() 
{     
      if(gIdentities)
	  {
         gIdentities.GetValFromPb(); 
         gIdentities.PopulateForm();
      }
}

function AddPickerEntries( tplType, list )
{
	gIdentities.AddPickerEntries( tplType, list )
}
//====================================================================================
// Links to other pages
//====================================================================================

