// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//First page of policy creation wizard

var next_order=2;
var vframeworks = new Object();



function Validation_Init()
{
   var form = "P_FORM"
   var reqV=new RequiredValidator();
   //var scriptV = new ScriptValidator();
   var scriptV = new InputTextValidator();

   if (document.forms[form])
   {
            vframeworks[form] = new ValidationFramework(form);
            vframeworks[form].formAction = std_val_form_action;
            vframeworks[form].fieldAction = std_val_field_action;
            vframeworks[form].addLabeledValidator("name",resolveString(cse_pp_st,"__sub_policy").concat(" "+resolveString(cse_pp_st,"__name")), reqV);
            var inputArray= new Array();
			inputArray["SECTION"]="Policies";
			inputArray["origName"]="";
			vframeworks[form].addValidator("name",new DuplicatesValidator(top.polctx.myPolicySet,inputArray));
			vframeworks[form].addValidator("name",new LengthValidator());
			vframeworks[form].addValidator("name",scriptV);
			vframeworks[form].addLabeledValidator("description",resolveString(cse_pp_st,"__description"),scriptV);

   }

}

function DrawParentCombo(selection)
{
    var pset = top.polctx.myPolicySet
    var len=pset.treeNdx.length
    var j;
    var pol_indent="";

    var data_html="";

    //set up next priority order for future use
    next_order = len+1;

    var div = document.getElementById("parents");
    if (!div) return;

    div.innerHTML = "";

    var sel=document.createElement("select");
    div.appendChild(sel);
    sel.id="selParent";


    for (var i=0; i<len; i++)
    {
        var ndx=pset.treeNdx[i];
	    if (ndx==-1) continue;

        var opt=document.createElement("option");
        sel.appendChild(opt);
        opt.value=pset.policies[ndx].id;
        if ( opt.value == selection) opt.selected=true;


        var pol_indent="";

	    for (var j=0; j<pset.policies[ndx].indent; j++)
	    {
            if (j<=7)
            {   pol_indent+='\u00A0'+'\u00A0';
            }
        }

		opt.appendChild(document.createTextNode(pol_indent+' '+pset.policies[ndx].name));

	}

    sel.className="policyWidth";

}



function Show(pb,pp)
{
    Validation_Init();

    // Show name
    pp.SetTempLeaf("name")
    var name = pb.GetProperty(pp)
    if (name != McUndefined)
		document.getElementById("idName").value = name

    //show description
    pp.SetTempLeaf("description")
    var descr = pb.GetProperty(pp)
    if (descr != McUndefined)
		 document.getElementById("idDescription").value = descr;

    //show parent
    pp.SetTempLeaf("parent")
    var parent=pb.GetProperty(pp)
    pp.SetTempLeaf("")
    DrawParentCombo( parent)
}

function Validate()
{   var ok = vframeworks["P_FORM"].onsubmit()
	return ok;
}

//Save data
function Apply(pb,pp)
{
   	// Save name
	pb.SetProperty(pp)
	pp.SetTempLeaf("name")
	pb.SetProperty(pp, document.getElementById("idName").value)

	// Save parent
    var sel=document.getElementById("selParent");
    var value=sel.options[sel.selectedIndex].value
	pp.SetTempLeaf("parent")
	pb.SetProperty(pp, value);

	// Generate id and refid
 	pp.SetTempLeaf("id")
	if (!pb.GetProperty(pp))
	{
     		var id=MakeGuid("")
  		pb.SetProperty(pp, id)
		pp.SetTempLeaf("IdentityRef")
		pb.SetProperty(pp, id)
	}

    //store description
	pp.SetTempLeaf("description")
	pb.SetProperty(pp, document.getElementById("idDescription").value)

	// Order
	pp.SetTempLeaf("Order")
	pb.SetProperty(pp, next_order)
	pp.SetTempLeaf("")

    var tmp=0;

    return pb;
}

