//Copyright (C) 2017 McAfee, Inc.  All rights reserved

// PageMap Menu Titles

var gsProductTitle = "McAfee Security for Microsoft Exchange"
var gsProductTitleRegTrade = "McAfee&reg; Security for Microsoft Exchange"
var gsAntiSpamAddOn = "McAfee Anti-Spam for McAfee Security for Microsoft Exchange"

// Dashboard
var gsMIDashboard			= "Dashboard";
var gsMIStatsInfo			= "Statistics & Information";
var gsMIGraphs				= "Graphical Reports";
var gsMISystemMetrics		= "System Metrics";
var gsMIScheduledTasks		= "Scheduled Tasks";
var gsSpamVersion			= "Anti-Spam Engine | Rules Version";
//Product Information
var gsNot					= "Not";
var gsEnabled				= "Enabled";
var gsInstalled				= "Installed";
var gsNotApplicable			= "Not Applicable";
var gsNotInstalled			= "Not Installed";

// Quarantined Items
var gsMIQuarantinedItems	= "Quarantined Items";
var gsMISpam				= "Anti-Spam";
var gsMIPhish				= "Phish";
var gsMIViruses				= "Virus Detections";
var gsTTIEATD				= "TIE And ATD Detections";
var gsMIPUPs				= "Potentially Unwanted Programs";
var gsMIContent				= "Unwanted Content";
var gsMIAllItems			= "All Items";
var gsMIOtherItems			= "Other Items";

// Schedule
var gsMISchedule			= "Schedule";
var gsMIScheduleUpdates		= "Product Updates";
var gsMIScheduleOnDemand	= "On-Demand Scans";

// Policy Manager
var gsMIPolicyManager		= "Policy Manager";
var gsMIPMSchedule			= "Schedule";
var gsMIPMEMailSMTP			= "Email Policies (SMTP)";
var gsMIPMEMailPOP3			= "Email Policies (POP3)";
var gsMIPMEWeb				= "Web Policies";
var gsMIPMEICAP				= "ICAP Policies";
var gsMIPFileTransfer		= "File Transfer Policies";
var gsMIPUsersAndGroups		= "Users & Groups";

var gsMIFirewall			= "Firewall";
var gsMIBufferOverflow		= "Buffer Overflow Protection";

// Settings and Diagnostics
var gsMISettingsDiag		= "Settings and Diagnostics"
var gsMIScannerSettings		= "Scanner Settings";
var gsMIMailNotifications	= "Mail Notifications";
var gsOnAccessSettings		= "On-Access Settings";
var gsMIDbManagemnent		= "Database Management"
var gsMITIE			= "TIE-Settings";
var gsMIPersonalPrefs		= "Personal Preferences";
var gsMIDiagnostics			= "Diagnostics";
var gsMIProductLog			= "Product Log";
var gsMIImportExport		= "Import and Export Configuration";

var gsMIPPCommunications	= "McAfee Product Communications";
var gsMISubmitSample		= "Submit Sample";

// UserGroup page strings
var gsCreatingUserGroup	= "Creating:";
var gsEditingUserGroup = "Editing:";
var gsSureCancel = "Are you sure you want to cancel? If you continue you will lose any changes.";
var gsSureDeleteGroup = "Are you sure you want to delete this group?";
var gsNoGroupName = "Please enter a name for this new group";
var gsNoUserName = "Please enter a user";

/*
// User group template names	##AK - 20050428 - modified array syntax to facilitate localization parse
var gIdentityTemplateNames = new Array()
gIdentityTemplateNames[0] = "A recipient is in %1g"
gIdentityTemplateNames[1] = "No recipients are in %1g"
gIdentityTemplateNames[2] = "A recipient is %1e"
gIdentityTemplateNames[3] = "No recipients are %1e"
*/

// Black & White lists
var gsTabGlobalBW		= "Global Blacklists and Whitelists";
var gsTabGroupBW		= "Group Blacklists and Whitelists";
var gsTabBlackList		= "Blacklist";
var gsTabWhiteList		= "Whitelist";
var gsBWNoName			= "Please enter a name for the entry";
var gsBWConfirmDeletes	= "Are you sure you want to delete all these entries?";
var gsBConfirmDelete	= "Are you sure you want to delete this black list entry?";
var gsWConfirmDelete	= "Are you sure you want to delete this white list entry?";
var gsDuplicateEntry	= "An entry with this name already exists, please enter a unique name.";
var gsWAlreadyExists    = "%1 is already present.";
var gsWAdded    	= "%1 has been added successfully.";
var gsWNoGroupId        = "%1 has not been added. The recipient of the e-mail is not a member of a User Group.";


// Point product datatypes for above
gDataTypeNames=new Object();
gDataTypeNames["g"] = "Active Directory Group";
gDataTypeNames["s"] = "";
gDataTypeNames["e"] = "e-mail address";
gDataTypeNames["a"] = "";
gDataTypeNames["d"] = "";
gDataTypeNames["h"] = "";

// Store columns	##AK - 20050428 - modified array syntax to facilitate localization parse.
var gStoreCols = new Array();
gStoreCols["onr"]= "Recipient";
gStoreCols["trs"]= "State";
gStoreCols["rpt"]= "Recipients";
gStoreCols["sdr"]= "Sender";
gStoreCols["fln"]= "Filename";
gStoreCols["vrs"]= "Detection Name";
gStoreCols["dts"]= "Date/Time";
gStoreCols["sbj"]= "Subject";
gStoreCols["rsn"]= "Reason";
gStoreCols["rul"]= "Rule Name";
gStoreCols["idy"]= "Policy Name";
gStoreCols["efn"]= "Embedded File Name";
gStoreCols["ssc"]= "Spam Score";
gStoreCols["tik"]= "Ticket Number";
gStoreCols["fdr"]= "Folder";
gStoreCols["svr"]= "Server";
gStoreCols["ftr"]= "Reasons";
gStoreCols["avd"]= "Anti-Virus DAT";
gStoreCols["ave"]= "Anti-Virus Engine";
gStoreCols["ase"]= "Anti-Spam Engine";
gStoreCols["asr"]= "Anti-Spam Rule";
gStoreCols["psn"]= "Scanned By";
gStoreCols["sav"]= "Submit to McAfee Labs";
gStoreCols["db"] = "Database";
gStoreCols["act"]= "Action Taken";
gStoreCols["tn"] = "Task";
gStoreCols["ctp"] = "Banned Phrases";
gStoreCols["tsscr"] = "Reputation Score";
gStoreCols["ipscr"] = "IP Reputation Score";
gStoreCols["tsip"] = "Sender IP Address";
gStoreCols["tiescr"] = "TIE Score";

// Page titles
strQtinedSpam          = "Spam";
strQtinedPhish         = "Phish";
strQtinedIP		       = "IP Reputation";
strQtinedVirus         = "Virus Detections";
strQtinedTIE	= "TIE Detections";
strQtinedPUP           = "Potentially Unwanted Programs";
strQtinedContent       = "Unwanted Content";
strQtinedAll           = "All Items";
strQtinedOther         = "Other Items"; 
strSpamSubmissions     = "Submitted as Spam";
strHamSubmissions      = "Submitted as Non-Spam";
strReleaseSubmissions  = "Submitted For Release";
strSpamTrained         = "Trained as Spam";
strHamTrained          = "Trained as Non-Spam";
var gsBlackAndWhite    = "Blacklist and Whitelist";
var gsUserConfig       = "Your Account";
strQtinedBannedFile	   = "Banned File types/Messages";
strQtinedCompDLP       = "DLP and Compliance";
strQtinedURL           = "URL Detections";
var strQtinedSpoof = "Spoofed Mails";


// Error codes
strErrorMessages[0x80041008] = "The McAfee Security for Microsoft Exchange is not currently available. Please try again later.";
strErrorMessages[0x80041010] = "Your Administrator is preventing you from viewing this type of item.";
strErrorMessages[0x80041013] = "Invalid log-on details. Please try again.";
strErrorMessages[0x80041014] = "The activation code you have entered is invalid.";
strErrorMessages[0x80040265] = "Operation failed. Document exceeds size limit.";
strErrorMessages[0x80040266] = "Operation failed. Internal error.";
strErrorMessages[0x80040267] = "Operation failed. Please update the DATS and rescan before submitting to McAfee Labs.";

// Logon	##AK - 20050428 - modified array declaration.
var gsLogonMessages= new Array();
gsLogonMessages[1] = "An account has been created for you. An email containing\n a default password has been sent to the given address.";
gsLogonMessages[2] = "An email containing your current password has been sent\n to the given address." ;
var gsLogonFailure = "The Username or password you entered was incorrect. Please re-enter your Login details and retry " ;

// User Config
var gsEmailAliases	= "E-mail Aliases";

//##AK - 20050428 - added array declaration and modified array syntax to facilitate localization parse.
var gsAliasStates = new Array();
gsAliasStates[0] = "Active";
gsAliasStates[1] = "Waiting for activation";
gsAliasStates[2] = "New";

var gsActivate	=	"Activate" ;
var gsPassword		= "Password";
var gsMaxAge		= "Other Settings";
var gsPasswordsDontMatch = "The two passwords you have entered do not match.";
var gsEnterCode		= "Enter the activation code here" ;
var gsAliasActivated    = "Your alias has been successfully activated.";
var gsConfirmDeleteAlias= "Are you sure you want to delete this alias?";

// EndUser Management
var gsNoQueryData = "No users found which match your query";
var gsEnterQuery = "Please enter a query to perform.";
var gsMultipleSelected = "Please select only one user to edit.";
var gsConfirmUserDelete = "Are you sure you want to delete selected user(s)?.";
var gsNoUsersSelected = "Please select at least one user account to delete";
var gsEmailAddress = "E-mail Address";

// Digest Settings
var gsDidestSchedule = "Digest Scheduler";
var gsDigestMail     = "Digest Mail";    
var gsDigestResponse = "Digest Response";
var gsInvalidAddress = "The e-mail address you have entered does not appear to be valid.";

// Dashboard
var gsNowText			= "Now";
var gsXAxisTitleD		= "Days";
var gsXAxisTitleH		= "Hours";
var gsYAxisTitle		= "Detections";
var gsConfirmResetStats	= "Are you sure you want to reset all statistics?";

// System Metrics
var gsCounter1 = "Processor 1 Usage";
var gsCounter2 = "Processor 2 Usage";
var gsCounter3 = "Processor 3 Usage";
var gsCounter4 = "Processor 4 Usage";
var gsCounter5 = "Available Memory MB";
var gsCounter6 = "System Threads";
var gsCounter7 = "Object Events";
var gsCounter8 = "Object Mutexes";
var gsCounter9 = "Object Threads";

// On-demand wizard
var gsODWizTitle = "Schedule an on-demand scan";
var gsODWizPage1 = "Choose when to scan";
var gsODWizPage2 = "Choose what to scan";
var gsODWizPage3 = "Choose exclusions";
var gsODWizPage4 = "Configure scan settings";
var gsODWizPage5 = "Enter a name for the scan";

var gsODSResumePage			= "Resumable scanning";
var gsODSelectPolicy		= "Select Policy";
var gsAllWorkspaces			= "All folders";
var gsFolderExists 			= "This folder has already been added.";

var gsAddFolderTree= "Add this folder and all its subfolders";
var gsAddFolder= "Add this folder only";
var gsRemoveFolder= "Remove this item";
var gsSelectFolderToAdd= "Please select a folder to add.";
var gsSelectFolderToRemove= "Please select a folder to remove.";
var gsScanSelected= "Folders to scan:";
var gsScanExcept= "Folders to exclude:";
var gsScanNoFoldersSelected= "You have not selected any folders to scan. Either select or type a server/folder to scan.";
var gsScanNoTimeout= "You have enabled resumable scanning. Please enter the number of minutes to stop scanning after."
var gsAllServersXml = "All Servers";
var gsAllServers = "Data Directory of All Servers";
var gsInvalidServer = "Invalid server name";
var gsInputFolderToAdd = "Type in the name of the folder to add";
var gsInputServerToAdd = "Type in the name of the server to add";
var gsSelectDataOrDesign = "Select at least one of Data or design documents to scan";
var gsScanTimeout = "Please enter a timeout value greater than zero.";
var gsFoldersToScan ="Scan the following folders:";
var gsFoldersNotToScan ="Scan all except the following folders:";
var gsOnDemand="On Demand ";
var gsPolicyName="Policy Name";
var gsTypeOfScan="Type of Scan";
var gsAdvFilter="Advanced";
var gsGranExpression="Click on Expression before proceeding.";
var gsMailSizeCheck="Specify at least one Mail Size value.";
var gsMailSizeFromMoreThanTo="The Mail Size (To) field should be greater than or equal to (From) field."

// Training States	
var gTrainingStates = new Array();
gTrainingStates[0]= "Untrained";
gTrainingStates[1]= "Submitted for Release";
gTrainingStates[2]= "Submitted as Non-Spam";
gTrainingStates[3]= "Submitted as Spam";
gTrainingStates[4]= "Trained as Non-Spam";
gTrainingStates[5]= "Trained as Spam";
gTrainingStates[6]= "Trained as Non-Spam on Group";
gTrainingStates[7]= "Trained as Spam on Group";
gTrainingStates[8]= "Released";
gTrainingStates[9]= "In Quarantine Manager Queue";
gTrainingStates[10]= "Submitted to McAfee Labs";
gTrainingStates[11]= "Forwarded";
gTrainingStates[12]= "Offbox Quarantine Failed - Max Retry Exceeded";

//==========================================================
// those strings are related to the gIdCfgTemplates array defined
// in PointProductSpecific.js.
//  Both arrays must stay in sync.
//============================================================

var gIdUITemplates = new Array();
gIdUITemplates[0] =	"The SMTP address of the sender is %1e";
gIdUITemplates[1] =	"The SMTP address of the sender is not %1e";
gIdUITemplates[2] =	"The SMTP address of any recipients is %1e";
gIdUITemplates[3] =	"The SMTP address of any recipients is not %1e";
gIdUITemplates[4] =	"The sender is in %1g";
gIdUITemplates[5] =	"The sender is not in %1g";
gIdUITemplates[6] =	"Any of the recipients is in %1g";
gIdUITemplates[7] =	"Any of the recipients is not in %1g";

// Avert report names
var gAVERTReportNames=[];
gAVERTReportNames["AntiVirusNews"]="Anti-Virus News";
gAVERTReportNames["SecurityNews"]="Security News";

// OnDemand Policy names
var gODPolicyNames = new Array(); 
gODPolicyNames[0] =	"On Demand";
gODPolicyNames[1] =	"Find Viruses";
gODPolicyNames[2] =	"Remove Viruses";
gODPolicyNames[3] =	"Find Non-Compliant Content";
gODPolicyNames[4] =	"Remove Non-Compliant Content";
gODPolicyNames[5] =	"Full Scan";

var gODPolicyRegNames;

// Scan Task prop names
gsTaskStatusItems["ttgt"] = "Folders scanned";
gsTaskStatusItems["tcs"] = "Status";
//gsTaskStatusItems["tvf"] = "Viruses found";
gsTaskStatusItems["trb"] = "Rules broken";
gsTaskStatusItems["tt"] = "Task Type";
gsTaskStatusItems["tuf"] = "Status";
gsTaskStatusItems["odres"] = "Results";
gsTaskStatusItems["tods"] = "Total Scanned";

//On Access Background Scan
var gsBGSStartSchedule = "Start BackGround Scheduling";
var gsBGSStopSchedule  = "Stop BackGround Scheduling";

// Start - of Localizable strings used by S.A.F.e code but defined by Point Product
// Product titles
//var gsProductTitle = "McAfee Security for Microsoft Exchange 7.6"
var gsProductSubtitle = "...for Microsoft&#174 Exchange"
var gsWelcome = "Welcome to McAfee Security for Microsoft Exchange"
var gsTagline = "Use McAfee Security for Microsoft Exchange to protect your Microsoft Exchange server from viruses and undesirable content."
var gsAbout = "About MSME"
var gsUsage = "In order to use the " + gsProductTitle + " user interface, you need<br>Microsoft&#174 Internet Explorer version 5.5 or higher installed"
// End - of Localizable strings used by S.A.F.e code but defined by Point Product
////////////////////////////////////////////////////////////////////////////


// Localizable strings defined by Point Product for PP usage.

// VSAPI settings page.
var gsVSAPI2 = "These changes may take up to two minutes to take effect."
var gsVSAPI2Disabled = "Disabling VSAPI2 will disable on-access scanning."
var gsTransAVAPIEnabled = "Note: Selecting this option in Microsoft Exchange 2003 mailbox server causes VSAPI to scan\neach e-mail twice, once at the transport level and then again at the mailbox level. This might\ndegrade mailbox server performance. It is recommended to select this option only on a\nFront-end or a Gateway server."
var gsVSAPIScanDisabled="VSAPI scanning needs to be enabled to start/stop background scanning."
var gsBackgroundScanDisabled="Background scanning needs to be enabled to start/stop background scanning."
var gsVSAPI2UpperAgeLimitWithTillDate = "From Date Should Be less than Todays Date."
var gsVSAPI2UpperAgeLimitWithoutTillDate = "From Date Should Be less than To Date"
var gsVSAPINoOfScanThreads = "Number of Scan Threads should be an integer value between 1 and 50."


// User groups
var gsIDName = "Policy Group"
var gsIDWizName = "Create a Policy Group"
var gsIdentitySelect = "For the Policy Group:"
var gsIDSelectGroup = "Please select a group"
var gsSenderIn = "Sender is in %1"

// Import wizard
var gsImportIdentity="Import Active Directory Groups"
var gsImportWhat="Choose what to import"
var gsImportConfirm="Import Summary"
var gsAtleastOneAD="You must select at least one type of Active Directory Group to import"
var gsSenderRecipient="You must select at least one of sender or recipient"

// Transportscanning
gsTransportWarning = "When using Transport Scanning, routed messages are scanned, and all unwanted messages are deleted. However cleaning and background scanning are NOT supported and messages are NOT scanned until they have been sent from the outbox. Are you sure you want to continue?"
gsBothWarning = "When using both Transport and VSAPI Scanning, all non-routed messages are scanned twice. Are you sure you want to continue?"
gsTransDisableWarning = "De-selecting this check box on a Exchange 2003 BridgeHead server OR Exchange 2007/2010 HUB/EDGE role makes the server un-protected. Do you really want to Disable this?"

//Admin reports wizard
var gsReport = "Report"
var gsWhenToReport = "When to report"
var gsReportSettings = "Who to report to"
var gsStatusReportSettings = "Report Settings"
var gsEnterEmail = "Please enter an email address"
var gsEnterSubject = "Please enter a subject line"
var gsErrNumDays = "Maximum Number of Rows"


// License stuff
var gsPolicyMgmt = "Extended Policy Management"

var gsLicenseExplanationBottom= "Please contact McAfee or your software dealer in order to acquire an appropriate licensed copy of this software."
// Product descriptions - one for each registry key as defined above - needs localizing
var gsProductDescriptionArray = new Array();
gsProductDescriptionArray[ "datversion" ]        = "DAT Version:"
gsProductDescriptionArray[ "datdate" ]           = "DAT Date:"
gsProductDescriptionArray[ "engineversion" ]     = "Engine Version:"
gsProductDescriptionArray[ "spamrulesversion" ]  = "Anti-Spam Rules Version:"
gsProductDescriptionArray[ "spamrulesdate" ]     = "Anti-Spam Rules Date:"
gsProductDescriptionArray[ "spamengineversion" ] = "Anti-Spam Engine Version:"
gsProductDescriptionArray[ "productversion" ]    = "Product Version:"
gsProductDescriptionArray[ "productname" ]       = "Product Description:"

// Anti-Spam
var gsEnterSysFolderAddr = "Please enter a valid system junk folder address."
var gsLicenseAntiSpamExpired = "The anti-spam license has expired or is not installed."
var gstrRange= "Please enter an integer value between %1 and %2."
var gsValidIPError = "Please enter a valid IP address.";
var gsValidPortError = "Please enter a valid port number.";
var gsValidUserError = "Please enter a valid user name.";
var gsValidPasswordError = "The password entered do not match. Please re-enter the password.";
var gsEmailsBlocked = "Choosing this setting will block majority of emails. For more information, refer Help.";

// Tasks.htm - names of tables.
var gsTaskTitleView = "View"
var gsTaskTitleSchedule = "Schedule"
var gsTaskTitleConfigure= "Configure"
var gsTaskTitleLicense  = "License"
var gsTaskEntryScheduleStatus = "Status Reports"
var gsTaskEntryScheduleConfig = "Configuration Reports"
var gsConfigReports = "Configuration Reports"


// Notification
var gsTaskEntryLicenseExpiry  ="License Expiry Notification"
var gsAreYouSure ="Are you sure?"

var gsNoPolicyGroups = "There are currently no policy groups defined"
var gsDefaultSubjectLine = gsProductTitle + " Alert"
var gsStatusReportSubject = gsProductTitle + " Status Report"
var gsConfigReportSubject = gsProductTitle + " Configuration Report"
var gsRequiresExchangeSP1 = "This product requires Microsoft Exchange 2000 SP1 or higher" 

//PageMap.js -> Page Titles
var gsTNotifications = "Notifications"
var gsTODDefault = "On-Demand (Default)"
var gsTODFindViruses = "On-Demand (Find Viruses)"
var gsTODRemoveViruses = "On-Demand (Remove Viruses)"
var gsTODFindBannedContent = "On-Demand (Find Non-Compliant Content)"
var gsTODRemoveBannedContent = "On-Demand (Remove Non-Compliant Content)"
var gsTODFullScan = "On-Demand (Full Scan)"
var gsTOutbreakManager = "Outbreak Manager"
var gsTGateway = "Gateway"
var gsTAntiSPAMSettings = "Anti-Spam Settings"
var gsTTIESettings = "TIE Settings"

//On-access settings page strings
var gsScanTimeoutString = "ScanTimeout";
var gsLowerAgeLimit = "Lower Age Limit";

//Validation Labels for E-mailValidator
var gEmailLabels = new Object();
gEmailLabels["McIdAdminEmail"] = "Administrator Email";
gEmailLabels["McIdSenderEmail"] = "Sender Email";
gEmailLabels["McIdSubjectLine"] = "Subject";
gEmailLabels["idTMQThreshold"] = "Transport Queue Threshold";
gEmailLabels["idVMQThreshold"] = "Virus scan Queue Threshold";

gEmailLabels["McIdASSUB"] = "Anti-Spam Subject";
gEmailLabels["McIdDLPSUB"] = "DLP and Compliance Subject";
gEmailLabels["McIdFFSUB"] = "File Filter Subject";
gEmailLabels["McIdCCSUB"] = "Corrupt Content Subject";
gEmailLabels["McIdPCSUB"] = "Protected Content Subject";
gEmailLabels["McIdECSUB"] = "Encrypted Content Subject";
gEmailLabels["McIdSGSUB"] = "Signed Content Subject";
gEmailLabels["McIdPPSUB"] = "Password Protected mail Subject";
gEmailLabels["McIdMSSUB"] = "Mail Size Filtering Subject";
gEmailLabels["McIdSCSUB"] = "Scanner control Subject";
gEmailLabels["McIdMMSUB"] = "MIME Mail Subject";
gEmailLabels["McIdTISUB"] = "TIE Reputations Subject";

gEmailLabels["McIdAS"] = "Anti-Spam: Email";
gEmailLabels["McIdDLP"] = "DLP and Compliance : Email";
gEmailLabels["McIdFF"] = "File Filter : Email";
gEmailLabels["McIdCC"] = "Corrupt Content : Email";
gEmailLabels["McIdPC"] = "Protected Content : Email";
gEmailLabels["McIdEC"] = "Encrypted Content : Email";
gEmailLabels["McIdSG"] = "Signed Content : Email";
gEmailLabels["McIdPP"] = "Password Protected mail : Email";
gEmailLabels["McIdMS"] = "Mail Size Filtering : Email";
gEmailLabels["McIdSC"] = "Scanner control : Email";
gEmailLabels["McIdMM"] = "MIME Mail : Email";
gEmailLabels["McIdTI"] = "TIE Reputations : Email";

// Forward specific string
var gFwSubject	= "Forwarded by McAfee Security for Microsoft Exchange"
var gFwBody		= "Please find the quarantined email attached.";

// Validation labels for TS
var gsErrTrustedSource = "Maximum threshold value for McAfee Global Threat Intelligence message reputation service";
// Notifications
var strGeneral			=	"Settings";
var strProductHealth	= 	"Product Health Alerts";
var strEmailDetections	= 	"Template";
var strThresholdRange	= "Invalid threshold queue limit choosen";

// OA Advanced settings
var strScanFailure	= "Enabling this feature will quarantine all emails on generic scan failure and \nwill not be delivered to the recipient's inbox.\n\nDo you want to continue?";
var strProductScanFailure	= "Enabling this feature will quarantine all emails on product scan failure and \nwill not be delivered to the recipient's inbox.\n\nDo you want to continue?";

// VSAPI Mailbox Exclusions
var gsTMBExclusionSettings = "Mailbox Exclusion Settings";
var gsMBCannotAdd       = "Only mailbox exclusion is allowed";
var gsSelectMBToAdd     = "Please select a mailbox to add.";
var gsEnterMBToAdd		= "Please enter a mailbox to add.";
var gsSelectMBToRemove  = "Please select a mailbox to remove.";
var gsMBExists 			= "One or more mailboxes were not added, as they were duplicates.";
var gsAllMailBoxes		= "All Mailboxes";
var gsAddMailBox        = "Add this mailbox only";
var gsRemoveMailBox     = "Remove this mailbox";
var gsMBparentAlreadyAdded 	= "One or more mailbox is already added for exclustion. Its subfolders cannot be added for exclusion.";
var gsMBSubFolderExists		= "One or more mailbox were not added for exclusion. Its subfolder is added for exclusion.";
var gsMBExclusionWarning	= "Are you sure you want to exclude subfolder(s) under Mail Database or Public Folder?";
var gsSubFolderEmpty		= "Subfolder cannot be left empty, while a Mail Database or Public Folder is added for exclusion.";

//ProxySettings
var gsPortNoString = "PortNumber"

//Release Quarantine Policy name
var gsReleaseQtnPolicy = "Release Quarantine";
