//
// RTEStrings.js
// String table for the rich text editor.
//
// Copyright (C) 2009 McAfee, Inc. All rights reserved.
//

var rte_st = new Object();
rte_st["reset"] = "Reset";
rte_st["style"] = "[Style]";
rte_st["<P>"] = "Paragraph <p>"
rte_st["<H1>"] = "Heading 1 <h1>"
rte_st["<H2>"] = "Heading 2 <h2>"
rte_st["<H3>"] = "Heading 3 <h3>"
rte_st["<H4>"] = "Heading 4 <h4>"
rte_st["<H5>"] = "Heading 5 <h5>"
rte_st["<H6>"] = "Heading 6 <h6>"
rte_st["<ADDRESS>"] = "Address <address>"
rte_st["<PRE>"] = "Preformatted <pre>"
rte_st["font"] = "[Font]";
rte_st["sans"] = "Sans Serif";
rte_st["serif"] = "Serif";
rte_st["mono"] = "Monospaced";
rte_st["size"] = "[Size]";
rte_st["1"] = "XX-Small";
rte_st["2"] = "X-Small";
rte_st["3"] = "Small";
rte_st["4"] = "Medium";
rte_st["5"] = "Large";
rte_st["6"] = "X-Large";
rte_st["7"] = "XX-Large";
rte_st["bold"] = "Bold";
rte_st["italic"] = "Italic";
rte_st["uline"] = "Underline";
rte_st["justifyleft"] = "Align Left";
rte_st["justifycenter"] = "Center";
rte_st["justifyright"] = "Align Right";
rte_st["justifyfull"] = "Justify";
rte_st["insertorderedlist"] = "Ordered List";
rte_st["insertunorderedlist"] = "Unordered List";
rte_st["outdent"] = "Outdent";
rte_st["indent"] = "Indent";
rte_st["forecolor"] = "Text Color";
rte_st["hilitecolor"] = "Background Color";
rte_st["inserthorizontalrule"] = "Horizontal Rule";
rte_st["tokens"] = "[Tokens]";

rte_st["url"] = "URL:";
rte_st["text"] = "Text:";
rte_st["newWindow"] = "Open link in new window";
rte_st["insertlink"] = "Insert Link";
rte_st["cancel"] = "Cancel";
rte_st["url1"] = "URL";
rte_st["linkText"] = "Link text";
rte_st["imageurl"] = "Image URL:";
rte_st["altText"] = "Alternative text:";
rte_st["altAsTitle"] = "Use this text as the image title";
rte_st["insertimage"] = "Insert Image";
rte_st["rows"] = "Rows:";
rte_st["rows1"] = "Rows";
rte_st["columns"] = "Columns:";
rte_st["columns1"] = "Columns";
rte_st["width"] = "Table width:";
rte_st["width1"] = "Width";
rte_st["pixels"] = "pixels";
rte_st["percent"] = "percent";
rte_st["usePercent"] = "Percent";
rte_st["thickness"] = "Border thickness:";
rte_st["thickness1"] = "Border thickness";
rte_st["padding"] = "Cell padding:";
rte_st["padding1"] = "Padding";
rte_st["spacing"] = "Cell spacing:";
rte_st["spacing1"] = "Spacing";
rte_st["inserttable"] = "Insert Table";
rte_st["readonly"] = "Read-only";
rte_st["modeSel"] = "Show: ";
rte_st["wysiwygMode"] = "HTML content (WYSIWYG)";
rte_st["sourceMode"] = "HTML content (source)";
rte_st["ptMode"] = "Plain-text content";

// Error messages
rte_st["preload_err"] = "Error preloading content";
