// Functions for toc

function exp(id) {
  var myElt=document.getElementById('p'+id);
  if (myElt) {
    // check current display state
    if (myElt.src.slice(myElt.src.lastIndexOf('/')+1) == 'minus.gif') {
      collapse(id);
    } else{
      expand(id);
    }
  }
}

function expand(id) {
  var myDoc;//= top.navigationwin.document;
  try {
      if ("undefined" != typeof(window.external.GetParam)) {
        myDoc = window.external.GetParam('window.navigationwin').document;
      }
      else {
        myDoc = top.navigationwin.document;
      }
  }
  catch(e){
        myDoc = top.navigationwin.document;
  }
  
  var myElt=myDoc.getElementById('s'+id);
  if (myElt) {
    with(myElt) {
      className='x';
      style.display=''; 
    }
    if (myDoc.getElementById('p'+id)) {
        myDoc.getElementById('p'+id).src='minus.gif';
    }
    if (myDoc.getElementById('b'+id)) {
        myDoc.getElementById('b'+id).src='obook.gif';
    }
  }
}

function collapse(id) {
  var myElt=document.getElementById('s'+id);
  if (myElt) {
    with(myElt) {
      className='x';
      style.display='none'; 
    }
    
    if (document.getElementById('p'+id)) {
        document.getElementById('p'+id).src='plus.gif';
    }
    
    if (document.getElementById('b'+id)) {
        document.getElementById('b'+id).src='cbook.gif';
    }
  }
}

function highlight(id) {
  var myDoc;//= top.navigationwin.document;
  try {
      if ("undefined" != typeof(window.external.GetParam)) {
        myDoc = window.external.GetParam('window.navigationwin').document;
      }
      else {
        myDoc = top.navigationwin.document;
      }
  }
  catch(e) {
    return;
  }
  
  var myElt=myDoc.getElementById('a'+id);
  
  if (myElt) {
    myElt.hideFocus=true;
    //myElt.focus();
    myElt.setActive();
    top.navigationwin.scrollTo(myElt.offsetLeft-48, myElt.offsetTop-(myDoc.body.clientHeight/3));
  }
}

function loadTOC() {
  // check current page displayed in TOC window.  If not toc.htm, load it.
  if (!isTOCLoaded()) {
    top.navigationwin.location.href='toc.html';
  }
}

function isTOCLoaded() {
  // return true, if toc.htm is loaded in TOC window.
  if (top.toc) {
    var myPath=top.navigationwin.location.pathname;
    var myFile=myPath.substr(myPath.length-7);

    if (myFile == 'toc.html') {
      return true;
    } else {
      return false; 
    }
  } else {
    return false;
  }
}

var oldHighlightEntry;
function highlightEntry() {
  var myDoc;//= top.navigationwin.document;
  try {
      if ("undefined" != typeof(window.external.GetParam)) {
        myDoc = window.external.GetParam('window.navigationwin').document;
      }
      else {
        myDoc = top.navigationwin.document;
      }
  }
  catch(e) {
    return;
  }
  
    // Get the entry ID
    var locationString = window.parent.contentwin.document.location.toString();
    var id;
    if (locationString.indexOf("#") > 0) {
        id = locationString.substring(locationString.indexOf("#") + 1);
    }
    else {
        id = locationString.substring(locationString.lastIndexOf("/") + 1, locationString.indexOf(".html"));
    }
          
    var entry=document.getElementById(id);
    if (entry == null) {
        return;
    }
    
    // De-highlight previous entry
    if (oldHighlightEntry) {
        oldHighlightEntry.style.background = "#ffffff";
    }
    oldHighlightEntry = entry;
    
    // Expand all higher levels
    var element = entry;
    while (element != null){
        if (element.className && element.className.indexOf("level") >= 0) {
            expand(element.id.substring(1));
        }
        element = element.parentNode;
    }
    
    // Highlight and scroll to the correct entry
    entry.style.background = "#ffffaa";
    
    var selectedPosY = 0;
    element = entry;
    while(element != null){
        selectedPosY += element.offsetTop;
        element = element.offsetParent;
    }
    scrollTo(0, selectedPosY - (myDoc.body.clientHeight/3));  
}



