// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Edit One CS rule
// (description of a phrase (simple or complex)
//

var qparams = queryParameters();
var qp_node= qparams["node"];
//=====================================================================
// utilities
//====================================================================

function abs_offset(e, pos) {

    var parent = e.parentNode;
    var y=e.offsetTop-0;
    while(parent!=undefined && parent.offsetTop!=undefined)
    { var pad=parent.offsetTop-0
      y+=pad;
      parent=parent.parentNode;
    }
    return y;
}


function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}

//==========================================================
// Asynchronous data load function
//==========================================================

// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function Show(pb_null, ppIn)
{
//create new pb as a copy of stored pb or top pb
var rules_pb;

if(CSRules_IsStorePb("condition"))
{
       rules_pb=CSRules_GetStorePb("condition", false)
}
else if(CSRules_IsStorePb("rule"))
{      rules_pb=CSRules_GetStorePb("rule", false)
}
else
{	   rules_pb = CSRules_MakePb(CSRules_GetTopPb())
}

CSRP_Show(rules_pb, ppIn, qp_node[0])
}

/**
 * Asynchronous data validation function
 */
function Validate() {
	return CSRP_Validate();
}

/**
 * Asynchronous data save function
 * @pb_global : global property bag 9not cvhanged)
 */
function Apply(pb_null,pp_null,save)
{
     var pbOut = CSRules_IsStorePb("condition");
	 var tst="condition";
     if(!pbOut)
     {    pbOut = CSRules_IsStorePb("rule");
	 	 tst="rule";
     }
     if(!pbOut)
     {
	     pbOut = CSRules_GetTopPb();
     }

     CSRP_Apply(pbOut);
     return top.gPageStack.Active().pb
}
