// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Edit One CS rule
// (lists all conditions)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================
var qparams = queryParameters();

function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}

//======================================
// Asynchronous data load function
//======================================

// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function Show(pbIn, ppIn)
{
   var category = qparams["cat"]
   CSRulePanel_Show(ppIn, category)

   //we don't show the "enabled" checkbox in this page
   var rg_enabled_div=document.getElementById("rg_enabled_div");
   if(rg_enabled_div)
   {   rg_enabled_div.style.display="none";
   }
}

//Asynchronous data validation function
function Validate() {
	 return CSRulePanel_Validate(true)
}

 // Asynchronous data save function
 // parameters
 // pb_null: the global property bag (not changed)
 // ppOut: not used
 // save: not used
function Apply(pb_null,ppOut,save)
{   var pbOut=CSRules_GetTopPb();
    var changes=CSRulePanel_Apply(pbOut)
    return top.gPageStack.Active().pb
}

//==========================================================================================
//Callback function to list required configuration data
//==========================================================================================
function GetCustomConfigReq() {
	return ["CSRules"];
}
