/*
 * DropMenu.js
 * Class definition and helper functions for creating a drop menu.
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved.
 */

function DropMenuItem(sText, sID, callbackFunction)
{
	this.sText				= sText;			// Language item description (e.g. "Edit Item")
	this.sID				= sID;				// Language neutral ID
	this.callbackFunction	= callbackFunction; // Function to call when item clicked
}

function DropMenu( sObj, aItems, nTopItem, userdata, sDiv )
{
	this.sObj				= sThis;	// Textual name of this object
	this.aItems				= aItems;	// Array of DropMenuItems
	this.UserData			= userdata;	// User data passed to callback function of item
	this.sDiv				= sDiv;		// Division on document where menu is rendered
	this.nTopItem			= nTopItem;	// Item at the top of the list, displayed when collapsed
	this.bExpanded			= false;

}



