//
//Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//
var formName = "notifications_form"
var vfSS = new ValidationFramework(formName);
var labelMap = new Object();
var K_ALL = "ALL"
var gEditPage
var gHTMLs = new Object();
var gNotifyTmplSelect;
var gNotificationTabs	= new TabSet("gNotificationTabs", true);	// Tab set for the page
var gAlertControls = ['idDATDown','idEngineDown','idASRDown','idPGDB','idTransportScan','idVirusScan','idRPCServ','idDLLHost','idPGReport','idPGInitialize','idPGStore','idODScan','idDBFull', 'idSAFEFAIL', 'idArtemisFAIL'];



function Notifications(BSMD)
{
	this.Show = Show
	this.Apply = Apply
	//this.Save = Save
	this.Validate = Validate
	this.EditMsg = EditMsg
	this.UpdateHTML = UpdateHTML
	this.Display = Display
}

function Show(pbIn)
{
	gNotificationTabs.add(strGeneral, "tabGeneral");
	gNotificationTabs.add(strEmailDetections, "tabProductNotifications");
	gNotificationTabs.add(strProductHealth, "tabProductHealthAlerts");
	// Initialize the tab handler
	gNotificationTabs.handler();
	//BZ 263087
	parent.Get(pbIn)	
	// Initialize validator
	var reqdVtor = new RequiredValidator();
	vfSS.addValidator("McIdAdminEmail", reqdVtor);
	vfSS.addValidator("McIdSenderEmail", reqdVtor);
	vfSS.addValidator("McIdSubjectLine", reqdVtor);
	
	
	vfSS.addValidator("McIdBody", reqdVtor);
	
	
	vfSS.addValidator("McIdAS", reqdVtor);
	vfSS.addValidator("McIdDLP", reqdVtor);
	vfSS.addValidator("McIdFF", reqdVtor);
	vfSS.addValidator("McIdCC", reqdVtor);
	vfSS.addValidator("McIdPC", reqdVtor);
	vfSS.addValidator("McIdEC", reqdVtor);
	vfSS.addValidator("McIdSG", reqdVtor);
	vfSS.addValidator("McIdPP", reqdVtor);
	vfSS.addValidator("McIdMS", reqdVtor);
	vfSS.addValidator("McIdSC", reqdVtor);
	vfSS.addValidator("McIdMU", reqdVtor);
	vfSS.addValidator("McIdMM", reqdVtor);
	vfSS.addValidator("McIdTI", reqdVtor);
	
	vfSS.addValidator("McIdASSUB", reqdVtor);
	vfSS.addValidator("McIdDLPSUB", reqdVtor);
	vfSS.addValidator("McIdFFSUB", reqdVtor);
	vfSS.addValidator("McIdCCSUB", reqdVtor);
	vfSS.addValidator("McIdPCSUB", reqdVtor);
	vfSS.addValidator("McIdECSUB", reqdVtor);
	vfSS.addValidator("McIdSGSUB", reqdVtor);
	vfSS.addValidator("McIdPPSUB", reqdVtor);
	vfSS.addValidator("McIdMSSUB", reqdVtor);
	vfSS.addValidator("McIdSCSUB", reqdVtor);
	vfSS.addValidator("McIdMUSUB", reqdVtor);
	vfSS.addValidator("McIdMMSUB", reqdVtor);
	vfSS.addValidator("McIdTISUB", reqdVtor);

	
	
	var emailVtor = new EmailValidator(true);
	vfSS.addValidator("McIdAdminEmail", emailVtor);
	var emailVtorSdr = new EmailValidator(false);
	vfSS.addValidator("McIdSenderEmail", emailVtorSdr);
	
	
	vfSS.addValidator("McIdAS", emailVtor);
	vfSS.addValidator("McIdDLP", emailVtor);
	vfSS.addValidator("McIdFF", emailVtor);
	vfSS.addValidator("McIdCC", emailVtor);
	vfSS.addValidator("McIdPC", emailVtor);
	vfSS.addValidator("McIdEC", emailVtor);
	vfSS.addValidator("McIdSG", emailVtor);
	vfSS.addValidator("McIdPP", emailVtor);
	vfSS.addValidator("McIdMS", emailVtor);
	vfSS.addValidator("McIdSC", emailVtor);
	vfSS.addValidator("McIdMU", emailVtor);
	vfSS.addValidator("McIdMM", emailVtor);
	vfSS.addValidator("McIdTI", emailVtor);
	
	var inputVtor = new InputTextValidator(true);
	vfSS.addValidator("McIdASSUB", inputVtor);
	vfSS.addValidator("McIdDLPSUB", inputVtor);
	vfSS.addValidator("McIdFFSUB", inputVtor);
	vfSS.addValidator("McIdCCSUB", inputVtor);
	vfSS.addValidator("McIdPCSUB", inputVtor);
	vfSS.addValidator("McIdECSUB", inputVtor);
	vfSS.addValidator("McIdSGSUB", inputVtor);
	vfSS.addValidator("McIdPPSUB", inputVtor);
	vfSS.addValidator("McIdMSSUB", inputVtor);
	vfSS.addValidator("McIdSCSUB", inputVtor);
	vfSS.addValidator("McIdMUSUB", inputVtor);
	vfSS.addValidator("McIdMMSUB", inputVtor);
	vfSS.addValidator("McIdTISUB", inputVtor);
	vfSS.addValidator("McIdBody", inputVtor);
	vfSS.addValidator("McIdSubjectLine", inputVtor);
	
	vfSS.labelMap = gEmailLabels;
    vfSS.formAction = std_val_form_action;
	vfSS.fieldAction = std_val_field_action;

	Display(pbIn);
	EnableOrDisableAll();
}

function Validate()
{
	return vfSS.onsubmit();
}

function Apply(pbOut)
{
	var pp = new PropertyPath("Notifications")
	pbOut.SetProperty(pp);
	pp.SetTempLeaf("Administrator")

	var ctrl = document.getElementById("McIdAdminEmail")
	var emailIDs = trim_string(ctrl.value);

	if(emailIDs.substring(emailIDs.length-1) == ";")
	{
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
	}
	pbOut.SetProperty(pp, emailIDs)

	pp.SetTempLeaf("Sender")
	pbOut.SetProperty(pp, document.getElementById("McIdSenderEmail").value)

	pp.SetTempLeaf("TaskResultNotification")
	pbOut.SetProperty(pp, document.getElementById("McIdTaskResultNotification").checked)
	
	pp.SetTempLeaf("Subject")
	pbOut.SetProperty(pp, document.getElementById("McIdSubjectLine").value)
	
	pp.SetTempLeaf("MsgInternalSender")
	pbOut.SetProperty(pp, gHTMLs["MsgInternalSender"]);

	pp.SetTempLeaf("MsgInternalRecipient")
	pbOut.SetProperty(pp, gHTMLs["MsgInternalRecipient"]);

	pp.SetTempLeaf("MsgExternalSender")
	pbOut.SetProperty(pp, gHTMLs["MsgExternalSender"]);

	pp.SetTempLeaf("MsgExternalRecipient")
	pbOut.SetProperty(pp, gHTMLs["MsgExternalRecipient"]);

	pp.SetTempLeaf("ProductHealthAlerts.enabled")
	var varEnabled = "0"
	if( document.getElementById("idPHAEnable").checked == true )
	{
		varEnabled = "1"
	}
	pbOut.SetProperty(pp, varEnabled)
	
	pp.SetTempLeaf("ProductHealthAlerts.notify")
	var text = "";
	if( document.getElementById("idePO").checked )
	{
		text = "ePO";
	}
	if( document.getElementById("idAdministrator").checked )
	{
		text += "Admin";
	}
	pbOut.SetProperty(pp, text)

	pp.SetTempLeaf("ProductHealthAlerts.dailyDigestAt")
	text = FormatNum(document.getElementById("dtHour").selectedIndex, 2);
	text += ":" + FormatNum(document.getElementById("dtMin").selectedIndex, 2);
	pbOut.SetProperty(pp, text)

	pp.SetTempLeaf("ProductHealthAlerts.Process.POSTGRES.enabled")
	varEnabled = document.getElementById("idPGDB").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Process.POSTGRES.isImmediate")
	varEnabled = document.getElementById("idPGDBImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.ASRULESDOWNLOAD.enabled")
	varEnabled = document.getElementById("idASRDown").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.ASRULESDOWNLOAD.isImmediate")
	varEnabled = document.getElementById("idASRDownImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)

	pp.SetTempLeaf("ProductHealthAlerts.Log.DATDOWNLOAD.enabled")
	varEnabled = document.getElementById("idDATDown").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.DATDOWNLOAD.isImmediate")
	varEnabled = document.getElementById("idDATDownImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)

	pp.SetTempLeaf("ProductHealthAlerts.Log.ENGINELOAD.enabled")
	varEnabled = document.getElementById("idEngineDown").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.ENGINELOAD.isImmediate")
	varEnabled = document.getElementById("idEngineDownImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)

	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGTRANSPORT.enabled")
	varEnabled = document.getElementById("idTransportScan").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGTRANSPORT.isImmediate")
	varEnabled = document.getElementById("idTransportScanImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)	

	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGSTORE.enabled")
	varEnabled = document.getElementById("idVirusScan").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGSTORE.isImmediate")
	varEnabled = document.getElementById("idVirusScanImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)	
	
	pp.SetTempLeaf("ProductHealthAlerts.Process.RPCSERVFAIL.enabled")
	varEnabled = document.getElementById("idRPCServ").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Process.RPCSERVFAIL.isImmediate")
	varEnabled = document.getElementById("idRPCServImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)

	pp.SetTempLeaf("ProductHealthAlerts.Process.DLLHOST.enabled")
	varEnabled = document.getElementById("idDLLHost").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Process.DLLHOST.isImmediate")
	varEnabled = document.getElementById("idDLLHostImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGREPORT.enabled")
	varEnabled = document.getElementById("idPGReport").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGREPORT.isImmediate")
	varEnabled = document.getElementById("idPGReportImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGINITIALIZEFAIL.enabled")
	varEnabled = document.getElementById("idPGInitialize").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGINITIALIZEFAIL.isImmediate")
	varEnabled = document.getElementById("idPGInitializeImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)

	pp.SetTempLeaf("ProductHealthAlerts.Log.PGITEMSTOREFAIL.enabled")
	varEnabled = document.getElementById("idPGStore").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGITEMSTOREFAIL.isImmediate")
	varEnabled = document.getElementById("idPGStoreImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.ONDEMANDFAIL.enabled")
	varEnabled = document.getElementById("idODScan").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.ONDEMANDFAIL.isImmediate")
	varEnabled = document.getElementById("idODScanImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.DBDISKSPACEWARN.enabled")
	varEnabled = document.getElementById("idDBFull").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.DBDISKSPACEWARN.isImmediate")
	varEnabled = document.getElementById("idDBFullImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	
	pp.SetTempLeaf("ProductHealthAlerts.Process.SAFESERVICEFAIL.enabled")
	varEnabled = document.getElementById("idSAFEFAIL").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)

	pp.SetTempLeaf("ProductHealthAlerts.Log.ARTEMISFAIL.enabled")
	varEnabled = document.getElementById("idArtemisFAIL").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	pp.SetTempLeaf("ProductHealthAlerts.Log.ARTEMISFAIL.isImmediate")
	varEnabled = document.getElementById("idArtemisFAILImmediate").checked == true ? "1" : "0";
	pbOut.SetProperty(pp, varEnabled)
	
	
	var ppath = new PropertyPath("Notifications.Auditors")
	//pp.SetTempLeaf("Auditor.Emailids.AVPolicy")
	ppath.SetTempLeaf("Subject")

	
	var subject = trim_string(ctrl.value);
	
   pbOut.SetProperty(ppath, subject)
   
   
   ppath.SetTempLeaf("MailBody")

	ctrl = document.getElementById("McIdBody")
	var mailbody = trim_string(ctrl.value);
	
   pbOut.SetProperty(ppath, mailbody)
	
	
	
	
	var pp = new PropertyPath("Notifications.Auditors.Emailids")
	//pp.SetTempLeaf("Auditor.Emailids.AVPolicy")
	pp.SetTempLeaf("ASPolicy.emailid")

	 ctrl = document.getElementById("McIdAS")
	var emailIDs = trim_string(ctrl.value);
	if(emailIDs.substring(emailIDs.length-1) == ";")
	{
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
	}
   pbOut.SetProperty(pp, emailIDs)
   
   pp.SetTempLeaf("CSPolicy.emailid")
   ctrl = document.getElementById("McIdDLP")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   
   pp.SetTempLeaf("FFPolicy.emailid")
   ctrl = document.getElementById("McIdFF")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   
   pp.SetTempLeaf("CCPolicy.emailid")
   ctrl = document.getElementById("McIdCC")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   
   pp.SetTempLeaf("PCPolicy.emailid")
   ctrl = document.getElementById("McIdPC")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   
   pp.SetTempLeaf("EMPolicy.emailid")
   ctrl = document.getElementById("McIdEC")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   
   pp.SetTempLeaf("SGPolicy.emailid")
   ctrl = document.getElementById("McIdSG")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   pp.SetTempLeaf("PPPolicy.emailid")
   ctrl = document.getElementById("McIdPP")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   pp.SetTempLeaf("MSPolicy.emailid")
   ctrl = document.getElementById("McIdMS")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   
   pp.SetTempLeaf("SCPolicy.emailid")
   ctrl = document.getElementById("McIdSC")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
      pp.SetTempLeaf("MUPolicy.emailid")
   ctrl = document.getElementById("McIdMU")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   pp.SetTempLeaf("MIMEPolicy.emailid")
   ctrl = document.getElementById("McIdMM")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)
   
   pp.SetTempLeaf("TIEPolicy.emailid")
   ctrl = document.getElementById("McIdTI")
   emailIDs = trim_string(ctrl.value);
   if(emailIDs.substring(emailIDs.length-1) == ";")
   {
		emailIDs = emailIDs.substring(0,emailIDs.length-1);
   }
   pbOut.SetProperty(pp, emailIDs)


//subject

	pp.SetTempLeaf("ASPolicy.subject")
   ctrl = document.getElementById("McIdASSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)
    
		pp.SetTempLeaf("CCPolicy.subject")
   ctrl = document.getElementById("McIdCCSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)

	pp.SetTempLeaf("CSPolicy.subject")
   ctrl = document.getElementById("McIdDLPSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)


	pp.SetTempLeaf("EMPolicy.subject")
   ctrl = document.getElementById("McIdECSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)


	pp.SetTempLeaf("FFPolicy.subject")
   ctrl = document.getElementById("McIdFFSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)


	pp.SetTempLeaf("MSPolicy.subject")
   ctrl = document.getElementById("McIdMSSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)


	pp.SetTempLeaf("PCPolicy.subject")
   ctrl = document.getElementById("McIdPCSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)


	pp.SetTempLeaf("PPPolicy.subject")
   ctrl = document.getElementById("McIdPPSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)


	pp.SetTempLeaf("SCPolicy.subject")
   ctrl = document.getElementById("McIdSCSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)

	pp.SetTempLeaf("MUPolicy.subject")
   ctrl = document.getElementById("McIdMUSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)

	pp.SetTempLeaf("MIMEPolicy.subject")
   ctrl = document.getElementById("McIdMMSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)

	pp.SetTempLeaf("SGPolicy.subject")
   ctrl = document.getElementById("McIdSGSUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)

	pp.SetTempLeaf("TIEPolicy.subject")
   ctrl = document.getElementById("McIdTISUB")
    sub = trim_string(ctrl.value);
    pbOut.SetProperty(pp, sub)

    
	pp.SetTempLeaf("")

	top.SetModified(false);
	return(pbOut);
}

function Display(pb)
{
	var pp = new PropertyPath("Notifications")
	pp.SetTempLeaf("Administrator")
	document.getElementById("McIdAdminEmail").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Sender")
	document.getElementById("McIdSenderEmail").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("TaskResultNotification")
	document.getElementById("McIdTaskResultNotification").checked = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Subject")
	document.getElementById("McIdSubjectLine").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("MsgInternalSender");
	gHTMLs["MsgInternalSender"] = pb.GetProperty(pp.GetPath());
	pp.SetTempLeaf("MsgInternalRecipient");
	gHTMLs["MsgInternalRecipient"] = pb.GetProperty(pp.GetPath());
	pp.SetTempLeaf("MsgExternalSender");
	gHTMLs["MsgExternalSender"] = pb.GetProperty(pp.GetPath());
	pp.SetTempLeaf("MsgExternalRecipient");
	gHTMLs["MsgExternalRecipient"] = pb.GetProperty(pp.GetPath());
	gNotifyTmplSelect = "MsgInternalSender";
	document.getElementById("McIdMsg").innerHTML = gHTMLs["MsgInternalSender"];

	pp.SetTempLeaf("ProductHealthAlerts.enabled")
	document.getElementById("idPHAEnable").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;

	pp.SetTempLeaf("ProductHealthAlerts.notify")
	text = pb.GetProperty(pp.GetPath())
	if( text !== McUndefined )
	{
		if(-1 != text.indexOf("ePO") )
		{
			document.getElementById("idePO").checked = true;
		}
		if(-1 != text.indexOf("Admin"))
		{
			document.getElementById("idAdministrator").checked = true;
		}
	}
	pp.SetTempLeaf("ProductHealthAlerts.dailyDigestAt")
	text = pb.GetProperty(pp.GetPath())
	document.getElementById("dtHour").selectedIndex = text.substr(0,2);
	document.getElementById("dtMin").selectedIndex = text.substr(3,2);
	
	pp.SetTempLeaf("ProductHealthAlerts.Process.POSTGRES.enabled")
	document.getElementById("idPGDB").checked =	pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Process.POSTGRES.isImmediate")
	document.getElementById("idPGDBImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.ASRULESDOWNLOAD.enabled")
	document.getElementById("idASRDown").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.ASRULESDOWNLOAD.isImmediate")
	document.getElementById("idASRDownImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;

	pp.SetTempLeaf("ProductHealthAlerts.Log.DATDOWNLOAD.enabled")
	document.getElementById("idDATDown").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.DATDOWNLOAD.isImmediate")
	document.getElementById("idDATDownImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;

	pp.SetTempLeaf("ProductHealthAlerts.Log.ENGINELOAD.enabled")
	document.getElementById("idEngineDown").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.ENGINELOAD.isImmediate")
	document.getElementById("idEngineDownImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;

	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGTRANSPORT.enabled")
	document.getElementById("idTransportScan").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGTRANSPORT.isImmediate")
	document.getElementById("idTransportScanImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;

	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGSTORE.enabled")
	document.getElementById("idVirusScan").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Process.EXCHGSTORE.isImmediate")
	document.getElementById("idVirusScanImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Process.RPCSERVFAIL.enabled")
	document.getElementById("idRPCServ").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Process.RPCSERVFAIL.isImmediate")
	document.getElementById("idRPCServImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Process.DLLHOST.enabled")
	document.getElementById("idDLLHost").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Process.DLLHOST.isImmediate")
	document.getElementById("idDLLHostImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGREPORT.enabled")
	document.getElementById("idPGReport").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGREPORT.isImmediate")
	document.getElementById("idPGReportImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGINITIALIZEFAIL.enabled")
	document.getElementById("idPGInitialize").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGINITIALIZEFAIL.isImmediate")
	document.getElementById("idPGInitializeImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGITEMSTOREFAIL.enabled")
	document.getElementById("idPGStore").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.PGITEMSTOREFAIL.isImmediate")
	document.getElementById("idPGStoreImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.ONDEMANDFAIL.enabled")
	document.getElementById("idODScan").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.ONDEMANDFAIL.isImmediate")
	document.getElementById("idODScanImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.DBDISKSPACEWARN.enabled")
	document.getElementById("idDBFull").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.DBDISKSPACEWARN.isImmediate")
	document.getElementById("idDBFullImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Process.SAFESERVICEFAIL.enabled")
	document.getElementById("idSAFEFAIL").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Process.SAFESERVICEFAIL.isImmediate")
	document.getElementById("idSAFEFAILImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	
	pp.SetTempLeaf("ProductHealthAlerts.Log.ARTEMISFAIL.enabled")
	document.getElementById("idArtemisFAIL").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("ProductHealthAlerts.Log.ARTEMISFAIL.isImmediate")
	document.getElementById("idArtemisFAILImmediate").checked = pb.GetProperty(pp.GetPath()) == "1" ? true : false;
	pp.SetTempLeaf("")

	pp.SetTempLeaf("Auditors.Emailids.ASPolicy.emailid")
	document.getElementById("McIdAS").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.CSPolicy.emailid")
	document.getElementById("McIdDLP").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.FFPolicy.emailid")
	document.getElementById("McIdFF").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.CCPolicy.emailid")
	document.getElementById("McIdCC").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.PCPolicy.emailid")
	document.getElementById("McIdPC").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.EMPolicy.emailid")
	document.getElementById("McIdEC").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.SGPolicy.emailid")
	document.getElementById("McIdSG").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.PPPolicy.emailid")
	document.getElementById("McIdPP").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.MSPolicy.emailid")
	document.getElementById("McIdMS").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.SCPolicy.emailid")
	document.getElementById("McIdSC").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.MUPolicy.emailid")
	document.getElementById("McIdMU").value = pb.GetProperty(pp.GetPath())
	
	pp.SetTempLeaf("Auditors.Emailids.MIMEPolicy.emailid")
	document.getElementById("McIdMM").value = pb.GetProperty(pp.GetPath())
	
	pp.SetTempLeaf("Auditors.Emailids.TIEPolicy.emailid")
	document.getElementById("McIdTI").value = pb.GetProperty(pp.GetPath())
	
	pp.SetTempLeaf("Auditors.MailBody")
	document.getElementById("McIdBody").value = pb.GetProperty(pp.GetPath())
	
	
	
	//subject
	pp.SetTempLeaf("Auditors.Emailids.ASPolicy.subject")
	document.getElementById("McIdASSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.CSPolicy.subject")
	document.getElementById("McIdDLPSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.FFPolicy.subject")
	document.getElementById("McIdFFSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.CCPolicy.subject")
	document.getElementById("McIdCCSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.PCPolicy.subject")
	document.getElementById("McIdPCSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.EMPolicy.subject")
	document.getElementById("McIdECSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.SGPolicy.subject")
	document.getElementById("McIdSGSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.PPPolicy.subject")
	document.getElementById("McIdPPSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.MSPolicy.subject")
	document.getElementById("McIdMSSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.SCPolicy.subject")
	document.getElementById("McIdSCSUB").value = pb.GetProperty(pp.GetPath())
	
		pp.SetTempLeaf("Auditors.Emailids.MUPolicy.subject")
	document.getElementById("McIdMUSUB").value = pb.GetProperty(pp.GetPath())

	pp.SetTempLeaf("Auditors.Emailids.MIMEPolicy.subject")
	document.getElementById("McIdMMSUB").value = pb.GetProperty(pp.GetPath())
	
	pp.SetTempLeaf("Auditors.Emailids.TIEPolicy.subject")
	document.getElementById("McIdTISUB").value = pb.GetProperty(pp.GetPath())
	
}

// Helper functions
function EditMsg()
{
	var element = document.getElementById("McIdMsg")
	var size = "HEIGHT=480,WIDTH=640"
	var windowPosition = "LEFT=" + 50 + ",TOP=" + (600 - 480)
	gEditPage = open('EditPage.htm', "Edit", size + ",resizable," + windowPosition)
}

function UpdateHTML(strHTML)
{
	var element = document.getElementById("McIdNotifyTmp");
		
	if(!ValidateTextInput(strHTML))
	{
		alert(gsScriptNotAllowed);
		return;
	}
	
	if(!ValidateLimitedHtmlInput(strHTML))
	{	
	
		alert(gsScriptNotAllowed);
		return;
	
	}
	
	if(!ValidateAlertTextInput(strHTML))
	{
		alert(gsScriptNotAllowed);
		return;
	}
	
	gHTMLs[gNotifyTmplSelect] = strHTML 
	document.getElementById("McIdMsg").innerHTML  = strHTML
	top.SetModified(true);
}
function EnableOrDisable(strControl,bForceStatus) // if bForceStatus = true, enable
{
	if (document.getElementById(strControl))
	{		
		if (bForceStatus != undefined)
		{			
			document.getElementById(strControl).disabled = !bForceStatus;			
		}
		var bStatus = (document.getElementById(strControl).disabled == false && document.getElementById(strControl).checked == true );
		document.getElementById(strControl+"Immediate").disabled = !bStatus;
		if ( "idSAFEFAIL" != strControl)
		{
			document.getElementById(strControl+"Daily").disabled = !bStatus;	
		}
		//EnableOrDisableTime();
	}
}

function EnableOrDisableImmediate(strControl,bForceStatus) // if bForceStatus = true, enable
{
	if (document.getElementById(strControl))
	{		
		if (bForceStatus != undefined)
		{			
			document.getElementById(strControl).disabled = !bForceStatus;			
		}
		var bStatus = (document.getElementById(strControl).disabled == false && document.getElementById(strControl).checked == true );
		document.getElementById(strControl+"Immediate").disabled = !bStatus;
	}
}

function IsNotificationDaily(strControl)
{
	if (document.getElementById(strControl))
	{
		return (document.getElementById(strControl).disabled == false && document.getElementById(strControl).checked == true && document.getElementById(strControl+"Daily").checked == true);
	}
}
function EnableOrDisableTime()
{
	var bDisable = false;
	if (document.getElementById("idPHAEnable").checked == true)
	{
		var bDaily = false;
		for(var counter = 0;counter<gAlertControls.length;counter++)
		{
			bDaily = bDaily || IsNotificationDaily(gAlertControls[counter]);
		}
		bDisable = !bDaily;
	}
	else
		bDisable = true;
	document.getElementById('dtHour').disabled = document.getElementById('dtMin').disabled = bDisable;
}
function EnableOrDisableAll()
{
	var bForceStatus = document.getElementById("idPHAEnable").checked;
	for(var counter = 0;counter<gAlertControls.length;counter++)
	{
		EnableOrDisable(gAlertControls[counter],bForceStatus);
	}
	document.getElementById("idePO").disabled = !bForceStatus;
	document.getElementById("idAdministrator").disabled = !bForceStatus;
	EnableOrDisableTime();

	document.getElementById("idPGDBDaily").disabled = true
	document.getElementById("idTransportScanDaily").disabled = true
	document.getElementById("idVirusScanDaily").disabled = true
	document.getElementById("idRPCServDaily").disabled = true
	document.getElementById("idDLLHostDaily").disabled = true
	document.getElementById("idPGReportDaily").disabled = true
	document.getElementById("idPGInitializeDaily").disabled = true
	document.getElementById("idPGStoreDaily").disabled = true
	document.getElementById("idODScanDaily").disabled = true
	document.getElementById("idSAFEFAILDaily").disabled = true
	
	if(!gEPOMode) // Disable only if it is not ePO
	{
		if(GetExVersion() != const_exVersion2003) {
			document.getElementById("idDLLHost").checked = false
			document.getElementById("idDLLHost").disabled = true
			document.getElementById("idDLLHostImmediate").disabled = true
		}
		if((!gbAntiSpamInstalled) || (IsMBInstalled() && (!IsBHInstalled()))) {
			document.getElementById("idASRDown").checked = false
			document.getElementById("idASRDown").disabled = true
			document.getElementById("idASRDownImmediate").disabled = true
			document.getElementById("idASRDownDaily").disabled = true
		}
	}	
	/*
	EnableOrDisable('idDATDown',bForceStatus);
	EnableOrDisable('idEngineDown',bForceStatus);
	EnableOrDisable('idASRDown',bForceStatus);
	EnableOrDisable('idASEDown',bForceStatus);
	*/
    //Disabling VSAPI  in case of Non MB role
	if((GetExVersion() == const_exVersion2013) || (!IsMBInstalled()))
	{
		document.getElementById("idVirusScan").checked = false
		document.getElementById("idVirusScan").disabled = true
		document.getElementById("idVirusScanImmediate").disabled = true
		document.getElementById("idVirusScanDaily").disabled = true
	}

	//Disabling Transport scan if it is not gateway role or if it 
	//hub role
	
	if(GetExVersion() == const_exVersion2003)
	{
		if(!IsBHInstalled())
		{
			document.getElementById("idTransportScan").checked = false
			document.getElementById("idTransportScan").disabled = true
			document.getElementById("idTransportScanImmediate").disabled = true
			document.getElementById("idTransportScanDaily").disabled = true
				
			document.getElementById("idArtemisFAIL").checked = false
			document.getElementById("idArtemisFAIL").disabled = true
			document.getElementById("idArtemisFAILImmediate").disabled = true
			document.getElementById("idArtemisFAILDaily").disabled = true
		}
	}
	else
	{
		if(!IsGWInstalled() && !IsBHInstalled())
		{
			document.getElementById("idTransportScan").checked = false
			document.getElementById("idTransportScan").disabled = true
			document.getElementById("idTransportScanImmediate").disabled = true
			document.getElementById("idTransportScanDaily").disabled = true

			document.getElementById("idArtemisFAIL").checked = false
			document.getElementById("idArtemisFAIL").disabled = true
			document.getElementById("idArtemisFAILImmediate").disabled = true
			document.getElementById("idArtemisFAILDaily").disabled = true
		}
	}	
	//Disable ODScan in case of Gateway or Hub.
	
	if(!IsODEnable())
	{
		document.getElementById("idODScan").checked = false
		document.getElementById("idODScan").disabled = true
		document.getElementById("idODScanImmediate").disabled = true
		document.getElementById("idODScanDaily").disabled = true
	}
}

