//
7// Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//

var timeOutPP = null;
var vfSS = new ValidationFramework("ODScanCredentialSettings_form");
var labelMap = new Object();
var bIsEPO = (typeof(gEPOMode) != "undefined" && gEPOMode)

function Show(pb, pp)
{
	ShowSettings(pb, pp)
}

function Apply(pb, pp)
{
	ApplySettings(pb, pp)
}

////////////////////////////////////////////////
//
// Writes current config settings into controls 
// and then reset modified flag
//
function ShowSettings(pb,pp)
{
	var ppSS = new PropertyPath("systemstate");
	ppSS.SetTempLeaf("oduserid");
	
	var username = parent.gSystemStatePB.GetProperty( ppSS.GetPath() );
	if(username == undefined)
	{
	   username = "MSMEODUser";
	}
	document.getElementById("UserName").value = username;
}

////////////////////////////////////////////////
// 
// Validates values in controls before applying
//
function Validate()
{
	if(document.getElementById("LDAPPassword").value != document.getElementById("LDAPPassword1").value) 
	{
		alert("Password re-entered did not match. Please re-enter the same password.");
		return false;
	}
	
	return true;
}

////////////////////////////////////////////////
//
// Writes all values from controls to config
// source for persistence.
//
function ApplySettings(pb,pp)
{	
	var path = new PropertyPath("Scheduler"); //PropertyPath(pp.GetPath());
	path.Append("ODSettings.UserCredential");

	path.SetTempLeaf("UserName")
	pb.SetProperty(path.GetPath(), document.getElementById("UserName").value);
	
	path.SetTempLeaf("Password")
	pb.SetProperty(path.GetPath(), document.getElementById("LDAPPassword").value);
	
	path.SetTempLeaf("UpdateLDAPPasswordEnabled")
	pb.SetProperty(path.GetPath(), document.getElementById("UpdateLDAPPasswordEnabled").checked);

	//alert("Apply Settings: Path set to Settings.ODSettings.UserCredential \r\nSettings are stored in pb with given pp.");
}

/*
function EnableControls(bEnable)
{	
	document.getElementById("Enabled").disabled = !bEnable
	document.getElementById("PolicyList").disabled = !bEnable
	EnableResumableScan()
}

function EnableResumableScan()
{
	document.getElementById("RestartFromLast").disabled = !document.getElementById("RestartFromLast").disabled
}

function IntialiseDateControl()
{
	// Search times
	var now = new Date()
	now.setMinutes(now.getMinutes()+1)
	var yesterday = new Date()
	yesterday.setTime(yesterday.getTime() - 86400000)
	InitDTControls("fr", yesterday)
	InitDTControls("to", now)
}*/