//Copyright (C) 2005 McAfee, Inc.  All rights reserved.
var gP =new Picker(gOnDemandScanSeperator)
var selector = new Selector("selector")


///////////////////////////////////////////////////////
//
// Show initial settings
//
function Show(pb,pp)
{
	// Show root of picker
	top.hiddenFrame.location.href = GetDynamicPageUrl( "SAFepicker" );
	var path = new PropertyPath(pp.GetPath())

	// Get allExcept value
	path.Append("What.OnDemand")
	path.SetTempLeaf("AllExcept")
	var bAllExcept =  pb.GetProperty(path.GetPath())
	path.SetTempLeaf("")

	// Load scan targets
	path.Append("Target")
	path.BeginEnum()

	while (pb.GetProperty(path.GetPath()) != McUndefined)
	{
		//  workspace
		path.SetTempLeaf("Workspace")
		var workspace = pb.GetProperty(path.GetPath())

		// folder
		path.SetTempLeaf("Folder")
		var folder = pb.GetProperty(path.GetPath())
			
		// subfolders indicator
		path.SetTempLeaf("Recursive")
		var recursive= pb.GetProperty(path.GetPath())
		selector.Add(workspace + gOnDemandScanSeperator + folder, (recursive ? "twostackedclosedfolders.gif" : "closedfolder.gif"))
	
		// Move to next target
		path.SetTempLeaf("")
		path.IncrementEnum()	
	}		

	// Assume scan selected if any targets are present
	EnablePickers(selector.entries.length > 0)
	if (selector.entries.length > 0)
	{
		if (bAllExcept)
		{
			document.getElementById("AllExcept").checked = true
			ScanRadioSelected(true);
		}
		else 	
			document.getElementById("ScanSelected").checked = true
	}
	else
		document.getElementById("ScanAll").checked = true

	
}

///////////////////////////////////////////////////////
//
// Enable/disable picker and buttons
//
function EnablePickers(bEnable)
{
	gP.Enable(bEnable)
	document.getElementById("addrec").disabled = !bEnable
	document.getElementById("add").disabled = !bEnable
	document.getElementById("remove").disabled = !bEnable
	//add pop up text to buttons
	var val = getCookieValue("McDynamic")
	if ( val == "NoIISMoz")
	{
		var btn = document.getElementById("addrec")
		if(bEnable)
		{
			var fnStrShow = "TooltipControl(true,'" + EscapeForJS(gsAddFolderTree) + "');";
			var fnStrVanish = "TooltipControl(false,'" + EscapeForJS(gsAddFolderTree) + "');";
			btn.onmouseover = new Function(fnStrShow);
			btn.onmouseout =  new Function(fnStrVanish);
		}
		btn = document.getElementById("add")
		if(bEnable)
		{
			var fnStrShow = "TooltipControl(true,'" + EscapeForJS(gsAddFolder) + "');";
			var fnStrVanish = "TooltipControl(false,'" + EscapeForJS(gsAddFolder) + "');";
			btn.onmouseover = new Function(fnStrShow);
			btn.onmouseout =  new Function(fnStrVanish);
		}
		btn = document.getElementById("remove")
		if(bEnable)
		{
			var fnStrShow = "TooltipControl(true,'" + EscapeForJS(gsRemoveFolder)+ "');";
			var fnStrVanish = "TooltipControl(false,'" + EscapeForJS(gsRemoveFolder) + "');";
			btn.onmouseover = new Function(fnStrShow);
			btn.onmouseout =  new Function(fnStrVanish);
		}
	}
	else
	{
		var btn = document.getElementById("addrec")
		btn.title = bEnable ? gsAddFolderTree : ""
		btn = document.getElementById("add")
		btn.title = bEnable ? gsAddFolder : ""
		btn = document.getElementById("remove")
		btn.title = bEnable ? gsRemoveFolder : ""
	}
	GreyUngrey("picker", !bEnable)
	GreyUngrey("selector", !bEnable)
}

///////////////////////////////////////////////////////
//
// Validate selections
//
function Validate()
{
	// Most validation happens on the fly on this page

	//make sure we have not chosen scan selected but selected nothing
		if ( document.getElementById("ScanSelected").checked == true || document.getElementById("AllExcept").checked == true ) 
	{
		if(selector.entries.length == 0)
		{
			alert(gsScanNoFoldersSelected)
			return false
		}
			
	}
	
	return true		
}

///////////////////////////////////////////////////////
//
// Store selections in wizard property bag
//
function Apply(pb,pp)
{
	// Set basic settings
	var path = new PropertyPath(pp.GetPath())

	path.SetTempLeaf("")
	//add the 'OnDemand.Target' property
	path.Append("What.OnDemand.Target")
	pb.DeleteList(path)

	path = new PropertyPath(pp.GetPath())
	path.SetTempLeaf("")
	//add the 'OnDemand' property
	path.Append("What.OnDemand")


	pb.SetProperty(path.GetPath())
	
	// Set "AllExcepted" flag if scanning all except selected folders
	if (document.getElementById("AllExcept").checked)
	{
		path.SetTempLeaf("AllExcept")
		pb.SetProperty(path.GetPath(), true)
		path.SetTempLeaf("")
	}

	// Find out whether ScanAll or ScanSelected is selected, if AllExcept exists then assign it to false
	if (!document.getElementById("AllExcept").checked)
	{
		path.SetTempLeaf("AllExcept")
		var bAllExcept =  pb.GetProperty(path.GetPath())
		if(bAllExcept !=McUndefined)
		{
			pb.SetProperty(path.GetPath(), false)
		}
		path.SetTempLeaf("")
	}

	// Iterate through folder selections, if we are not scanning all
	path.Append("Target")	
	if (!document.getElementById("ScanAll").checked)
	{
		path.BeginEnum()
	
		for (var i= 0; i < selector.entries.length;i++)
		{
			// Add root
			pb.SetProperty(path.GetPath())

			// Add workspace
			path.SetTempLeaf("Workspace")
			pb.SetProperty(path.GetPath(), selector.entries[i].path.substr(0, selector.entries[i].path.indexOf(gOnDemandScanSeperator)))
		
			// Add folder
			path.SetTempLeaf("Folder")
			pb.SetProperty(path.GetPath(), selector.entries[i].path.substr(selector.entries[i].path.indexOf(gOnDemandScanSeperator)+1))

			// Add subfolders indicator
			path.SetTempLeaf("Recursive")
			pb.SetProperty(path.GetPath(), selector.entries[i].icon != "closedfolder.gif")


			// Carry on to next folder
			path.SetTempLeaf("")
			path.IncrementEnum()
		}
	}

	// Set task type
	pp.SetTempLeaf("What")
	pb.SetProperty(pp) 
	pp.SetTempLeaf("Type")
	pb.SetProperty(pp,"ScanTask")
	pp.SetTempLeaf("")


}

/////////////////////////////////////////////
//
// Adds folder current selected in picker
//
function AddSelectedFolder(icon)
{
	var bAdd = false;
	if (gP.selected == McUndefined)
	{
		alert(gsSelectFolderToAdd)
		return
	}
	//selector.Add(gP.GetPath(),icon)
	for (var sel in gP.selected)
	{
		for (var i= 0; i < selector.entries.length;i++)
		{
			if (selector.entries[i].path == gP.GetPath(gP.selected[sel]))
			{
				alert(gsFolderExists);
				return;
			}		
		}
	}
	for (var sel in gP.selected)
	{
		var path=gP.GetPath(gP.selected[sel]);
		selector.Add(gP.GetPath(gP.selected[sel]),icon);
		bAdd = true;
	}

	if(bAdd == false)
		alert(gsSelectFolderToAdd)
}

/////////////////////////////////////////////
//
// Deletes item currently selected in selector
//
function RemoveSelectedFolder()
{
	if (selector.FirstSelection()<0)
	{
		alert(gsSelectFolderToRemove)
		return
	}	
        selector.RemoveSelection()
}

function ScanRadioSelected(bExcept)
{
	var picker2Title = document.getElementById("picker2Title")
	if(bExcept)
		picker2Title.innerHTML = gsScanExcept
	else
		picker2Title.innerHTML = gsScanSelected
	
	EnablePickers(true)	
}