
/**
 * Description: Page definitions for the SME
 *
 * Copyright (C) 2005 McAfee, Inc. All rights reserved.
 */

	
new Page("dashboard", gsTDashboard, "Dashboard.html", "", "", "","");
new Page("statsinfo", gsTStats, "Dashboard.html", "dashboard", "Scheduler", "","");
new Page("odsettings", gsTODScans, "TaskStatus.html?ScanTask", "dashboard", "Scheduler", "","");
new Page("odreportsettings", gsTaskEntryScheduleStatus, "TaskStatus.html?StatusReportTask", "dashboard", "Scheduler", "","");
new Page("configreportsettings", gsTaskEntryScheduleConfig, "TaskStatus.html?ReportTask", "dashboard", "Scheduler", "","");
new Page("graphs", gsTReports, "GraphicalReports.html", "dashboard", "", "","");

	
new Page("quarantined", gsTDetectedItems, "ResultsTable.html?spam", "", "", "","");
new Page("spam", gsTSpam, "ResultsTable.html?spam", "quarantined", "", "","");
new Page("ip", gsTIP, "ResultsTable.html?ip", "quarantined", "", "","");
new Page("phish", gsTPhish, "ResultsTable.html?phish", "quarantined", "", "","");
new Page("virus", gsTViruses, "ResultsTable.html?virus", "quarantined", "", "","");
new Page("tie_atd", gsTTIEATD, "ResultsTable.html?tie_atd", "quarantined", "", "", "");
new Page("spoof", gsTSPOOF, "ResultsTable.html?spoof", "quarantined", "", "", "");
new Page("pup", gsTPups, "ResultsTable.html?pup", "quarantined", "", "","");
new Page("unwantedcontent", gsTContent, "ResultsTable.html?unwantedcontent", "quarantined", "", "","");
new Page("bannedfile", gsTBannedFile, "ResultsTable.html?bannedfile", "quarantined", "", "","");
new Page("content", gsTCompnDLP, "ResultsTable.html?content", "quarantined", "", "","");
new Page("url", gsTURL, "ResultsTable.html?url", "quarantined", "", "","");
new Page("allitems", gsTAll, "ResultsTable.html?allitems", "quarantined", "", "","");

	
new Page("policy_manager", gsTPolicyManager, "PolicySetPageOA.html", "", "", "","yes");
new Page("policy_on_access", gsTOnAccess, "PolicySetPageOA.html", "policy_manager", "Policies", "","");
new Page("policy_od_default", gsTODDefault, "PolicySetPageOD.html", "policy_manager", "Policies", "","");
new Page("policy_od_findviruses", gsTODFindViruses , "PolicySetPageODFAV.html", "policy_manager", "Policies", "","");
new Page("policy_od_removeviruses", gsTODRemoveViruses , "PolicySetPageODRAV.html", "policy_manager", "Policies", "","");
new Page("policy_od_find_bannedcontent", gsTODFindBannedContent , "PolicySetPageODFBC.html", "policy_manager", "Policies", "","");
new Page("policy_od_remove_bannedcontent", gsTODRemoveBannedContent , "PolicySetPageODRBC.html", "policy_manager", "Policies", "","");
new Page("policy_od_fullscan", gsTODFullScan , "PolicySetPageODFS.html", "policy_manager", "Policies", "","");
//new Page("policy_outbreakmanager", gsTOutbreakManager , "PolicySetPageOBM.html", "policy_manager", "Policies", "","");
new Page("policy_gateway", gsTGateway , "PolicySetPageGW.html", "policy_manager", "Policies", "","");


new Page("settings_list", gsTShared, "Settings.html", "policy_manager", "Settings", "","");
new Page("settings_and_diagnostics", gsTSettings, "onaccessPage.htm", "", "", "","");
new Page("oasettings", gsTOASettings, "onaccessPage.htm", "settings_and_diagnostics", "VSAPI2", "","");
new Page("odscansettings", gsTODSettings, "ODScanCredentialSettings.html", "settings_and_diagnostics", "Scheduler", "","");
new Page("mbexclusionpage", gsTMBExclusionSettings, "MBExclusionPage.html", "settings_and_diagnostics", "VSAPI2Excl", "","");
new Page("notificationsettigns", gsTNotifications, "NotificationsPage.htm", "settings_and_diagnostics", "Notifications", "","");
new Page("antispamsettigns", gsMISpam, "SpamOrganizationRouting.htm", "settings_and_diagnostics", "", "","");
new Page("tiesettings", gsMITIE, "TIESettings.htm", "settings_and_diagnostics", "", "","");
new Page("databasemanagement", gsTDISettings, "DatabaseManagement.html", "settings_and_diagnostics", "Repository", "","");
new Page("uiprefs", gsTUIPeferences, "UIPreferences.html", "settings_and_diagnostics", "", "","");
new Page("diagnostics", gsTDiagnostics, "Diagnostics.html", "settings_and_diagnostics", "", "","");
new Page("productlog", gsTProductLog, "ResultsTable.html?productlog", "settings_and_diagnostics", "", "","");
new Page("DATSettings", gsTDATSettings, "DATSettings.html", "settings_and_diagnostics", "", "","");
new Page("exportimport", gsTImportExport, "ImportExport.html", "settings_and_diagnostics", "", "","");
new Page("ProxySettings", gsTProxySettings, "ProxySettings.html", "settings_and_diagnostics", "", "","");

