// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
//
//====================================================================================
// Const and Flags
//=====================================================================================


//values meaningful for backend
var score_values = {High:"15", Med:"10" , Low:"5" , Custom:"15"} ;
var t_labels = ["High","Med","Low"];
var K_NEVER = "Never"
var K_CUSTOM = "Custom"

//====================================================================================
// Draw and data management
//=====================================================================================

function PolSetting_AS_DrawOpt_Threshold(pp, div)
{
var pb = options_pb;
var dhtml = "";
var t_values=[];

	//pp.SetTempLeaf("ScoreLevel");
	//var level = pb.GetProperty(pp);
	//pp.SetTempLeaf("SpamThreshold");
	//score_values[K_CUSTOM]= pb.GetProperty(pp);
	//dhtml+=resolveString(cse_pp_st, level) + "(" + score_values[level] + ")"

	for (var i=0;i<t_labels.length ; i++ )
    {
       pp.SetTempLeaf("ScoreBasedActionValue"+(i+1));
	   t_values[i]= pb.GetProperty(pp);
    }
    top.polctx.polSetting["t_values"] = t_values;

	pp.SetTempLeaf("SpamThreshold");
	t_values[t_labels.length]= pb.GetProperty(pp);
	pp.SetTempLeaf("");

	dhtml += resolveString ( cse_pp_st, "ACT_AS_Thresholds", t_values );
    PolSetting_TxtWrite("opt_div_threshold", dhtml);
}

function PolSetting_AS_DrawOpt_Prefix(pp, div)
{
var pb = options_pb;
var dhtml = "";

	pp.SetTempLeaf("PrefixSubject");
	var do_it = pb.GetProperty(pp);
	pp.SetTempLeaf("PrefixSubjectText");
	var prop = pb.GetProperty(pp);

    if (do_it==1)
    {  dhtml += prop;
	   PolSetting_TxtWrite("opt_div_prefix", dhtml);
    }
	else PolSetting_DhtmlHide("opt_tr_prefix");

}

function PolSetting_AS_DrawOpt_Indicator(pp)
{
var pb = options_pb;
var dhtml="";

	pp.SetTempLeaf("SpamIndicator");
	var do_it = pb.GetProperty(pp);

	if (do_it != K_NEVER )
	{	dhtml += resolveString(cse_pp_st ,do_it);
		PolSetting_TxtWrite("opt_div_indicator", dhtml);
    }
	else PolSetting_DhtmlHide("opt_tr_indicator");
}

function PolSetting_AS_DrawOpt_Report(pp)
{
var dhtml="";
var pb = options_pb;
	pp.SetTempLeaf("AttachReport");
	var do_it = pb.GetProperty(pp);
	pp.SetTempLeaf("VerboseLogging");
	var verbose = pb.GetProperty(pp);

	if (do_it != K_NEVER)
    {   if (verbose==1) dhtml += resolveString(cse_pp_st , "OPT_VERBOSE") + " "
		dhtml += resolveString(cse_pp_st ,do_it);
		PolSetting_TxtWrite("opt_div_report", dhtml);
    }
	else PolSetting_DhtmlHide("opt_tr_report");
}

function PolSetting_AS_DrawOpt_BWLists(pp)
{
var dhtml="";
var pb = options_pb;
var regexStr;
var pattern
var res;
var lst=[ {key:"BlackListFrom", val:"0"},{key:"BlackListTo", val:"0"}, {key:"WhiteListFrom", val:"0"}, {key:"WhiteListTo", val:"0"}]

pp.SetTempLeaf("");

for(var i=0;i<lst.length;i++)
{
   regexStr='^' + pp.GetPath() + "\\." + lst[i].key +"\\.(\\w+)"
   pattern=new RegExp(regexStr);
   res=pb.GetMatchingPaths(pattern);
   if (res) lst[i].val=res.length;
}
dhtml+=resolveString(cse_pp_st, "OPT_BLST", [lst[0].val, lst[1].val]);
dhtml+="<BR>"
dhtml+=resolveString(cse_pp_st, "OPT_WLST", [lst[2].val, lst[3].val]);

PolSetting_DhtmlWrite("opt_div_bwlists", dhtml);
}

//param is the path to the settings
function PolSetting_AS_DrawOptions()
{
  var ppT = PolSetting_GetOptionsPath("AS", "OPTIONSLST_DIV")

  PolSetting_AS_DrawOpt_Threshold (ppT);
  PolSetting_AS_DrawOpt_Prefix (ppT);
  PolSetting_AS_DrawOpt_Indicator(ppT);
  PolSetting_AS_DrawOpt_Report (ppT);
  PolSetting_AS_DrawOpt_BWLists(ppT)
}

//draw the actions in place in the page _ assumes the div are present
// pb:property bag to read from
// pp:path to the actual setting
function PolSetting_AS_DrawActions()
{
  var ppT=PolSetting_GetPPNode("");
  var pb=PolSetting_GetPb();

  var act_obj= new PolicyAction (pb, ppT, false);
  var action_index =  new Array(t_labels.length);

  for( var i=0; i<t_labels.length; i++ )
  {
	 j = i+1;
	 action_index[i] = act_obj.BuildTable("Action"+j, i, "AS")
  }
  //build dhtml
  var dhtml="";

  dhtml= '<table border="0" cellpadding="0" cellspacing="0"  class="dataSubTable" width="100%">'
  dhtml += '<tr class="header">'
  dhtml += '<td class="dst" style="width:50%"><span class="bold">' + resolveString(cse_pp_st , "ACTTITLE_AS") + '</span></td>'
  dhtml += '<td class="dst eor noLeft" align=right> <A href="javascript:PolSettings_Actions(\'AS\')" class=BlueLink id="ACTIONS_LNK">' + resolveString(cse_pp_st, "__edit") + '</a> </td>'
  dhtml += '</tr>'

  for (var i=0;i<t_labels.length; i++ )
  {
	  if(action_index[i] == -1)
		  continue;
	  var sk="ACT_AS_Action";
	  var param = " ";

	  //ppT.SetTempLeaf("ScoreBasedActionLevel"+(i+1));
	  //level = pb.GetProperty(ppT);
      //ppT.SetTempLeaf("ScoreBasedActionValue"+(i+1));
	  //score_values[K_CUSTOM]= pb.GetProperty(ppT);

	  param += resolveString ( cse_pp_st, t_labels[i] );


	  var cl="";
	  if( IsLastRow(i, action_index) )
		  cl = 'class="row1 lastRow"';
	  else
		  cl = 'class="row1"';

	  dhtml += '<tr ' + cl + ' > <td  class="dst">'
	  dhtml += resolveString(cse_pp_st, sk, [param]);
	  dhtml +='</td><td class="dst eor ">'
	  dhtml += act_obj.GetVal(i)
	  dhtml +='</td></tr>'
  }

  dhtml += '</table><BR>'

  //dhtml output
  var div = document.getElementById("act_div");
  if (div) {
  div.innerHTML = dhtml;
  }
}
//================================================================
// This function determines if 'itr' is the index for the last row
//================================================================
function IsLastRow(itr, action_index)
{
	var result = true;
	for( j=itr+1; j<action_index.length; j++ )
	{
		if(action_index[j] != -1)
		{
			result = false;
			break;
		}
	}
	return result
}

//=========================================================
// Functions called when user interact with controls
//=========================================================

//call create option page or refresh current page
function PolSetting_AS_SelectFromOptions(the_combo)
{
    if (PolSetting_OnOptionsSel(the_combo, "AS"))
	{
		PolSetting_AS_DrawOptions();
	}
}

//inherit checkbox onclick
function OnclickInherit(val)
{  	PolSetting_SetModify();
	PolSetting_SetOptionsSel("AS")
    PolSetting_AS_DrawActions();
    PolSetting_AS_DrawOptions();
	PolSetting_CheckInherit();
}

//=========================================================
// Mandatory Functions
//=========================================================

/**
 * Asynchronous data load function
 */
function Show(pbIn, null_pp) {

    PolSetting_Show(pbIn);
	PolSetting_AS_DrawActions();
    PolSetting_DrawOptionsCombo("AS", "OPTIONSLST_DIV");
	PolSetting_AS_DrawOptions();
	PolSetting_CheckInherit();

}


/**
 * Asynchronous data validation function
 */
function Cancel() {
	PolSetting_Draw();
	PolSetting_AS_DrawActions();
    PolSetting_DrawOptionsCombo("AS", "OPTIONSLST_DIV");
	PolSetting_AS_DrawOptions();
	PolSetting_CheckInherit();
    top.gPageStack.Active().SetModified(false);
}

/**
 * Asynchronous data validation function
 */
function Validate() {
    var ok = true;

    return ok;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pb,pp,save) {

    PolSetting_Apply("AS", false);
	if (!save)
		return top.gPageStack.Active().pb
}


