/**
 * JavaScript for the Settings page
 *
 * Copyright (C) 2009 McAfee, Inc. All rights reserved
 */

var s_pb = null;

function Show(pbIn) {
    s_pb = pbIn;
    var otherNodes = ["FileRules", "Alerts"];
    for (var i = 0; i < otherNodes.length; i++) {
        var prop = otherNodes[i];
        if (null == s_pb.GetProperty(prop)) {
            top.gPB.GetElement(prop, s_pb);
        }
    }

    try {
        // No longer in the policy settings area
        if (null != top.polctx) {
            top.polctx = {};
        }
    }
    catch(e) {
    }

    try {
        // Show the scanner configurations
        scanners_Show(s_pb);
    }
    catch(e) {
    }

    try {
        // Show the file filtering rules
        ffr_Show(s_pb);
    }
    catch(e) {
    }

    try {
        // Show the content Scanner rules
        CSRLists_Show(s_pb);
    }
    catch(e) {
    }

    try {
        // Show the Time Restrictions
        TimeList_Show(s_pb);
    }
    catch(e) {
    }

    try {
        // Show the alerts
        alerts_Show(s_pb);
    }
    catch(e) {
    }

    // Reveal the page in its majesty
    window.status = "";
    var div = document.getElementById("notification_area");
    if (div)
        div.style.display = "none";
    div = document.getElementById("whole_page");
    if (div)
        div.style.display = "block";
}

function Validate() {
    return true;
}

function Apply() {
    TimeList_Apply(s_pb);
    return s_pb;
}

/**
 * Callback function to list required configuration data
 */
function GetCustomConfigReq() {
	return ["CSRules", "DefaultAlerts"];
}

