// Copyright (C) 2009 McAfee, Inc.  All rights reserved.
// Edit One CS rule
// (lists all conditions)
//
//====================================================================================
// Const, globals and Flags
//=====================================================================================

var qparams = queryParameters();
var page_vf;
var dataBindings = new Array();
var gTimeRestriction;

var gSettings;

// data structure to store info
// @this.pb local propertybag, cloned from pbIn
// @this.pp_str path to this rule



function page_init()
{
      try
      {  top.gPageStack.OnLoad()
      }
      catch(e)
	  {  alert(e.message);
      }
}


/**
 * Asynchronous data load function
 */
// ppIn is the path to the rule itself.
// pbIn is the current propert bag, to be merged with top pb if needed
function Show(pbIn, ppIn)
{
    var f = document.forms["TIME_FORM"];

   	page_vf = new ValidationFramework("TIME_FORM");
	page_vf.formAction = std_val_form_action;
	gTimeRestriction = new TimeRestriction(pbIn);	
	gTimeRestriction.Init(f, page_vf, 1);
	var inputVtor = new InputTextValidator(true);
	page_vf.addValidator("time_name", inputVtor);
	page_vf.fieldAction = std_val_field_action;


    var pp_str="";

    if ("string" == typeof(ppIn))
    {   pp_str = ppIn;
    }
    else
    {   pp_str = ppIn.GetPath();
    }

    gTimeRestriction.SetFormValues(f, pp_str);

}

/**
 * Asynchronous data validation function
 */
function Validate() {
    var f = document.forms["TIME_FORM"];
    gTimeRestriction.BuildTimeStrings(f);
	if ( page_vf.onsubmit() )
	{   return true;
    }
    return false;
}

/**
 * Asynchronous data save function
 * @param pb the property bag to fill
 */
function Apply(pbOut,pp_null,s_null)
{
    var f = document.forms["TIME_FORM"];
    var pp_str=gTimeRestriction.pp_str;

    gTimeRestriction.BuildTimeStrings(f);
    gTimeRestriction.SaveTimeSlot(pbOut, pp_str);
    return pbOut;
}

