// Copyright (C) 2009 McAfee, Inc.  All rights reserved.

function Show()
{
	// Load query
	gUIPlugin = "UIRepository"
	gQueryTable=document.getElementById("resultsTable")
	gFilterRoot = "((rsn=\"pa\" OR rsn=\"ec\" OR rsn=\"enc\" OR rsn=\"sig\" OR rsn=\"cor\" OR rsn=\"dos\" OR rsn=\"procnt\" OR rsn=\"pwdpro\" OR rsn=\"blockmime\" OR rsn=\"other\") AND trs!=8 AND trs!=10)"

	QueryShow(strQtinedContent,new Array(strReleaseToOwner,strDownload,strExport,strForward,strView),"ManagingAllItemsHelp")


	// Disable the release to owner and download buttons
	document.getElementById( "action0" ).disabled = true;
	document.getElementById( "action1" ).disabled = true;
	document.getElementById( "action3" ).disabled = true;
	document.getElementById( "action4" ).disabled = true;
}

///////////////////////////////////////////////////////////////////////////
//
// Carry out an action
//
function Action(op)
{

	var str = ""
	switch (op)
	{

		case 0: // Release
			str = "UIRepository"+"&t=7"
			str = JoinFilters(str, QueryId())
			str = JoinFilters(str, QueryRecordsToDisplay())
			str = JoinFilters(str, QuerySelectedRecords())
			str = PSGetFilterValues(str)
		break

		case 1: // Download
			str = "UIRepository"+"&t=1"
			str = JoinFilters(str, QueryId())
			str = JoinFilters(str, QueryRecordsToDisplay())
			str = JoinFilters(str, QuerySelectedRecords())
			str = PSGetFilterValues(str)
			str = JoinFilters(str, "n=" + QuerySelectedFileName("eml"))
		break

		case 2: // Export to CSV
			str = "UIRepository"+"&t=4"
			str = JoinFilters(str, QueryId())
			str = JoinFilters(str, QueryRecordsToDisplay(true))
			str = JoinFilters(str, QuerySelectedRecords())
			str = PSGetFilterValues(str);
		break
		case 3: // Forward
			ForwardQuarantinedItem();
		break;

		case 4: // View
			if (QueryNoSelectedRecords() != 1)
			{
				alert(strOneRow);
				return;
			}
			ViewQuarantinedItem();
		break
	}

	if (str != "")
	{
		parent.hiddenFrame.location.href = GetDynamicPageUrl(str)
	}
}

function OnMcGridClicked(selectionArray)
{
	var bQtined = true;
	if ( selectionArray.length == 0 )
	{
		bQtined = false;
	}
	for (var i=0;i<selectionArray.length;i++)
	{
		var nRecNum = parseInt(selectionArray[i],10);
		var qtn = gQueryRecords[nRecNum][gVisibleCols.length];
		bQtined = bQtined && qtn && qtn==1;
	}
	document.getElementById( "action0" ).disabled = !bQtined;
	document.getElementById( "action1" ).disabled = !(bQtined && selectionArray.length ==1);
	document.getElementById( "action3" ).disabled = !(bQtined && selectionArray.length ==1);
	document.getElementById( "action4" ).disabled = !(bQtined && selectionArray.length ==1);
}

function OnSetRowIcon(row)
{
	var iconInfo;
	var nRecNum = parseInt(row,10);
	var qtn = gQueryRecords[nRecNum][gVisibleCols.length];
	if( qtn && qtn == 1 )
	{
		iconInfo = new Array();
		iconInfo["filename"] = "../../images/icons/qtndata.gif";
		iconInfo["alttext"] = strQuarantinedDataAlt;
	}
	else
	{
		iconInfo = new Array();
		iconInfo["filename"] = "../../images/icons/noqtndata.gif";
		iconInfo["alttext"] = strNoQuarantinedDataAlt;
	}

	return(iconInfo);
}
