//
// Copyright (C) 2005 McAfee, Inc.  All rights reserved.
//
var gIsePO35 = false
var vfOnAccess		= new ValidationFramework("odreportsettings_form");

function ConfigurationReportTaskPage()
{
	// Initialize member functions
	this.Show = Show
	this.Validate = Validate
	this.Apply = Apply
	this.EnableDisable = EnableDisable
	this.InheritUninherit = InheritUninherit

	// Initialize member data
	this.bEnabled = true
}

////////////////////////////////////////////////
//
// Enables or disables all controls on the page
//
function EnableDisable(bEnable)
{
	EnableControl("McNameRecipient", bEnable)
	EnableControl("McNameSubjectLine", bEnable)
}

function InheritUninherit()
{
	EnableDisable(!document.getElementById("inherit").checked)
}

////////////////////////////////////////////////
//
// Writes current config settings into controls 
function Show()
{

		// Load current settings
	var ps = new PropertySource(true)
	var pb = new PropertyBag()
	ps.Get(pb, new Array("ePOTask"))
	var pp = new PropertyPath("ePOTask")
	pp.Append("What.Report")

	// Set all the report settings from DB
	// Set Recipient
	pp.SetTempLeaf("Recipient")
	document.getElementById("McIdRecipient").value = pb.GetProperty(pp.GetPath())
	pp.SetTempLeaf("")

	// Set subject	
	pp.SetTempLeaf("Subject")
	document.getElementById("McIdSubjectLine").value = pb.GetProperty(pp.GetPath())
	pp.SetTempLeaf("")
		
	// Apply inherit state
	var bInherit = window.external.schedule_value_bool("ePOTask", "Inherit")
	document.getElementById("inherit").checked = bInherit
	EnableDisable(!bInherit)
}

////////////////////////////////////////////////
// 
// Validates values in controls before applying
//
function Validate()
{
	// Return false if any controls contain values which are invalid
	var recipient = document.getElementById("McIdRecipient").value
	var rx1 = /^.+\@.+\..+/

	if(recipient == "" || !recipient.match(rx1) )
	{
		alert(gsInvalidEmail)
		document.getElementById("McIdRecipient").focus()
		return false
	}

	var subject = document.getElementById("McIdSubjectLine").value
	if(subject == "")
	{
		alert(gsEnterSubject)
		document.getElementById("McIdSubjectLine").focus()
		return false
	}
	
	var numRows = toInteger(document.getElementById("McidNumRows").value)
	if( numRows <=0 || numRows > 365 )
	{
		var invalidNumRows = formatString(strRange, new Array(1,365));
		var errmsg = vfr_st["bad_form_one_error"]+ "\n" + "- " + gsErrNumDays + ": " + invalidNumRows + "\n" + vfr_st["one_error_resubmit"]; 
		document.getElementById("McidNumRows").focus()
		alert ( errmsg );
		return false; //num of rows invalid.	     
	}

	// Return success
	return true
}

////////////////////////////////////////////////
//
// Writes all values from controls to config
// source for persistence.
//
function Apply()
{
	// Set basic settings	
	var path = new PropertyPath("ePOTask")
	var pb = new PropertyBag()

	// Set task type
	pb.SetProperty(path)
	path.SetTempLeaf("What")
	pb.SetProperty(path) 
	path.SetTempLeaf("Type")
	pb.SetProperty(path,"ReportTask")
	path.SetTempLeaf("What.Report")
	pb.SetProperty(path)
	path.SetTempLeaf("Name")
	pb.SetProperty(path,"ConfigurationReport Task")
	path.SetTempLeaf("")

	path.Append("What.Report")

	// Set recipient
	var recipient = document.getElementById("McIdRecipient").value
	path.SetTempLeaf("Recipient")
	pb.SetProperty(path.GetPath(), recipient)
	path.SetTempLeaf("")
	// Set subject
	var subject = document.getElementById("McIdSubjectLine").value
	path.SetTempLeaf("Subject")
	pb.SetProperty(path.GetPath(), subject)
	path.SetTempLeaf("")

	var ps = new PropertySource(true)
	ps.Put(pb,document.getElementById("inherit").checked)
}